c this file is written by Thi Nhung Dao on 09/02/2015 
c the full one-loop correction to the H(i)->H(j)+H(k) decays
c input: mass eigenstates i,j,k
c        mass(H(i))**2 =m12, Mass(H(j))**2=m22, Mass(H(k))**2= m32
c        tree-level: iloop=1, 1-loop: iloop=2, 2-loop: iloop=3
c output:  ampsq  <->  amplitude squared
c last modified 21/07/2022 by Thi Nhung Dao

      subroutine HHHTL_calc()
      implicit none   
      double precision dMW2,dMZ2,dZe,dMHpm2,dthd,dthu,dths,dtad,dtas,
     &      dL3HM(6,6,6),OLHHH(6,6,6),reHHHQCD(6,6,6),reHHHATAT(6,6,6)
      double complex resAG(6,6,6)
      common /HHHTL/dMW2,dMZ2,dZe,dMHpm2,dthd,dthu,dths,dtad,dtas,
     &                 dL3HM,OLHHH,reHHHQCD,reHHHATAT,resAG
      call Counterterms(dMW2,dMZ2,dZe,dMHpm2,dthd,dthu,dths,dtad,dtas)
      call dLHHH(dMW2,dMZ2,dZe,dMHpm2,dthd,dthu,dths,dtad,dtas
     $        ,dL3HM,resAG)
      call ReHHH_at(OLHHH) 
      call ReHHH_QCD(reHHHQCD)
      call ReHHH_atat(reHHHATAT)    
      end

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      
      
      subroutine recoupHHH(i,j,k,m12,m22,m32,ampsq,iloop,CPcon)
      implicit none    
      integer i,j,k,iloop,i1,j1,k1
      integer imax,imin,jmax,jmin,kmax,kmin
      common/CPindexrange/imax,imin,jmax,jmin,kmax,kmin
      double precision m12,m22,m32,ampsq
      double precision reHHHQCD_o(6,6,6),reHHHATAT_o(6,6,6)
      double precision dLGACT(6,6,6),ZHN(5,5)
      double precision ZH5(5,5),ZH(6,6) 
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU            
      double complex  ChHpWmA(6,2),ChHmWpA(2,6),ChHpWmZ(6,2),
     &                ChHmWpZ(2,6),ChhWmWp(6,6),ChhAZ(6,6),ChhZZ(6,6),
     &                ChHpWm(6,2),ChHmWp(2,6),ChhZ(6,6),ChWmWp(6),
     &                ChZZ(6),ChSdmSdp(6,6,6),ChSemSep(6,6,6),
     &                ChSupSum(6,6,6),ChSvSvconj(6),ChHmHp(2,2,6),
     &                ChhSemSep(6,6,6,6),ChhSvSvconj(6,6),
     &                ChhHmHp(2,6,2,6),ChhSupSum(6,6,6,6),
     &                ChhSdmSdp(6,6,6,6),CLhChapCham(2,2,6),
     &                CRhChapCham(2,2,6),CLhFepFem(3,3,6),
     &                CRhFepFem(3,3,6),CLhFdpFdm(3,3,6),
     &                CRhFdpFdm(3,3,6),CLhFumFup(3,3,6),
     &                CRhFumFup(3,3,6),ChU3U3(6),ChU2U2(6),ChU4U4(6),
     &                Chhh(6,6,6),Chhhh(6,6,6,6),CLhChiChi(5,5,6),
     &                CRhChiChi(5,5,6),CHmHpSvSv(3,2,3,2),
     &                CHmHpSdmSdp(6,2,6,2),CHmHpSupSum(6,2,6,2),
     &                CHmHpSemSep(6,2,6,2),CHmSepSv(3,6,2),
     &                CHpSemSv(6,3,2),CHmSupSdp(6,6,2),
     &                CHpSumSdm(6,6,2),CLHpChiCha(5,2,2),
     &                CRHpChiCha(5,2,2),CLHmChiCha(2,5,2),
     &                CRHmChiCha(2,5,2)
     

      common /coupl/ ChHpWmA,ChHmWpA,ChHpWmZ,ChHmWpZ,ChhWmWp,
     &               ChhAZ,ChhZZ,ChHpWm,ChHmWp,ChhZ,ChWmWp,ChZZ,
     &               ChSdmSdp,ChSemSep,ChSupSum,ChSvSvconj,ChHmHp,
     &               ChhSemSep,ChhSvSvconj,ChhHmHp,ChhSupSum,ChhSdmSdp,
     &               CLhChapCham,CRhChapCham,CLhFepFem,CRhFepFem,
     &               CLhFdpFdm,CRhFdpFdm,CLhFumFup,CRhFumFup,ChU3U3,
     &               ChU2U2,ChU4U4,Chhh,Chhhh,CLhChiChi,CRhChiChi,
     &               CHmHpSvSv,CHmHpSdmSdp,CHmHpSupSum,CHmHpSemSep,
     &               CHmSepSv,CHpSemSv,CHmSupSdp,CHpSumSdm,CRHpChiCha,
     &               CLHpChiCha,CRHmChiCha,CLHmChiCha
      logical CPcon
      double complex res(6,6,6),amp
      double precision dMW2,dMZ2,dZe,dMHpm2,dthd,dthu,dths,dtad,dtas,
     &      dL3HM(6,6,6),OLHHH(6,6,6),reHHHQCD(6,6,6),reHHHATAT(6,6,6)
      double complex resAG(6,6,6)
      common /HHHTL/dMW2,dMZ2,dZe,dMHpm2,dthd,dthu,dths,dtad,dtas,
     &                 dL3HM,OLHHH,reHHHQCD,reHHHATAT,resAG
      double complex Zfac(5,5)      
      common /Zfactor/ Zfac
      ZHN=ZH(2:6,2:6)
      if (CPcon)then
        if(i.lt.3) then 
          imin=1; imax=2
        else
          imin=3; imax=5
        endif 
        if(j.lt.3) then 
          jmin=1; jmax=2
        else
          jmin=3; jmax=5
        endif 
        if(k.lt.3) then 
          kmin=1; kmax=2
        else
          kmin=3; kmax=5
        endif 
      else
      imin=1;jmin=1;kmin=1
      imax=5;jmax=5;kmax=5
      endif
      if(iloop.eq.0) then
         amp=0D0
         do i1=imin,imax
            do j1=jmin,jmax
               do k1=kmin,kmax
                  amp=amp+ Zfac(i,i1)*Zfac(j,j1)*Zfac(k,k1)* ((0,-1)
     $                 *Chhh(i1+1,j1+1,k1+1))
               enddo
            enddo
         enddo
      else
         call UrecoupHHH(m12,m22,m32,res)       
      if (iloop.eq.1) then
         amp=0D0
         do i1=imin,imax
            do j1=jmin,jmax
               do k1=kmin,kmax
                     amp=amp+ Zfac(i,i1)*Zfac(j,j1)*Zfac(k,k1)*((0,-1)
     $                    *Chhh(i1+1,j1+1,k1+1)+ res(i1+1,j1 +1,k1+1)
     $                    -dL3HM(i1+1,j1+1,k1+1)) 
               enddo
            enddo
         enddo
         amp=amp+resAG(i+1,j+1,k+1)
c  nhung change 1/3/2015 ]
      elseif (iloop.eq.2) then   
      call INTHHH(reHHHQCD,reHHHQCD_o,ZHN)    
         amp=0D0
         do i1=imin,imax
            do j1=jmin,jmax
               do k1=kmin,kmax
                     amp=amp+ Zfac(i,i1)*Zfac(j,j1)*Zfac(k,k1)*((0,-1)
     $                    *Chhh(i1+1,j1+1,k1+1)+ res(i1+1,j1 +1,k1+1)
     $                    -dL3HM(i1+1,j1+1,k1+1)+reHHHQCD_o(i1,j1,k1)) 
               enddo
            enddo
         enddo
         amp=amp+resAG(i+1,j+1,k+1)      
      elseif (iloop.eq.3) then   
      call INTHHH(reHHHQCD,reHHHQCD_o,ZHN)        
      call INTHHH(reHHHATAT,reHHHATAT_o,ZHN)         
         amp=0D0
         do i1=imin,imax
            do j1=jmin,jmax
               do k1=kmin,kmax
                     amp=amp+ Zfac(i,i1)*Zfac(j,j1)*Zfac(k,k1)*((0,-1)
     $                    *Chhh(i1+1,j1+1,k1+1)+ res(i1+1,j1 +1,k1+1)
     $                    -dL3HM(i1+1,j1+1,k1+1)+reHHHQCD_o(i1,j1,k1)+
     &                    reHHHATAT_o(i1,j1,k1)) 
               enddo
            enddo
         enddo
         amp=amp+resAG(i+1,j+1,k+1)           
      endif       
      endif       
      ampsq= amp*DCONJG(amp)
      
      end

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine reeffHHH(reHHH,iloop,CPcon)
      implicit none    
      integer i,j,k,iloop,i1,j1,k1
      double precision reHHH(6,6,6),treHHH(6,6,6),SuHHH(6,6,6),
     &                 SuHHH_o(6,6,6)       
      logical CPcon
      double precision ZH5(5,5),ZH(6,6) 
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU 
      double precision Mh1l(5),ZH1l(5,5) 
      double precision MHpm1l
      common /H1loop/ MHpm1l,MH1l,ZH1l
      double precision dMW2,dMZ2,dZe,dMHpm2,dthd,dthu,dths,dtad,dtas,
     &      dL3HM(6,6,6),OLHHH(6,6,6),reHHHQCD(6,6,6),reHHHATAT(6,6,6)
      double complex resAG(6,6,6)
      common /HHHTL/dMW2,dMZ2,dZe,dMHpm2,dthd,dthu,dths,dtad,dtas,
     &                 dL3HM,OLHHH,reHHHQCD,reHHHATAT,resAG            
      call Tree_HHH(treHHH)
c      call CalcTrilCoupl  ! to test with Hanna's code. Both codes are in agreement
      if(iloop.eq.0) then
      call INTHHH(treHHH,suHHH_o,ZH1l)  
      reHHH=suHHH_o
      else                
      if (iloop.eq.1) then
      call INTHHH(treHHH+OLHHH,suHHH_o,ZH1l)        
      reHHH=suHHH_o
      else      
      if(iloop.eq.2) then    
      call INTHHH(treHHH+OLHHH+reHHHQCD,suHHH_o,ZH1l)            
      reHHH=suHHH_o
      else       
      call INTHHH(treHHH+OLHHH+reHHHQCD+reHHHATAT,suHHH_o,ZH1l)         
      reHHH=suHHH_o  
      endif  
      endif       
      endif            
      end

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine dLHHH(dMW2,dMZ2,dZe,dMHpm2,dthd,dthu,dths,
     &  dtad,dtas,dL3HM,resAG)
      implicit none
      integer i,j,k,i1,j1,k1
      double precision dMW2,dMZ2,dZe,dthd,dthu,dths,dtad,dtas,dMHpm2,
     &                 dL3H(6,6,6),dL3HM(6,6,6),dMAG(6),dMAGM(6),dSW
     &                 ,dCW,dLGACT(6,6,6), dM(6,6)
      double precision dReAlambda,dImAlambda,dv,dReAkappa,dImAkappa,
     &                 dMchaH2
      double precision sqrt2,MW2,MZ2,v2,vs2,la2,ka2,SB,CB,ImAlambda,
     &                 ReAlambda,ImAkappa,ReAkappa,CB2,SB2,phi,phiIl,
     &                 phiIk,SW,CW,SW2,CW2,masshh(6)

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
      
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3)
     
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      logical MHpmInput,CPcon,mQrun,onelswitch     
      double precision ZH5(5,5),ZH(6,6)
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
      double complex  ChHpWmA(6,2),ChHmWpA(2,6),ChHpWmZ(6,2),
     &                ChHmWpZ(2,6),ChhWmWp(6,6),ChhAZ(6,6),ChhZZ(6,6),
     &                ChHpWm(6,2),ChHmWp(2,6),ChhZ(6,6),ChWmWp(6),
     &                ChZZ(6),ChSdmSdp(6,6,6),ChSemSep(6,6,6),
     &                ChSupSum(6,6,6),ChSvSvconj(6),ChHmHp(2,2,6),
     &                ChhSemSep(6,6,6,6),ChhSvSvconj(6,6),
     &                ChhHmHp(2,6,2,6),ChhSupSum(6,6,6,6),
     &                ChhSdmSdp(6,6,6,6),CLhChapCham(2,2,6),
     &                CRhChapCham(2,2,6),CLhFepFem(3,3,6),
     &                CRhFepFem(3,3,6),CLhFdpFdm(3,3,6),
     &                CRhFdpFdm(3,3,6),CLhFumFup(3,3,6),
     &                CRhFumFup(3,3,6),ChU3U3(6),ChU2U2(6),ChU4U4(6),
     &                Chhh(6,6,6),Chhhh(6,6,6,6),CLhChiChi(5,5,6),
     &                CRhChiChi(5,5,6),CHmHpSvSv(3,2,3,2),
     &                CHmHpSdmSdp(6,2,6,2),CHmHpSupSum(6,2,6,2),
     &                CHmHpSemSep(6,2,6,2),CHmSepSv(3,6,2),
     &                CHpSemSv(6,3,2),CHmSupSdp(6,6,2),
     &                CHpSumSdm(6,6,2),CLHpChiCha(5,2,2),
     &                CRHpChiCha(5,2,2),CLHmChiCha(2,5,2),
     &                CRHmChiCha(2,5,2)
      double complex  resAG(6,6,6),HSelf
 
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /switch/ MHpmInput,CPcon,mQrun,onelswitch
      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU
      common /coupl/ ChHpWmA,ChHmWpA,ChHpWmZ,ChHmWpZ,ChhWmWp,
     &               ChhAZ,ChhZZ,ChHpWm,ChHmWp,ChhZ,ChWmWp,ChZZ,
     &               ChSdmSdp,ChSemSep,ChSupSum,ChSvSvconj,ChHmHp,
     &               ChhSemSep,ChhSvSvconj,ChhHmHp,ChhSupSum,ChhSdmSdp,
     &               CLhChapCham,CRhChapCham,CLhFepFem,CRhFepFem,
     &               CLhFdpFdm,CRhFdpFdm,CLhFumFup,CRhFumFup,ChU3U3,
     &               ChU2U2,ChU4U4,Chhh,Chhhh,CLhChiChi,CRhChiChi,
     &               CHmHpSvSv,CHmHpSdmSdp,CHmHpSupSum,CHmHpSemSep,
     &               CHmSepSv,CHpSemSv,CHmSupSdp,CHpSumSdm,CRHpChiCha,
     &               CLHpChiCha,CRHmChiCha,CLHmChiCha
      sqrt2=Sqrt(2D0)
      SB=Sin(beta); SB2=SB**2
      CB=Cos(beta); CB2=CB**2
      la2= abslambda**2;  ka2= abskappa**2;   v2=v**2
      vS2=vs**2;      MW2=MW**2;      MZ2=MZ**2
      ReAlambda=absAlambda*Cos(phiAl)
      ImAlambda=absAlambda*Sin(phiAl)
      ReAkappa=absAkappa*Cos(phiAk)
      ImAkappa=absAkappa*Sin(phiAk)
      phi=phik - phil + 2*phis - phiu
      phiIl=phil + phis + phiu
      phiIk=phik + 3*phis
      CW=MW/MZ; CW2=CW**2;  SW2=1-CW2;  SW=Sqrt(SW2)
      dv = (2*(dMZ2*MW**4 + MZ2*(2*dZe*MW2*(MW2 - MZ2) 
     &       + dMW2*(-2*MW2 + MZ2))))/(e**2*MZ**4*v)
      dSW= CW2/SW/2D0*(dMZ2/MZ2 - dMW2/MW2)
      dCW=-((dSW*SW)/CW)
      if(MHpmInput) then

       dReAlambda=(sqrt2*(SB*(-(dthd*SB**3)+CB**5*dv*la2*SB*v2+CB*
     &  SB*v*(dMHpm2-CB2**2*dMW2-2*CB2*dMW2*SB2-dMW2*SB2**2+dv*la2*SB**
     &  4*v)-CB**3*(dthu-2*dv*la2*SB**3*v2))*Cos(phil+phis+phiu)+dtad
     &  *Sin(phil+phis+phiu)))/(abslambda*SB*v*vS)

       dImAlambda=(dtad*sqrt2/Cos(phil+phis+phiu))/(abslambda*SB*v*v
     &  S)-dReAlambda*Tan(phil+phis+phiu)

       dImAkappa=(1/cos(phik+3*phis)*(-(dtas*sqrt2)+abslambda*CB*SB*v
     &  *(2*dv*ImAlambda+dImAlambda*v)*Cos(phil+phis+phiu)+2*abskappa*a
     &  bslambda*CB*dv*SB*sqrt2*v*vS*Sin(phik-phil+2*phis-phiu)+2*absla
     &  mbda*CB*dv*ReAlambda*SB*v*Sin(phil+phis+phiu)+abslambda*CB*dReA
     &  lambda*SB*v2*Sin(phil+phis+phiu)))/(abskappa*vs2)

       dReAkappa=0D0
       dMchaH2=dMHpm2
      else
       dReAlambda=0D0
       dReAkappa=0D0
       dMchaH2=CB2**2*dMW2+2*CB2*dMW2*SB2+dMW2*SB2**2+(CB2*dthu)/
     &  (SB*v)+(dthd*SB2)/(CB*v)-CB**4*dv*la2*v-2*CB**2*dv*la2*SB**2*v-
     &  dv*la2*SB**4*v-(dtad*Tan(phil+phis+phiu))/(CB*SB**2*v)

      dImAlambda=(sqrt2*(dtad*Cos(phil+phis+phiu)+SB*(dthd*SB**3-CB
     &  **5*dv*la2*SB*v2+CB*SB*v*(-dMchaH2+CB2**2*dMW2+2*CB2*dMW2*SB2
     &  +dMW2*SB2**2-dv*la2*SB**4*v)+CB**3*(dthu-2*dv*la2*SB**3*v2))*
     &  Sin(phil+phis+phiu)))/(abslambda*SB*v*vS)

       dImAkappa=(sqrt2/Cos(phik+3*phis)*(-(dtas*vS**3)+CB*dtad*v*v
     &  s2+3*abskappa*abslambda*CB*dv*SB*v*vs2**2*Sin(phik-phil+2*phis-
     &  phiu)))/(abskappa*vS**3*vs2)
      endif

c(the basis here is (G, a, as, hd, hu, hs))
       dL3H(1,1,1)=0
       dL3H(1,1,2)=0
       dL3H(1,1,3)=abslambda*CB*dImAlambda*SB*sqrt2*Cos(phiIl)+abslam
     &  bda*CB*dReAlambda*SB*sqrt2*Sin(phiIl)
       dL3H(1,1,4)=(dMZ2*(CB**3-CB*SB2))/v+(dv*(-(CB**3*MZ2)+CB*SB2*(
     &  MZ2+la2*v2)))/v2
       dL3H(1,1,5)=(dMZ2*(-(CB2*SB)+SB**3))/v+(dv*SB*(-(MZ2*SB2)+CB2*
     &  (MZ2+la2*v2)))/v2
       dL3H(1,1,6)=-(abslambda*CB*dReAlambda*SB*sqrt2*Cos(phiIl))+abs
     &  lambda*CB*dImAlambda*SB*sqrt2*Sin(phiIl)
       dL3H(1,2,2)=0
       dL3H(1,2,3)=(abslambda*dImAlambda*(CB2-SB2)*Cos(phiIl))/sqrt2+
     &  (abslambda*dReAlambda*(CB2-SB2)*Sin(phiIl))/sqrt2
       dL3H(1,2,4)=(-2*CB2*dMZ2*SB)/v+CB2*dv*SB*(la2+(2*MZ2)/v2)
       dL3H(1,2,5)=(2*CB*dMZ2*SB2)/v-(CB*dv*SB2*(2*MZ2+la2*v2))/v2
       dL3H(1,2,6)=-((abslambda*dReAlambda*(CB2-SB2)*Cos(phiIl))/sqrt
     &  2)+(abslambda*dImAlambda*(CB2-SB2)*Sin(phiIl))/sqrt2
       dL3H(1,3,3)=0
       dL3H(1,3,4)=(abslambda*dReAlambda*SB*Cos(phiIl))/sqrt2-(abslam
     &  bda*dImAlambda*SB*Sin(phiIl))/sqrt2
       dL3H(1,3,5)=-((abslambda*CB*dReAlambda*Cos(phiIl))/sqrt2)+(abs
     &  lambda*CB*dImAlambda*Sin(phiIl))/sqrt2
       dL3H(1,3,6)=0
       dL3H(1,4,4)=0
       dL3H(1,4,5)=0
       dL3H(1,4,6)=(abslambda*dImAlambda*SB*Cos(phiIl))/sqrt2+(abslam
     &  bda*dReAlambda*SB*Sin(phiIl))/sqrt2
       dL3H(1,5,5)=0
       dL3H(1,5,6)=-((abslambda*CB*dImAlambda*Cos(phiIl))/sqrt2)-(abs
     &  lambda*CB*dReAlambda*Sin(phiIl))/sqrt2
       dL3H(1,6,6)=0
       dL3H(2,2,2)=0
       dL3H(2,2,3)=-(abslambda*CB*dImAlambda*SB*sqrt2*Cos(phiIl))-abs
     &  lambda*CB*dReAlambda*SB*sqrt2*Sin(phiIl)
       dL3H(2,2,4)=(dMZ2*(-CB**3+CB*SB2))/v+(dv*(-(CB*MZ2*SB2)+CB**3*
     &  (MZ2+la2*v2)))/v2
       dL3H(2,2,5)=(dMZ2*SB*(CB2-SB2))/v+(dv*(-(CB2*MZ2*SB)+SB**3*(MZ
     &  2+la2*v2)))/v2
       dL3H(2,2,6)=abslambda*CB*dReAlambda*SB*sqrt2*Cos(phiIl)-abslam
     &  bda*CB*dImAlambda*SB*sqrt2*Sin(phiIl)
       dL3H(2,3,3)=abskappa*abslambda*dv*(CB2+SB2)*Sin(phi)
       dL3H(2,3,4)=(abslambda*CB*dReAlambda*Cos(phiIl))/sqrt2-(abslam
     &  bda*CB*dImAlambda*Sin(phiIl))/sqrt2
       dL3H(2,3,5)=(abslambda*dReAlambda*SB*Cos(phiIl))/sqrt2-(abslam
     &  bda*dImAlambda*SB*Sin(phiIl))/sqrt2
       dL3H(2,3,6)=-(abskappa*abslambda*dv*(CB2+SB2)*Cos(phi))
       dL3H(2,4,4)=0
       dL3H(2,4,5)=0
       dL3H(2,4,6)=(abslambda*CB*dImAlambda*Cos(phiIl))/sqrt2+(abslam
     &  bda*CB*dReAlambda*Sin(phiIl))/sqrt2
       dL3H(2,5,5)=0
       dL3H(2,5,6)=(abslambda*dImAlambda*SB*Cos(phiIl))/sqrt2+(abslam
     &  bda*dReAlambda*SB*Sin(phiIl))/sqrt2
       dL3H(2,6,6)=-(abskappa*abslambda*dv*(CB2+SB2)*Sin(phi))
       dL3H(3,3,3)=abskappa*dImAkappa*sqrt2*Cos(phiIk)+abskappa*dReAk
     &  appa*sqrt2*Sin(phiIk)
       dL3H(3,3,4)=abslambda*dv*(abslambda*CB+abskappa*SB*Cos(phi))
       dL3H(3,3,5)=abslambda*dv*(abslambda*SB+abskappa*CB*Cos(phi))
       dL3H(3,3,6)=-(abskappa*dReAkappa*sqrt2*Cos(phiIk))+abskappa*dI
     &  mAkappa*sqrt2*Sin(phiIk)
       dL3H(3,4,4)=0
       dL3H(3,4,5)=(abslambda*dImAlambda*Cos(phiIl))/sqrt2+(abslambda
     &  *dReAlambda*Sin(phiIl))/sqrt2
       dL3H(3,4,6)=abskappa*abslambda*dv*SB*Sin(phi)
       dL3H(3,5,5)=0
       dL3H(3,5,6)=abskappa*abslambda*CB*dv*Sin(phi)
       dL3H(3,6,6)=-(abskappa*dImAkappa*sqrt2*Cos(phiIk))-abskappa*dR
     &  eAkappa*sqrt2*Sin(phiIk)
       dL3H(4,4,4)=(3*CB*dMZ2)/v-(3*CB*dv*MZ2)/v2
       dL3H(4,4,5)=-((dMZ2*SB)/v)+dv*SB*(la2+MZ2/v2)
       dL3H(4,4,6)=0
       dL3H(4,5,5)=-((CB*dMZ2)/v)+CB*dv*(la2+MZ2/v2)
       dL3H(4,5,6)=-((abslambda*dReAlambda*Cos(phiIl))/sqrt2)+(abslam
     &  bda*dImAlambda*Sin(phiIl))/sqrt2
       dL3H(4,6,6)=abslambda*dv*(abslambda*CB-abskappa*SB*Cos(phi))
       dL3H(5,5,5)=(3*dMZ2*SB)/v-(3*dv*MZ2*SB)/v2
       dL3H(5,5,6)=0
       dL3H(5,6,6)=abslambda*dv*(abslambda*SB-abskappa*CB*Cos(phi))
       dL3H(6,6,6)=abskappa*dReAkappa*sqrt2*Cos(phiIk)-abskappa*dImAk
     &  appa*sqrt2*Sin(phiIk)
       do i=1,6
        do j=i,6
         do k=j,6
         dL3H(k,j,i)=   dL3H(i,j,k)
         dL3H(k,i,j)=   dL3H(i,j,k)
         dL3H(j,k,i)=   dL3H(i,j,k)
         dL3H(j,i,k)=   dL3H(i,j,k)
         dL3H(i,k,j)=   dL3H(i,j,k)
         enddo
        enddo
       enddo
       dMAG(1)=(CB*dthd + dthu*SB )/v
       dMAG(2)=(CB*dthu - dthd*SB)/v
       dMAG(3)=0
       dMAG(4)=(-2*abslambda*CB*SB*vS*(dImAlambda*Cos(phiIl)+dReA
     &  lambda*Sin(phiIl)))/sqrt2
       dMAG(5)=-((abslambda*(CB2-SB2)*vS*(dImAlambda*Cos(phiIl)+d
     &  ReAlambda*Sin(phiIl)))/sqrt2)
       dMAG(6)=0

c counterterm in tree-level mass eigenstates
      do i=1,6
       dMAGM(i)=0D0
       do i1=1,6
       dMAGM(i)=dMAGM(i) + ZH(i,i1)*dMAG(i1)
       enddo
      enddo
      Masshh(1)=Mz;  Masshh(2:6)=Mh(1:5)
       do i=1,6
        do j=1,6
         do k=1,6
         dL3HM(k,j,i)=0D0
       do i1=1,6
        do j1=1,6
         do k1=1,6
       dL3HM(k,j,i)=dL3HM(k,j,i)+ZH(i,i1)*ZH(j,j1)*ZH(k,k1)*dL3H(k1,j1,i1)
         enddo
        enddo
       enddo
c[ nhung change 1/3/2015
                resAG(i,j,k)=-(0,1)*Chhh(j,k,1)*(HSelf(i,1,Masshh(i)**2)
     $               -dMAGM(i))/(-MZ2 + Masshh(i)**2)*(1- MZ2/Masshh(i)
     $               **2)-(0,1)*(Chhh(i,k,1)*(HSelf(j,1,Masshh(j)**2)
     $               -dMAGM(j)))/(-MZ2 + Masshh(j)**2)*(1- MZ2/Masshh(j)
     $               **2)-(0,1)*(Chhh(i,j,1)*(HSelf(k,1,Masshh(k)**2)
     $               -dMAGM(k)))/(-MZ2 + Masshh(k)**2)*(1- MZ2/Masshh(k)
     $               **2)
c end change]
         enddo
        enddo
       enddo

      end
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine UrecoupHHH(m12,m22,m32,res)
      implicit none 
#include "looptools.h"  
  
      integer i,j,k
      integer imax,imin,jmax,jmin,kmax,kmin
      common/CPindexrange/imax,imin,jmax,jmin,kmax,kmin
      double precision m12,m22,m32


      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
     
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      
      double complex  ChHpWmA(6,2),ChHmWpA(2,6),ChHpWmZ(6,2),
     &                ChHmWpZ(2,6),ChhWmWp(6,6),ChhAZ(6,6),ChhZZ(6,6),
     &                ChHpWm(6,2),ChHmWp(2,6),ChhZ(6,6),ChWmWp(6),
     &                ChZZ(6),ChSdmSdp(6,6,6),ChSemSep(6,6,6),
     &                ChSupSum(6,6,6),ChSvSvconj(6),ChHmHp(2,2,6),
     &                ChhSemSep(6,6,6,6),ChhSvSvconj(6,6),
     &                ChhHmHp(2,6,2,6),ChhSupSum(6,6,6,6),
     &                ChhSdmSdp(6,6,6,6),CLhChapCham(2,2,6),
     &                CRhChapCham(2,2,6),CLhFepFem(3,3,6),
     &                CRhFepFem(3,3,6),CLhFdpFdm(3,3,6),
     &                CRhFdpFdm(3,3,6),CLhFumFup(3,3,6),
     &                CRhFumFup(3,3,6),ChU3U3(6),ChU2U2(6),ChU4U4(6),
     &                Chhh(6,6,6),Chhhh(6,6,6,6),CLhChiChi(5,5,6),
     &                CRhChiChi(5,5,6),CHmHpSvSv(3,2,3,2),
     &                CHmHpSdmSdp(6,2,6,2),CHmHpSupSum(6,2,6,2),
     &                CHmHpSemSep(6,2,6,2),CHmSepSv(3,6,2),
     &                CHpSemSv(6,3,2),CHmSupSdp(6,6,2),
     &                CHpSumSdm(6,6,2),CLHpChiCha(5,2,2),
     &                CRHpChiCha(5,2,2),CLHmChiCha(2,5,2),
     &                CRHmChiCha(2,5,2)
     
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /coupl/ ChHpWmA,ChHmWpA,ChHpWmZ,ChHmWpZ,ChhWmWp,
     &               ChhAZ,ChhZZ,ChHpWm,ChHmWp,ChhZ,ChWmWp,ChZZ,
     &               ChSdmSdp,ChSemSep,ChSupSum,ChSvSvconj,ChHmHp,
     &               ChhSemSep,ChhSvSvconj,ChhHmHp,ChhSupSum,ChhSdmSdp,
     &               CLhChapCham,CRhChapCham,CLhFepFem,CRhFepFem,
     &               CLhFdpFdm,CRhFdpFdm,CLhFumFup,CRhFumFup,ChU3U3,
     &               ChU2U2,ChU4U4,Chhh,Chhhh,CLhChiChi,CRhChiChi,
     &               CHmHpSvSv,CHmHpSdmSdp,CHmHpSupSum,CHmHpSemSep,
     &               CHmSepSv,CHpSemSv,CHmSupSdp,CHpSumSdm,CRHpChiCha,
     &               CLHpChiCha,CRHmChiCha,CLHmChiCha

      integer I2,J2,K2,I3,I5,J5,K5,I6,J6,K6
     &        ,iint1, iint2, iint3, iint4, iint5, iint6, iint7, iint8
     &        ,iint9(6), iint10(6), iint11(6), iint12(6), iint13(6,6)
     &        ,iint14(6,6), iint15(6,6), iint16(6,6), iint17(6,6)
     &        ,iint18(6,6), iint19(6), iint20(6,6), iint21(6,6)
     &        ,iint22(6,6), iint23(6,6), iint24(6,6), iint25(6,6)
     &        ,iint26(6,6), iint27(6,6), iint28(6,6), iint29(6,6,6)
     &        ,iint30(6,6,6), iint31(6,6,6), iint32(6,6,6)
     &        ,iint33(5,5), iint34(5,5,5), iint35(3), iint36(3)
     &        ,iint37(3), iint38(3), iint39(3), iint40(3), iint41(3)
     &        ,iint42(3), iint43(3), iint44(3), iint45(2), iint46(2)
     &        ,iint47(2), iint48(2), iint49(2,2), iint50(2,2)
     &        ,iint51(2,2), iint52(2,2), iint53(2,2), iint54(2,2)
     &        ,iint55(2), iint56(2,2,2), iint57(2,2), iint58(2,2,2)
      double precision MassFd(3),MassFe(3),MassFu(3),MassHpm(2),
     &                 Masshh(6),MW2,MZ2,Pi2
      double complex cI
      parameter (Pi2 = 4d0*Asin(1d0)**2, cI=(0,1D0))
      double complex dup12, dup13, dup14, dup15, dup16, dup17
     &               ,dup18, dup19, dup20, dup21, dup22, dup23
     &               ,dup24, dup25, dup26, dup27, dup28, dup29, dup30
     &               ,dup31, dup32, dup33
      double complex part1,part2,part3,part4,part5,part6,part7,part8
     &              ,part9,res(6,6,6)


      MW2=MW**2;         MZ2=MZ**2
      MassFd(1)=md;      MassFd(2)=ms
      MassFd(3)=mb;      MassFe(1)=me
      MassFe(2)=mmu;     MassFe(3)=mtau
      MassFu(1)=mu;      MassFu(2)=mc
      MassFu(3)=mt;      MassHpm(1)=Mw
      MassHpm(2)=Mhpm;   Masshh(1)=Mz
      Masshh(2:6)=Mh(1:5)
      part1=0D0;         part2=0D0
      part3=0D0;         part4=0D0
      part5=0D0;         part6=0D0
      part7=0D0;         part8=0D0
      part9=0D0

c#define checkHHH
        do i=imin+1,imax+1
          do j=jmin+1,jmax+1
            do k=kmin+1,kmax+1

c[ nhung change 1/3/2015

      part1=0D0;         part2=0D0
      part3=0D0;         part4=0D0
      part5=0D0;         part6=0D0
      part7=0D0;         part8=0D0
      part9=0D0
c end]
	iint1 = Bget(m12,MW2,MW2)
	iint2 = Bget(m22,MW2,MW2)
	iint3 = Bget(m32,MW2,MW2)
	iint4 = Cget(m22,m32,m12,MW2,MW2,MW2)
	iint5 = Bget(m12,MZ2,MZ2)
	iint6 = Bget(m22,MZ2,MZ2)
	iint7 = Bget(m32,MZ2,MZ2)
	iint8 = Cget(m22,m32,m12,MZ2,MZ2,MZ2)
	do I6 = 1,6
	iint9(I6) = Cget(m12,m32,m22,MZ2,MZ2,Masshh(I6)**2)
	iint10(I6) = Cget(m22,m32,m12,MZ2,MZ2,Masshh(I6)**2)
	iint11(I6) = Bget(m32,MZ2,Masshh(I6)**2)
	iint12(I6) = Cget(m32,m12,m22,MZ2,MZ2,Masshh(I6)**2)
	enddo

	do J6 = 1,6
	iint19(J6) = Bget(m32,MZ2,Masshh(J6)**2)
	enddo

	do J6 = 1,6
	do I6 = 1,6
	iint13(I6,J6) = Bget(m22,Masshh(I6)**2,Masshh(J6)**2)
	iint14(I6,J6) = Bget(m12,Masshh(I6)**2,Masshh(J6)**2)
        iint15(I6,J6) = 
     &  Cget(m12,m32,m22,MZ2,Masshh(I6)**2,Masshh(J6)**2)
	iint16(I6,J6) = Bget(m32,Masshh(I6)**2,Masshh(J6)**2)
        iint17(I6,J6) = 
     &  Cget(m12,m22,m32,MZ2,Masshh(I6)**2,Masshh(J6)**2)
        iint18(I6,J6) = 
     &  Cget(m22,m12,m32,MZ2,Masshh(I6)**2,Masshh(J6)**2)
	iint20(I6,J6) = Bget(m12,MSd(I6)**2,MSd(J6)**2)
	iint21(I6,J6) = Bget(m22,MSd(I6)**2,MSd(J6)**2)
	iint22(I6,J6) = Bget(m32,MSd(I6)**2,MSd(J6)**2)
	iint23(I6,J6) = Bget(m32,MSe(I6)**2,MSe(J6)**2)
	iint24(I6,J6) = Bget(m22,MSe(I6)**2,MSe(J6)**2)
	iint25(I6,J6) = Bget(m12,MSe(I6)**2,MSe(J6)**2)
	iint26(I6,J6) = Bget(m12,MSu(I6)**2,MSu(J6)**2)
	iint27(I6,J6) = Bget(m22,MSu(I6)**2,MSu(J6)**2)
	iint28(I6,J6) = Bget(m32,MSu(I6)**2,MSu(J6)**2)
	enddo
	enddo

	do K6 = 1,6
	do J6 = 1,6
	do I6 = 1,6
        iint29(I6,J6,K6) = 
     &  Cget(m12,m32,m22,Masshh(I6)**2,Masshh(J6)**2,
     &   Masshh(K6)**2)
        iint30(I6,J6,K6) = 
     &  Cget(m12,m32,m22,MSd(I6)**2,MSd(J6)**2,
     &   MSd(K6)**2)
        iint31(I6,J6,K6) = 
     &  Cget(m12,m32,m22,MSe(I6)**2,MSe(J6)**2,
     &   MSe(K6)**2)
        iint32(I6,J6,K6) = 
     &  Cget(m12,m32,m22,MSu(I6)**2,MSu(J6)**2,
     &   MSu(K6)**2)
	enddo
	enddo
	enddo


	do K5 = 1,5
	do J5 = 1,5
        iint33(J5,K5) = 
     &  Bget(m32,Mchi(J5)**2,Mchi(K5)**2)
	do I5 = 1,5
        iint34(I5,J5,K5) = 
     &  Cget(m12,m32,m22,Mchi(I5)**2,Mchi(J5)**2,
     &   Mchi(K5)**2)
	enddo
	enddo
	enddo

	do I3 = 1,3
	iint35(I3) = Bget(m12,MSv(I3)**2,MSv(I3)**2)
	iint36(I3) = Bget(m22,MSv(I3)**2,MSv(I3)**2)
	iint37(I3) = Bget(m32,MSv(I3)**2,MSv(I3)**2)
        iint38(I3) = Cget(m22,m32,m12,MSv(I3)**2,
     &   MSv(I3)**2,MSv(I3)**2)
	iint39(I3) = Bget(m32,MassFd(I3)**2,MassFd(I3)**2)
        iint40(I3) = Cget(m22,m32,m12,MassFd(I3)**2,
     &   MassFd(I3)**2,MassFd(I3)**2)
	iint41(I3) = Bget(m32,MassFe(I3)**2,MassFe(I3)**2)
        iint42(I3) = Cget(m22,m32,m12,MassFe(I3)**2,
     &   MassFe(I3)**2,MassFe(I3)**2)
	iint43(I3) = Bget(m32,MassFu(I3)**2,MassFu(I3)**2)
        iint44(I3) = Cget(m22,m32,m12,MassFu(I3)**2,
     &   MassFu(I3)**2,MassFu(I3)**2)
	enddo

	do I2 = 1,2
	iint45(I2) = Cget(m12,m32,m22,MW2,MW2,MassHpm(I2)**2)
	iint46(I2) = Cget(m22,m32,m12,MW2,MW2,MassHpm(I2)**2)
	iint47(I2) = Bget(m32,MW2,MassHpm(I2)**2)
	iint48(I2) = Cget(m32,m12,m22,MW2,MW2,MassHpm(I2)**2)
	enddo

	do J2 = 1,2
	do I2 = 1,2
	iint49(I2,J2) = Bget(m12,MassHpm(I2)**2,MassHpm(J2)**2)
	iint50(I2,J2) = Bget(m22,MassHpm(I2)**2,MassHpm(J2)**2)
        iint51(I2,J2) = 
     &  Bget(m32,MassHpm(I2)**2,MassHpm(J2)**2)
        iint52(I2,J2) = 
     &  Cget(m12,m32,m22,MW2,MassHpm(I2)**2,MassHpm(J2)**2)
        iint53(I2,J2) = 
     &  Cget(m12,m22,m32,MW2,MassHpm(I2)**2,MassHpm(J2)**2)
        iint54(I2,J2) = 
     &  Cget(m22,m12,m32,MW2,MassHpm(I2)**2,MassHpm(J2)**2)
	enddo
	enddo


	do K2 = 1,2
	iint55(K2) = Bget(m32,MW2,MassHpm(K2)**2)
	do J2 = 1,2
        iint57(J2,K2) = Bget(m32,Mcha(J2)**2,Mcha(K2)**2)
	do I2 = 1,2
        iint56(I2,J2,K2) = 
     &  Cget(m12,m32,m22,MassHpm(I2)**2,MassHpm(J2)**2,
     &   MassHpm(K2)**2)
        iint58(I2,J2,K2) = 
     &  Cget(m12,m32,m22,Mcha(I2)**2,Mcha(J2)**2,
     &   Mcha(K2)**2)
	enddo
	enddo
	enddo

cp1 gauge boson and ghost contribution

        part1 =  - 
     &   1/(4.D0*Pi2)*(Bval(bb0,iint1)*ChhWmWp(j,k)*ChWmWp(i)) - 
     &   1/(4.D0*Pi2)*(Bval(bb0,iint2)*ChhWmWp(i,k)*ChWmWp(j)) - 
     &   1/(4.D0*Pi2)*(Bval(bb0,iint3)*ChhWmWp(i,j)*ChWmWp(k)) - 
     &   1/(8.D0*Pi2)*(Bval(bb0,iint5)*ChhZZ(j,k)*ChZZ(i)) - 
     &   1/(8.D0*Pi2)*(Bval(bb0,iint6)*ChhZZ(i,k)*ChZZ(j)) - 
     &   1/(8.D0*Pi2)*(Bval(bb0,iint7)*ChhZZ(i,j)*ChZZ(k)) + 
     &   cI/(8.D0*Pi2)*((ChU3U3(i)*ChU3U3(j)*ChU3U3(k) + 
     &        ChU4U4(i)*ChU4U4(j)*ChU4U4(k) + 
     &        4*ChWmWp(i)*ChWmWp(j)*ChWmWp(k))*Cval(cc0,iint4)) +
     &   cI/(8.D0*Pi2)*((ChU2U2(i)*ChU2U2(j)*ChU2U2(k) + 
     &        2*ChZZ(i)*ChZZ(j)*ChZZ(k))*Cval(cc0,iint8))

#ifdef checkHHH
       print*,  "ZY", part1
#endif
cp2  1 charged Higgs+ 2W loop

        do I2=1,2
        part2 =  part2- 
     &      cI/(16.D0*Pi2)*(Bval(bb0,iint47(I2))*
     &      (ChHmWp(I2,j)*ChHpWm(k,I2)*ChWmWp(i) + 
     &      ChHmWp(I2,i)*ChHpWm(k,I2)*ChWmWp(j) + 
     &      ChHmWp(I2,k)*(ChHpWm(j,I2)*ChWmWp(i) + 
     &      ChHpWm(i,I2)*ChWmWp(j)))) - 
     &      cI/(16.D0*Pi2)*(Bval(bb0,iint3)*
     &      (ChHmWp(I2,j)*ChHpWm(i,I2) + 
     &      ChHmWp(I2,i)*ChHpWm(j,I2))*ChWmWp(k)) - 
     &      cI/(16.D0*Pi2)*((m22*ChHmWp(I2,j)*ChHpWm(i,I2) + 
     &      m22*ChHmWp(I2,i)*ChHpWm(j,I2) + 
     &      m12*(-(ChHmWp(I2,j)*ChHpWm(i,I2)) - 
     &      ChHmWp(I2,i)*ChHpWm(j,I2)))*ChWmWp(k)*
     &      Cval(cc1,iint48(I2))) - 
     &      cI/(32.D0*Pi2)*(((7*m22 + m32)*ChHmWp(I2,k)*
     &      ChHpWm(j,I2) + 7*m22*ChHmWp(I2,j)*ChHpWm(k,I2) + 
     &      m32*ChHmWp(I2,j)*ChHpWm(k,I2) + 
     &      m12*(-(ChHmWp(I2,k)*ChHpWm(j,I2)) - 
     &      ChHmWp(I2,j)*ChHpWm(k,I2)))*ChWmWp(i)*
     &      Cval(cc2,iint45(I2))) - 
     &      cI/(32.D0*Pi2)*(((-m22 + m32)*ChHmWp(I2,k)*
     &      ChHpWm(i,I2) - m22*ChHmWp(I2,i)*ChHpWm(k,I2) + 
     &      m32*ChHmWp(I2,i)*ChHpWm(k,I2) + 
     &      m12*(7*ChHmWp(I2,k)*ChHpWm(i,I2) +7*ChHmWp(I2,i)* 
     &      ChHpWm(k,I2)))*ChWmWp(j)*Cval(cc2,iint46(I2)))+ 
     &      cI/(32.D0*Pi2)*(((-3*m22 + m32)*ChHmWp(I2,j)*
     &      ChHpWm(i,I2) - 3*m22*ChHmWp(I2,i)*ChHpWm(j,I2) + 
     &      m32*ChHmWp(I2,i)*ChHpWm(j,I2) + 
     &      m12*(-(ChHmWp(I2,j)*ChHpWm(i,I2)) - 
     &      ChHmWp(I2,i)*ChHpWm(j,I2)))*ChWmWp(k)*
     &      Cval(cc2,iint48(I2))) - 
     &      cI/(16.D0*Pi2)*(ChWmWp(j)*Cval(cc0,iint46(I2))*
     &      ((-m22 + m32 + MW2)*ChHmWp(I2,k)*ChHpWm(i,I2) - 
     &      m22*ChHmWp(I2,i)*ChHpWm(k,I2) + 
     &      m32*ChHmWp(I2,i)*ChHpWm(k,I2) + 
     &      m12*(3*ChHmWp(I2,k)*ChHpWm(i,I2) + 
     &      3*ChHmWp(I2,i)*ChHpWm(k,I2)) + 
     &      MW2*(ChHmWp(I2,i)*ChHpWm(k,I2)))) + 
     &      cI/(8.D0*Pi2)*(ChWmWp(j)*Cval(cc1,iint46(I2))*
     &      (m32*ChHmWp(I2,i)*ChHpWm(k,I2) + 
     &      m12*(-(ChHmWp(I2,k)*ChHpWm(i,I2)) - 
     &      ChHmWp(I2,i)*ChHpWm(k,I2)) + 
     &      ChHmWp(I2,k)*ChHpWm(i,I2)*(m32 - 1/2.D0*m22) - 
     &      1/2.D0*(m22*ChHmWp(I2,i)*ChHpWm(k,I2)))) + 
     &      cI/(8.D0*Pi2)*(ChWmWp(i)*Cval(cc1,iint45(I2))*
     &      ((-m22 + m32)*ChHmWp(I2,k)*ChHpWm(j,I2) - 
     &      m22*ChHmWp(I2,j)*ChHpWm(k,I2) + 
     &      m32*ChHmWp(I2,j)*ChHpWm(k,I2) + 
     &      m12*(-(1/2.D0*(ChHmWp(I2,k)*ChHpWm(j,I2))) - 
     &      1/2.D0*(ChHmWp(I2,j)*ChHpWm(k,I2))))) - 
     &      cI/(16.D0*Pi2)*(ChWmWp(i)*Cval(cc0,iint45(I2))*
     &      ((3*m22 + m32 + MW2)*ChHmWp(I2,k)*ChHpWm(j,I2) + 
     &      3*m22*ChHmWp(I2,j)*ChHpWm(k,I2) + 
     &      m32*ChHmWp(I2,j)*ChHpWm(k,I2) + 
     &      m12*(-(ChHmWp(I2,k)*ChHpWm(j,I2)) - 
     &      ChHmWp(I2,j)*ChHpWm(k,I2)) + 
     &      MW2*(ChHmWp(I2,j)*ChHpWm(k,I2))))

        part2 = part2 + 
     &   cI/(16.D0*Pi2)*(ChWmWp(k)*Cval(cc0,iint48(I2))*
     &      (-2*m22*ChHmWp(I2,i)*ChHpWm(j,I2) + 
     &        m32*ChHmWp(I2,i)*ChHpWm(j,I2) + 
     &        m12*(-(ChHmWp(I2,j)*ChHpWm(i,I2)) - 
     &           ChHmWp(I2,i)*ChHpWm(j,I2)) - 
     &        ChHmWp(I2,i)*ChHpWm(j,I2)*MassHpm(I2)**2 + 
     &        ChHmWp(I2,j)*ChHpWm(i,I2)*
     &         (-2*m22 + m32 - MassHpm(I2)**2)))

        enddo
#ifdef checkHHH
       print*,  "1 Charged Higgs", part2
#endif
cp3 2 charged Higgs + 1 W loop


        do I2=1,2
          do J2=1,2
        part3 = part3 - 
     &   1/(16.D0*Pi2)*(Bval(bb0,iint49(I2,J2))*
     &      ChhHmHp(J2,j,I2,k)*ChHmHp(I2,J2,i)) - 
     &   1/(16.D0*Pi2)*(Bval(bb0,iint50(I2,J2))*
     &      ChhHmHp(J2,i,I2,k)*ChHmHp(I2,J2,j)) + 
     &   cI/(16.D0*Pi2)*(Bval(bb0,iint55(J2))*
     &      (ChHmHp(I2,J2,j)*ChHmWp(J2,k)*ChHpWm(i,I2) + 
     &        ChHmHp(I2,J2,i)*ChHmWp(J2,k)*ChHpWm(j,I2) + 
     &        ChHmHp(J2,I2,j)*ChHmWp(I2,i)*ChHpWm(k,J2) + 
     &        ChHmHp(J2,I2,i)*ChHmWp(I2,j)*ChHpWm(k,J2)))-
     &     cI/(16.D0*Pi2)*
     &    (((-m22 + m32)*ChHmHp(I2,J2,k)*ChHmWp(J2,j)*
     &         ChHpWm(i,I2) - 
     &        m22*ChHmHp(J2,I2,k)*ChHmWp(I2,i)*
     &         ChHpWm(j,J2) + 
     &        m32*ChHmHp(J2,I2,k)*ChHmWp(I2,i)*
     &         ChHpWm(j,J2) + 
     &        m12*(-3*ChHmHp(I2,J2,k)*ChHmWp(J2,j)*
     &            ChHpWm(i,I2) - 
     &           3*ChHmHp(J2,I2,k)*ChHmWp(I2,i)*
     &            ChHpWm(j,J2)))*Cval(cc1,iint52(I2,J2))) + 
     &   cI/(16.D0*Pi2)*(((-m22 + m32)*ChHmHp(I2,J2,j)*
     &         ChHmWp(J2,k)*ChHpWm(i,I2) - 
     &        m22*ChHmHp(J2,I2,j)*ChHmWp(I2,i)*
     &         ChHpWm(k,J2) + 
     &        m32*ChHmHp(J2,I2,j)*ChHmWp(I2,i)*
     &         ChHpWm(k,J2) + 
     &        m12*(ChHmHp(I2,J2,j)*ChHmWp(J2,k)*
     &            ChHpWm(i,I2) + 
     &           ChHmHp(J2,I2,j)*ChHmWp(I2,i)*ChHpWm(k,J2))
     &        )*Cval(cc1,iint53(I2,J2))) + 
     &   cI/(16.D0*Pi2)*(((m22 + m32)*ChHmHp(I2,J2,i)*
     &         ChHmWp(J2,k)*ChHpWm(j,I2) + 
     &        m22*ChHmHp(J2,I2,i)*ChHmWp(I2,j)*
     &         ChHpWm(k,J2) + 
     &        m32*ChHmHp(J2,I2,i)*ChHmWp(I2,j)*
     &         ChHpWm(k,J2) + 
     &        m12*(-(ChHmHp(I2,J2,i)*ChHmWp(J2,k)*
     &              ChHpWm(j,I2)) - 
     &           ChHmHp(J2,I2,i)*ChHmWp(I2,j)*ChHpWm(k,J2))
     &        )*Cval(cc1,iint54(I2,J2))) - 
     &   cI/(16.D0*Pi2)*(((-3*m22 + m32)*ChHmHp(I2,J2,k)*
     &         ChHmWp(J2,j)*ChHpWm(i,I2) - 
     &        3*m22*ChHmHp(J2,I2,k)*ChHmWp(I2,i)*
     &         ChHpWm(j,J2) + 
     &        m32*ChHmHp(J2,I2,k)*ChHmWp(I2,i)*
     &         ChHpWm(j,J2) + 
     &        m12*(-(ChHmHp(I2,J2,k)*ChHmWp(J2,j)*
     &              ChHpWm(i,I2)) - 
     &           ChHmHp(J2,I2,k)*ChHmWp(I2,i)*ChHpWm(j,J2))
     &        )*Cval(cc2,iint52(I2,J2))) + 
     &   cI/(8.D0*Pi2)*(m32*
     &      (ChHmHp(I2,J2,j)*ChHmWp(J2,k)*ChHpWm(i,I2) + 
     &        ChHmHp(J2,I2,j)*ChHmWp(I2,i)*ChHpWm(k,J2))*
     &      Cval(cc2,iint53(I2,J2))) - 
     &   1/(16.D0*Pi2)*(Bval(bb0,iint51(I2,J2))*
     &      (ChhHmHp(J2,i,I2,j)*ChHmHp(I2,J2,k) - 
     &        cI*(ChHmHp(I2,J2,k)*ChHmWp(J2,j)*
     &           ChHpWm(i,I2)) - 
     &        cI*(ChHmHp(J2,I2,k)*ChHmWp(I2,i)*
     &           ChHpWm(j,J2)))) + 
     &   cI/(16.D0*Pi2)*(Cval(cc0,iint52(I2,J2))*
     &      ((2*m22 - 2*m32 + MW2)*ChHmHp(I2,J2,k)*
     &         ChHmWp(J2,j)*ChHpWm(i,I2) + 
     &        2*m22*ChHmHp(J2,I2,k)*ChHmWp(I2,i)*
     &         ChHpWm(j,J2) - 
     &        2*m32*ChHmHp(J2,I2,k)*ChHmWp(I2,i)*
     &         ChHpWm(j,J2) + 
     &        m12*(2*ChHmHp(I2,J2,k)*ChHmWp(J2,j)*
     &            ChHpWm(i,I2) + 
     &           2*ChHmHp(J2,I2,k)*ChHmWp(I2,i)*
     &            ChHpWm(j,J2)) + 
     &        MW2*(ChHmHp(J2,I2,k)*ChHmWp(I2,i)*
     &           ChHpWm(j,J2))))

        part3 = part3 + 
     &   cI/(8.D0*Pi2)*(m32*
     &      (ChHmHp(I2,J2,i)*ChHmWp(J2,k)*ChHpWm(j,I2) + 
     &        ChHmHp(J2,I2,i)*ChHmWp(I2,j)*ChHpWm(k,J2))*
     &      Cval(cc2,iint54(I2,J2))) + 
     &   cI/(8.D0*Pi2)*(Cval(cc0,iint53(I2,J2))*
     &      (-(m22*ChHmHp(J2,I2,j)*ChHmWp(I2,i)*
     &           ChHpWm(k,J2)) + 
     &        m32*ChHmHp(J2,I2,j)*ChHmWp(I2,i)*
     &         ChHpWm(k,J2) + 
     &        m12*(1/2.D0*(ChHmHp(I2,J2,j)*ChHmWp(J2,k)*
     &              ChHpWm(i,I2)) + 
     &           1/2.D0*(ChHmHp(J2,I2,j)*ChHmWp(I2,i)*
     &              ChHpWm(k,J2))) + 
     &        ChHmHp(I2,J2,j)*ChHmWp(J2,k)*ChHpWm(i,I2)*
     &         (-m22 + m32 + 1/2.D0*MassHpm(I2)**2) + 
     &        1/2.D0*(ChHmHp(J2,I2,j)*ChHmWp(I2,i)*
     &           ChHpWm(k,J2)*MassHpm(I2)**2))) + 
     &   cI/(8.D0*Pi2)*(Cval(cc0,iint54(I2,J2))*
     &      (m32*ChHmHp(J2,I2,i)*ChHmWp(I2,j)*
     &         ChHpWm(k,J2) + 
     &        m12*(-(ChHmHp(I2,J2,i)*ChHmWp(J2,k)*
     &              ChHpWm(j,I2)) - 
     &           ChHmHp(J2,I2,i)*ChHmWp(I2,j)*ChHpWm(k,J2))
     &          + 1/2.D0*(m22*ChHmHp(J2,I2,i)*ChHmWp(I2,j)*
     &           ChHpWm(k,J2)) + 
     &        ChHmHp(I2,J2,i)*ChHmWp(J2,k)*ChHpWm(j,I2)*
     &         (m32 + 1/2.D0*m22 + 1/2.D0*MassHpm(I2)**2) + 
     &        1/2.D0*(ChHmHp(J2,I2,i)*ChHmWp(I2,j)*
     &           ChHpWm(k,J2)*MassHpm(I2)**2)))
           enddo
         enddo


#ifdef checkHHH
       print*,  "2 Charged Higgs", part3
#endif

cp4 3 chargino loop, 3 charged Higgs loop

        do I2=1,2
          do J2=1,2
            do K2=1,2
        dup24 = CRhChapCham(J2,I2,i)*Mcha(I2) + 
     &   CLhChapCham(J2,I2,i)*Mcha(J2)
        dup25 = CLhChapCham(J2,I2,i)*Mcha(I2) + 
     &   CRhChapCham(J2,I2,i)*Mcha(J2)
        dup26 = CLhChapCham(J2,K2,k)*
     &    CRhChapCham(K2,I2,j)*Mcha(I2) + 
     &   CLhChapCham(K2,I2,j)*CRhChapCham(J2,K2,k)*
     &    Mcha(J2)
        dup27 = CLhChapCham(K2,I2,j)*
     &    CRhChapCham(J2,K2,k)*Mcha(I2) + 
     &   CLhChapCham(J2,K2,k)*CRhChapCham(K2,I2,j)*
     &    Mcha(J2)
        dup28 = CRhChapCham(I2,K2,j)*Mcha(I2) + 
     &   CLhChapCham(I2,K2,j)*Mcha(K2)
        dup29 = CRhChapCham(K2,I2,j)*Mcha(I2) + 
     &   CLhChapCham(K2,I2,j)*Mcha(K2)
        dup30 = CLhChapCham(I2,K2,j)*Mcha(I2) + 
     &   CRhChapCham(I2,K2,j)*Mcha(K2)
        dup31 = CLhChapCham(J2,K2,k)*Mcha(J2) + 
     &   CRhChapCham(J2,K2,k)*Mcha(K2)
        dup32 = CLhChapCham(K2,I2,j)*Mcha(I2) + 
     &   CRhChapCham(K2,I2,j)*Mcha(K2)
        dup33 = CLhChapCham(I2,J2,i)*
     &    (dup31*CRhChapCham(K2,I2,j) + 
     &      CLhChapCham(K2,I2,j)*CRhChapCham(J2,K2,k)*
     &       Mcha(I2)) + CRhChapCham(I2,J2,i)*
     &    (dup29*CLhChapCham(J2,K2,k) + 
     &      CLhChapCham(K2,I2,j)*CRhChapCham(J2,K2,k)*
     &       Mcha(J2)) + CRhChapCham(K2,J2,k)*
     &    (dup25*CLhChapCham(I2,K2,j) + 
     &      CLhChapCham(J2,I2,i)*CRhChapCham(I2,K2,j)*
     &       Mcha(K2)) + CLhChapCham(K2,J2,k)*
     &    (dup24*CRhChapCham(I2,K2,j) + 
     &      CLhChapCham(I2,K2,j)*CRhChapCham(J2,I2,i)*Mcha(K2))

        part4 = part4 + 
     &   cI/(8.D0*Pi2)*(dup33*Bval(bb0,iint57(J2,K2))) + 
     &   Cval(cc1,iint58(I2,J2,K2))*
     &    (-(cI/(16.D0*Pi2)*((-m12 - m22 + m32)*
     &      (dup27*CLhChapCham(I2,J2,i) + dup26*CRhChapCham(I2,J2,i)+ 
     &      dup24*CLhChapCham(K2,J2,k)*CRhChapCham(I2,K2,j) + 
     &      dup25*CLhChapCham(I2,K2,j)*CRhChapCham(K2,J2,k)))) + 
     &      cI/(8.D0*Pi2)*(m12*(dup29*CLhChapCham(J2,K2,k)*
     &      CRhChapCham(I2,J2,i) + dup28*CLhChapCham(K2,J2,k)*
     &      CRhChapCham(J2,I2,i) + dup32*CLhChapCham(I2,J2,i)*
     &      CRhChapCham(J2,K2,k) + dup30*CLhChapCham(J2,I2,i)*
     &      CRhChapCham(K2,J2,k)))) + Cval(cc2,iint58(I2,J2,K2))*
     &    (cI/(8.D0*Pi2)*(m22*
     &      (dup27*CLhChapCham(I2,J2,i)+dup26*CRhChapCham(I2,J2,i) + 
     &      dup24*CLhChapCham(K2,J2,k)*CRhChapCham(I2,K2,j) + 
     &      dup25*CLhChapCham(I2,K2,j)*CRhChapCham(K2,J2,k))) - 
     &    cI/(16.D0*Pi2)*((-m12 - m22 + m32)*
     &      (dup29*CLhChapCham(J2,K2,k)*CRhChapCham(I2,J2,i) + 
     &      dup28*CLhChapCham(K2,J2,k)*CRhChapCham(J2,I2,i) + 
     &      dup32*CLhChapCham(I2,J2,i)*CRhChapCham(J2,K2,k) + 
     &      dup30*CLhChapCham(J2,I2,i)*CRhChapCham(K2,J2,k)))) - 
     &   cI/(16.D0*Pi2)*((ChHmHp(I2,J2,i)*ChHmHp(J2,K2,k)*
     &         ChHmHp(K2,I2,j) + 
     &        ChHmHp(I2,K2,j)*ChHmHp(J2,I2,i)*
     &         ChHmHp(K2,J2,k))*
     &      Cval(cc0,iint56(I2,J2,K2))) + 
     &   Cval(cc0,iint58(I2,J2,K2))*
     &    (-(cI/(16.D0*Pi2)*((-m12 - m22 + m32)*
     &      (CLhChapCham(K2,J2,k)*CRhChapCham(I2,K2,j)*
     &      CRhChapCham(J2,I2,i) + CLhChapCham(I2,J2,i)*
     &      CLhChapCham(K2,I2,j)*CRhChapCham(J2,K2,k) + 
     &      CLhChapCham(J2,K2,k)*CRhChapCham(I2,J2,i)*
     &      CRhChapCham(K2,I2,j) + CLhChapCham(I2,K2,j)*
     &      CLhChapCham(J2,I2,i)*CRhChapCham(K2,J2,k))*Mcha(I2))) + 
     &      cI/(8.D0*Pi2)*(dup33*Mcha(I2)**2) + 
     &      cI/(8.D0*Pi2)*((CLhChapCham(I2,J2,i)*
     &            CLhChapCham(J2,K2,k)*CLhChapCham(K2,I2,j)
     &             + CLhChapCham(I2,K2,j)*
     &            CLhChapCham(J2,I2,i)*CLhChapCham(K2,J2,k)
     &             + CRhChapCham(I2,J2,i)*
     &            CRhChapCham(J2,K2,k)*CRhChapCham(K2,I2,j)
     &             + CRhChapCham(I2,K2,j)*
     &            CRhChapCham(J2,I2,i)*CRhChapCham(K2,J2,k)
     &           )*Mcha(I2)*Mcha(J2)*Mcha(K2)))
             enddo
           enddo
         enddo

#ifdef checkHHH

       print*,  "3 Charged Higgs, 3 chargino", part4
#endif

cp5   fermion loops, sneutrino
        do I3=1,3
        dup18 = CLhFdpFdm(I3,I3,k)*CRhFdpFdm(I3,I3,i) + 
     &   CLhFdpFdm(I3,I3,i)*CRhFdpFdm(I3,I3,k)

        dup19 = CLhFdpFdm(I3,I3,k)*CRhFdpFdm(I3,I3,j) + 
     &   CLhFdpFdm(I3,I3,j)*CRhFdpFdm(I3,I3,k)

        dup20 = CLhFepFem(I3,I3,k)*CRhFepFem(I3,I3,i) + 
     &   CLhFepFem(I3,I3,i)*CRhFepFem(I3,I3,k)

        dup21 = CLhFepFem(I3,I3,k)*CRhFepFem(I3,I3,j) + 
     &   CLhFepFem(I3,I3,j)*CRhFepFem(I3,I3,k)

        dup22 = CLhFumFup(I3,I3,k)*CRhFumFup(I3,I3,i) + 
     &   CLhFumFup(I3,I3,i)*CRhFumFup(I3,I3,k)

        dup23 = CLhFumFup(I3,I3,k)*CRhFumFup(I3,I3,j) + 
     &   CLhFumFup(I3,I3,j)*CRhFumFup(I3,I3,k)

        part5 = part5 - 
     &   1/(16.D0*Pi2)*(Bval(bb0,iint35(I3))*ChhSvSvconj(j,k)*
     &      ChSvSvconj(i)) - 
     &   1/(16.D0*Pi2)*(Bval(bb0,iint36(I3))*ChhSvSvconj(i,k)*
     &      ChSvSvconj(j)) - 
     &   1/(16.D0*Pi2)*(Bval(bb0,iint37(I3))*ChhSvSvconj(i,j)*
     &      ChSvSvconj(k)) - 
     &   cI/(8.D0*Pi2)*(ChSvSvconj(i)*ChSvSvconj(j)*ChSvSvconj(k)*
     &      Cval(cc0,iint38(I3))) + 
     &   (3*cI)/(4.D0*Pi2)*
     &    (Bval(bb0,iint39(I3))*
     &      (CLhFdpFdm(I3,I3,j)*
     &         (CLhFdpFdm(I3,I3,k)*CRhFdpFdm(I3,I3,i) + 
     &           CLhFdpFdm(I3,I3,i)*CRhFdpFdm(I3,I3,k) + 
     &           CRhFdpFdm(I3,I3,i)*CRhFdpFdm(I3,I3,k)) + 
     &        CRhFdpFdm(I3,I3,j)*
     &         (CLhFdpFdm(I3,I3,k)*CRhFdpFdm(I3,I3,i) + 
     &           CLhFdpFdm(I3,I3,i)*
     &            (CLhFdpFdm(I3,I3,k) + CRhFdpFdm(I3,I3,k))
     &           ))*MassFd(I3)) + 
     &   Cval(cc0,iint40(I3))*
     &    (-((3*cI)/(8.D0*Pi2)*
     &         ((-m12 - m22 + m32)*
     &           (CLhFdpFdm(I3,I3,k)*CRhFdpFdm(I3,I3,i)*
     &              CRhFdpFdm(I3,I3,j) + 
     &             CLhFdpFdm(I3,I3,i)*CLhFdpFdm(I3,I3,j)*
     &              CRhFdpFdm(I3,I3,k))*MassFd(I3))) + 
     &      (3*cI)/(4.D0*Pi2)*
     &       ((CLhFdpFdm(I3,I3,i) + CRhFdpFdm(I3,I3,i))*
     &         (CLhFdpFdm(I3,I3,j) + CRhFdpFdm(I3,I3,j))*
     &         (CLhFdpFdm(I3,I3,k) + CRhFdpFdm(I3,I3,k))*
     &         MassFd(I3)**3)) + 
     &   cI*(Cval(cc1,iint40(I3))*
     &      (dup19*m22*(3/(4.D0*Pi2)*
     &            (CLhFdpFdm(I3,I3,i)*MassFd(I3)) + 
     &           3/(4.D0*Pi2)*(CRhFdpFdm(I3,I3,i)*MassFd(I3))
     &           ) + dup18*m22*
     &         (3/(8.D0*Pi2)*CLhFdpFdm(I3,I3,j) + 
     &           3/(8.D0*Pi2)*CRhFdpFdm(I3,I3,j))*MassFd(I3)+
     &          dup18*(-(3/(8.D0*Pi2)*
     &              (m32*CLhFdpFdm(I3,I3,j))) + 
     &           m12*(3/(8.D0*Pi2)*CLhFdpFdm(I3,I3,j) + 
     &              3/(8.D0*Pi2)*CRhFdpFdm(I3,I3,j)) - 
     &           3/(8.D0*Pi2)*(m32*CRhFdpFdm(I3,I3,j)))*
     &         MassFd(I3))) + 
     &   cI*(Cval(cc2,iint40(I3))*
     &      (dup18*m12*(3/(4.D0*Pi2)*CLhFdpFdm(I3,I3,j) + 
     &           3/(4.D0*Pi2)*CRhFdpFdm(I3,I3,j))*MassFd(I3)+
     &          dup19*(m12*
     &            (3/(8.D0*Pi2)*
     &               (CLhFdpFdm(I3,I3,i)*MassFd(I3)) + 
     &              3/(8.D0*Pi2)*
     &               (CRhFdpFdm(I3,I3,i)*MassFd(I3))) + 
     &           CLhFdpFdm(I3,I3,i)*
     &            (3/(8.D0*Pi2)*m22 - 3/(8.D0*Pi2)*m32)*
     &            MassFd(I3) + 
     &           (3/(8.D0*Pi2)*(m22*CRhFdpFdm(I3,I3,i)) - 
     &              3/(8.D0*Pi2)*(m32*CRhFdpFdm(I3,I3,i)))*
     &            MassFd(I3)))) + 
     &   cI/(4.D0*Pi2)*(Bval(bb0,iint41(I3))*
     &      (CLhFepFem(I3,I3,j)*
     &         (CLhFepFem(I3,I3,k)*CRhFepFem(I3,I3,i) + 
     &           CLhFepFem(I3,I3,i)*CRhFepFem(I3,I3,k) + 
     &           CRhFepFem(I3,I3,i)*CRhFepFem(I3,I3,k)) + 
     &        CRhFepFem(I3,I3,j)*
     &         (CLhFepFem(I3,I3,k)*CRhFepFem(I3,I3,i) + 
     &           CLhFepFem(I3,I3,i)*
     &            (CLhFepFem(I3,I3,k) + CRhFepFem(I3,I3,k))
     &           ))*MassFe(I3)) + 
     &   Cval(cc0,iint42(I3))*
     &    (-(cI/(8.D0*Pi2)*
     &         ((-m12 - m22 + m32)*
     &           (CLhFepFem(I3,I3,k)*CRhFepFem(I3,I3,i)*
     &              CRhFepFem(I3,I3,j) + 
     &             CLhFepFem(I3,I3,i)*CLhFepFem(I3,I3,j)*
     &              CRhFepFem(I3,I3,k))*MassFe(I3))) + 
     &      cI/(4.D0*Pi2)*((CLhFepFem(I3,I3,i) + 
     &           CRhFepFem(I3,I3,i))*
     &         (CLhFepFem(I3,I3,j) + CRhFepFem(I3,I3,j))*
     &         (CLhFepFem(I3,I3,k) + CRhFepFem(I3,I3,k))*
     &         MassFe(I3)**3)) + 
     &   cI*(Cval(cc1,iint42(I3))*
     &      (dup21*m22*(1/(4.D0*Pi2)*
     &            (CLhFepFem(I3,I3,i)*MassFe(I3)) + 
     &           1/(4.D0*Pi2)*(CRhFepFem(I3,I3,i)*MassFe(I3))
     &           ) + dup20*m22*
     &         (1/(8.D0*Pi2)*CLhFepFem(I3,I3,j) + 
     &           1/(8.D0*Pi2)*CRhFepFem(I3,I3,j))*MassFe(I3)+
     &          dup20*(-(1/(8.D0*Pi2)*
     &              (m32*CLhFepFem(I3,I3,j))) + 
     &           m12*(1/(8.D0*Pi2)*CLhFepFem(I3,I3,j) + 
     &              1/(8.D0*Pi2)*CRhFepFem(I3,I3,j)) - 
     &           1/(8.D0*Pi2)*(m32*CRhFepFem(I3,I3,j)))*
     &         MassFe(I3))) + 
     &   cI*(Cval(cc2,iint42(I3))*
     &      (dup20*m12*(1/(4.D0*Pi2)*CLhFepFem(I3,I3,j) + 
     &           1/(4.D0*Pi2)*CRhFepFem(I3,I3,j))*MassFe(I3)+
     &          dup21*(m12*
     &            (1/(8.D0*Pi2)*
     &               (CLhFepFem(I3,I3,i)*MassFe(I3)) + 
     &              1/(8.D0*Pi2)*
     &               (CRhFepFem(I3,I3,i)*MassFe(I3))) + 
     &           CLhFepFem(I3,I3,i)*
     &            (1/(8.D0*Pi2)*m22 - 1/(8.D0*Pi2)*m32)*
     &            MassFe(I3) + 
     &           (1/(8.D0*Pi2)*(m22*CRhFepFem(I3,I3,i)) - 
     &              1/(8.D0*Pi2)*(m32*CRhFepFem(I3,I3,i)))*
     &            MassFe(I3))))

        part5 = part5 + 
     &   (3*cI)/(4.D0*Pi2)*
     &    (Bval(bb0,iint43(I3))*
     &      (CLhFumFup(I3,I3,j)*
     &         (CLhFumFup(I3,I3,k)*CRhFumFup(I3,I3,i) + 
     &           CLhFumFup(I3,I3,i)*CRhFumFup(I3,I3,k) + 
     &           CRhFumFup(I3,I3,i)*CRhFumFup(I3,I3,k)) + 
     &        CRhFumFup(I3,I3,j)*
     &         (CLhFumFup(I3,I3,k)*CRhFumFup(I3,I3,i) + 
     &           CLhFumFup(I3,I3,i)*
     &            (CLhFumFup(I3,I3,k) + CRhFumFup(I3,I3,k))
     &           ))*MassFu(I3)) + 
     &   Cval(cc0,iint44(I3))*
     &    (-((3*cI)/(8.D0*Pi2)*
     &         ((-m12 - m22 + m32)*
     &           (CLhFumFup(I3,I3,k)*CRhFumFup(I3,I3,i)*
     &              CRhFumFup(I3,I3,j) + 
     &             CLhFumFup(I3,I3,i)*CLhFumFup(I3,I3,j)*
     &              CRhFumFup(I3,I3,k))*MassFu(I3))) + 
     &      (3*cI)/(4.D0*Pi2)*
     &       ((CLhFumFup(I3,I3,i) + CRhFumFup(I3,I3,i))*
     &         (CLhFumFup(I3,I3,j) + CRhFumFup(I3,I3,j))*
     &         (CLhFumFup(I3,I3,k) + CRhFumFup(I3,I3,k))*
     &         MassFu(I3)**3)) + 
     &   cI*(Cval(cc1,iint44(I3))*
     &      (dup23*m22*(3/(4.D0*Pi2)*
     &            (CLhFumFup(I3,I3,i)*MassFu(I3)) + 
     &           3/(4.D0*Pi2)*(CRhFumFup(I3,I3,i)*MassFu(I3))
     &           ) + dup22*m22*
     &         (3/(8.D0*Pi2)*CLhFumFup(I3,I3,j) + 
     &           3/(8.D0*Pi2)*CRhFumFup(I3,I3,j))*MassFu(I3)+
     &          dup22*(-(3/(8.D0*Pi2)*
     &              (m32*CLhFumFup(I3,I3,j))) + 
     &           m12*(3/(8.D0*Pi2)*CLhFumFup(I3,I3,j) + 
     &              3/(8.D0*Pi2)*CRhFumFup(I3,I3,j)) - 
     &           3/(8.D0*Pi2)*(m32*CRhFumFup(I3,I3,j)))*
     &         MassFu(I3))) + 
     &   cI*(Cval(cc2,iint44(I3))*
     &      (dup22*m12*(3/(4.D0*Pi2)*CLhFumFup(I3,I3,j) + 
     &           3/(4.D0*Pi2)*CRhFumFup(I3,I3,j))*MassFu(I3)+
     &          dup23*(m12*
     &            (3/(8.D0*Pi2)*
     &               (CLhFumFup(I3,I3,i)*MassFu(I3)) + 
     &              3/(8.D0*Pi2)*
     &               (CRhFumFup(I3,I3,i)*MassFu(I3))) + 
     &           CLhFumFup(I3,I3,i)*
     &            (3/(8.D0*Pi2)*m22 - 3/(8.D0*Pi2)*m32)*
     &            MassFu(I3) + 
     &           (3/(8.D0*Pi2)*(m22*CRhFumFup(I3,I3,i)) - 
     &              3/(8.D0*Pi2)*(m32*CRhFumFup(I3,I3,i)))*
     &            MassFu(I3))))
        enddo
#ifdef checkHHH
       print*,  "3 fermion, 3 sneutrino", part5
#endif
cp6  3 neutralino loop

        do I5=1,5
        do J5=1,5
        do K5=1,5
        dup12 = CLhChiChi(J5,K5,k)*CRhChiChi(K5,I5,j)*
     &    Mchi(I5) + CLhChiChi(K5,I5,j)*
     &    CRhChiChi(J5,K5,k)*Mchi(J5)

        dup13 = CLhChiChi(K5,I5,j)*CRhChiChi(J5,K5,k)*
     &    Mchi(I5) + CLhChiChi(J5,K5,k)*
     &    CRhChiChi(K5,I5,j)*Mchi(J5)

        dup14 = CRhChiChi(K5,I5,j)*Mchi(I5) + 
     &   CLhChiChi(K5,I5,j)*Mchi(K5)

        dup15 = CLhChiChi(J5,K5,k)*Mchi(J5) + 
     &   CRhChiChi(J5,K5,k)*Mchi(K5)

        dup16 = CLhChiChi(K5,I5,j)*Mchi(I5) + 
     &   CRhChiChi(K5,I5,j)*Mchi(K5)

        dup17 = CLhChiChi(I5,J5,i)*
     &    (dup15*CRhChiChi(K5,I5,j) + 
     &      CLhChiChi(K5,I5,j)*CRhChiChi(J5,K5,k)*
     &       Mchi(I5)) + 
     &   CRhChiChi(I5,J5,i)*
     &    (dup14*CLhChiChi(J5,K5,k) + 
     &      CLhChiChi(K5,I5,j)*CRhChiChi(J5,K5,k)*
     &       Mchi(J5))

        part6 = part6 + 
     &   cI/(8.D0*Pi2)*(dup17*Bval(bb0,iint33(J5,K5))) + 
     &   Cval(cc1,iint34(I5,J5,K5))*
     &    (-(cI/(16.D0*Pi2)*
     &         ((-m12 - m22 + m32)*
     &           (dup13*CLhChiChi(I5,J5,i) + 
     &             dup12*CRhChiChi(I5,J5,i)))) + 
     &      cI/(8.D0*Pi2)*(m12*
     &         (dup14*CLhChiChi(J5,K5,k)*
     &            CRhChiChi(I5,J5,i) + 
     &           dup16*CLhChiChi(I5,J5,i)*
     &            CRhChiChi(J5,K5,k)))) + 
     &   Cval(cc2,iint34(I5,J5,K5))*
     &    (cI/(8.D0*Pi2)*(m22*
     &         (dup13*CLhChiChi(I5,J5,i) + 
     &           dup12*CRhChiChi(I5,J5,i))) - 
     &      cI/(16.D0*Pi2)*
     &       ((-m12 - m22 + m32)*
     &         (dup14*CLhChiChi(J5,K5,k)*
     &            CRhChiChi(I5,J5,i) + 
     &           dup16*CLhChiChi(I5,J5,i)*
     &            CRhChiChi(J5,K5,k)))) + 
     &   Cval(cc0,iint34(I5,J5,K5))*
     &    (-(cI/(16.D0*Pi2)*((-m12 - m22 + m32)*
     &           (CLhChiChi(I5,J5,i)*CLhChiChi(K5,I5,j)*
     &              CRhChiChi(J5,K5,k) + 
     &             CLhChiChi(J5,K5,k)*CRhChiChi(I5,J5,i)*
     &              CRhChiChi(K5,I5,j))*Mchi(I5))) + 
     &      cI/(8.D0*Pi2)*(dup17*Mchi(I5)**2) + 
     &      cI/(8.D0*Pi2)*((CLhChiChi(I5,J5,i)*
     &            CLhChiChi(J5,K5,k)*CLhChiChi(K5,I5,j) + 
     &           CRhChiChi(I5,J5,i)*CRhChiChi(J5,K5,k)*
     &            CRhChiChi(K5,I5,j))*Mchi(I5)*Mchi(J5)*Mchi(K5)))

        enddo
        enddo
        enddo
#ifdef checkHHH
       print*,  "3 neutralino", part6
#endif
cp7  2 Z boson + 1 neutral Higgs

        do I6=1,6
        part7 = part7 + 
     &   cI/(16.D0*Pi2)*(Bval(bb0,iint11(I6))*ChhZ(k,I6)*
     &      (ChhZ(j,I6)*ChZZ(i) + ChhZ(i,I6)*ChZZ(j))) + 
     &   cI/(16.D0*Pi2)*(Bval(bb0,iint7)*ChhZ(i,I6)*ChhZ(j,I6)*
     &      ChZZ(k)) + cI/(16.D0*Pi2)*
     &    ((3*m12 - m22 + m32 + MZ2)*ChhZ(i,I6)*ChhZ(k,I6)*
     &      ChZZ(j)*Cval(cc0,iint10(I6))) + 
     &   cI/(16.D0*Pi2)*((-m12 + 3*m22 + m32 + MZ2)*ChhZ(j,I6)*
     &      ChhZ(k,I6)*ChZZ(i)*Cval(cc0,iint9(I6))) + 
     &   cI/(16.D0*Pi2)*((-m12 + m22)*ChhZ(i,I6)*ChhZ(j,I6)*
     &      ChZZ(k)*Cval(cc1,iint12(I6))) + 
     &   cI/(32.D0*Pi2)*((7*m12 - m22 + m32)*ChhZ(i,I6)*
     &      ChhZ(k,I6)*ChZZ(j)*Cval(cc2,iint10(I6))) - 
     &   cI/(32.D0*Pi2)*((-m12 - 3*m22 + m32)*ChhZ(i,I6)*
     &      ChhZ(j,I6)*ChZZ(k)*Cval(cc2,iint12(I6))) + 
     &   cI/(32.D0*Pi2)*((-m12 + 7*m22 + m32)*ChhZ(j,I6)*
     &      ChhZ(k,I6)*ChZZ(i)*Cval(cc2,iint9(I6))) - 
     &   cI/(8.D0*Pi2)*(ChhZ(j,I6)*ChhZ(k,I6)*ChZZ(i)*
     &      Cval(cc1,iint9(I6))*(-m22 + m32 - 1/2.D0*m12)) - 
     &   cI/(8.D0*Pi2)*(ChhZ(i,I6)*ChhZ(k,I6)*ChZZ(j)*
     &      Cval(cc1,iint10(I6))*(-m12 + m32 - 1/2.D0*m22)) - 
     &   cI/(16.D0*Pi2)*(ChhZ(i,I6)*ChhZ(j,I6)*ChZZ(k)*
     &      Cval(cc0,iint12(I6))*
     &      (-m12 - 2*m22 + m32 - Masshh(I6)**2))
        enddo
#ifdef checkHHH
       print*,  "1 Higgs + 2 Z", part7
#endif
cp8 2 neutral Higgs + 1 Z loop,  1 neutral Higgs + 2 sfermions

        do I6=1,6
        do J6=1,6
        part8 = part8 - 
     &   1/(32.D0*Pi2)*(Bval(bb0,iint13(I6,J6))*
     &      Chhh(j,I6,J6)*Chhhh(i,k,I6,J6)) - 
     &   1/(32.D0*Pi2)*(Bval(bb0,iint14(I6,J6))*
     &      Chhh(i,I6,J6)*Chhhh(j,k,I6,J6)) - 
     &   cI/(16.D0*Pi2)*(Bval(bb0,iint19(J6))*
     &      (Chhh(j,I6,J6)*ChhZ(i,I6) + 
     &        Chhh(i,I6,J6)*ChhZ(j,I6))*ChhZ(k,J6)) - 
     &   3/(16.D0*Pi2)*(Bval(bb0,iint20(I6,J6))*
     &      ChhSdmSdp(J6,j,I6,k)*ChSdmSdp(I6,J6,i)) - 
     &   3/(16.D0*Pi2)*(Bval(bb0,iint21(I6,J6))*
     &      ChhSdmSdp(J6,i,I6,k)*ChSdmSdp(I6,J6,j)) - 
     &   3/(16.D0*Pi2)*(Bval(bb0,iint22(I6,J6))*
     &      ChhSdmSdp(J6,i,I6,j)*ChSdmSdp(I6,J6,k)) - 
     &   1/(16.D0*Pi2)*(Bval(bb0,iint23(I6,J6))*
     &      ChhSemSep(J6,i,I6,j)*ChSemSep(I6,J6,k)) - 
     &   1/(16.D0*Pi2)*(Bval(bb0,iint24(I6,J6))*
     &      ChhSemSep(J6,i,I6,k)*ChSemSep(I6,J6,j)) - 
     &   1/(16.D0*Pi2)*(Bval(bb0,iint25(I6,J6))*
     &      ChhSemSep(J6,j,I6,k)*ChSemSep(I6,J6,i)) - 
     &   3/(16.D0*Pi2)*(Bval(bb0,iint26(I6,J6))*
     &      ChhSupSum(J6,j,I6,k)*ChSupSum(I6,J6,i)) - 
     &   3/(16.D0*Pi2)*(Bval(bb0,iint27(I6,J6))*
     &      ChhSupSum(J6,i,I6,k)*ChSupSum(I6,J6,j)) - 
     &   3/(16.D0*Pi2)*(Bval(bb0,iint28(I6,J6))*
     &      ChhSupSum(J6,i,I6,j)*ChSupSum(I6,J6,k)) - 
     &   cI/(16.D0*Pi2)*((2*m12 + 2*m22 - 2*m32 + MZ2)*
     &      Chhh(k,I6,J6)*ChhZ(i,I6)*ChhZ(j,J6)*
     &      Cval(cc0,iint15(I6,J6))) + 
     &   cI/(16.D0*Pi2)*((-3*m12 - m22 + m32)*Chhh(k,I6,J6)*
     &      ChhZ(i,I6)*ChhZ(j,J6)*Cval(cc1,iint15(I6,J6)))-
     &     cI/(16.D0*Pi2)*
     &    ((m12 - m22 + m32)*Chhh(j,I6,J6)*ChhZ(i,I6)*
     &      ChhZ(k,J6)*Cval(cc1,iint17(I6,J6))) - 
     &   cI/(16.D0*Pi2)*((-m12 + m22 + m32)*Chhh(i,I6,J6)*
     &      ChhZ(j,I6)*ChhZ(k,J6)*Cval(cc1,iint18(I6,J6)))+
     &     cI/(16.D0*Pi2)*
     &    ((-m12 - 3*m22 + m32)*Chhh(k,I6,J6)*ChhZ(i,I6)*
     &      ChhZ(j,J6)*Cval(cc2,iint15(I6,J6))) - 
     &   cI/(8.D0*Pi2)*(m32*Chhh(j,I6,J6)*ChhZ(i,I6)*
     &      ChhZ(k,J6)*Cval(cc2,iint17(I6,J6))) - 
     &   cI/(8.D0*Pi2)*(m32*Chhh(i,I6,J6)*ChhZ(j,I6)*
     &      ChhZ(k,J6)*Cval(cc2,iint18(I6,J6))) - 
     &   1/(32.D0*Pi2)*(Bval(bb0,iint16(I6,J6))*
     &      Chhh(k,I6,J6)*
     &      (Chhhh(i,j,I6,J6) + 2*cI*(ChhZ(i,I6)*ChhZ(j,J6))))-
     &     cI/(8.D0*Pi2)*(Chhh(j,I6,J6)*ChhZ(i,I6)*
     &      ChhZ(k,J6)*Cval(cc0,iint17(I6,J6))*
     &      (-m22 + m32 + 1/2.D0*m12 + 1/2.D0*Masshh(I6)**2)) - 
     &   cI/(8.D0*Pi2)*(Chhh(i,I6,J6)*ChhZ(j,I6)*
     &      ChhZ(k,J6)*Cval(cc0,iint18(I6,J6))*
     &      (-m12 + m32 + 1/2.D0*m22 + 1/2.D0*Masshh(I6)**2))
        enddo
        enddo
#ifdef checkHHH
       print*,  "2 Higgs+ 1Z, 1 Higgs+ 2sfermion", part8
#endif
cp9 3 neutral Higgs, 3 sfermions

        do I6=1,6
        do J6=1,6
        do K6=1,6
        part9 = part9 - 
     &   cI/(16.D0*Pi2)*(Chhh(i,I6,J6)*Chhh(j,I6,K6)*
     &      Chhh(k,J6,K6)*Cval(cc0,iint29(I6,J6,K6))) - 
     &   (3*cI)/(16.D0*Pi2)*
     &    ((ChSdmSdp(I6,J6,i)*ChSdmSdp(J6,K6,k)*
     &    ChSdmSdp(K6,I6,j) + ChSdmSdp(I6,K6,j)*ChSdmSdp(J6,I6,i)*
     &    ChSdmSdp(K6,J6,k))*Cval(cc0,iint30(I6,J6,K6))) - 
     &   cI/(16.D0*Pi2)*((ChSemSep(I6,J6,i)*
     &    ChSemSep(J6,K6,k)*ChSemSep(K6,I6,j) + 
     &    ChSemSep(I6,K6,j)*ChSemSep(J6,I6,i)*ChSemSep(K6,J6,k))*
     &      Cval(cc0,iint31(I6,J6,K6))) - 
     &   (3*cI)/(16.D0*Pi2)*
     &    ((ChSupSum(I6,J6,i)*ChSupSum(J6,K6,k)*
     &    ChSupSum(K6,I6,j) + ChSupSum(I6,K6,j)*ChSupSum(J6,I6,i)*
     &    ChSupSum(K6,J6,k))*Cval(cc0,iint32(I6,J6,K6)))
        enddo
        enddo
        enddo


#ifdef checkHHH

       print*,  "3  Higgs, 3 sfermion", part9
       print*, "tree", chhh(i,j,k)
       print*, "total", part1+part2+part3+part4+part5+part6+part7+part8+part9

#endif
        res(i,j,k)=part1+part2+part3+part4+part5+part6+part7+part8
     &                 +part9


          enddo
        enddo
      enddo
      end

