#define epsi 1D-10

*
***********************************************************************
*
 
     

      double precision function A0T(M2, Q2)
      double precision M2, Q2
      if(M2/Q2.gt.epsi) then
       A0T=M2* (1- Log(M2/Q2))
      else
       A0T=0D0
      endif

      return
      end

*
***********************************************************************
*
      double precision function AEpT(M2, Q2)
      double precision M2, Q2, Zeta2, Pi
      Pi   = 3.141592653589793D0
      Zeta2= Pi**2/6.
      if (M2/Q2.gt.epsi) then
        AEpT= M2*(1.+0.5D0* Zeta2 - Log(M2/Q2) + (Log(M2/Q2))**2/2.)
      else
        AEpT=0D0
      endif

      end

*
***********************************************************************
*
      

      double precision function B0T(M12,M22,Q2)
      double precision M12, M22, Q2
       double precision regMass2,regmass,logX,logx2,xinverse,xinverse2
       common/regularmass/regMass2,regMass,logX,logx2,xinverse,xinverse2
      if(M12.eq.0D0 .AND. M22.eq.0D0)then
       B0T=  - logx
      elseif(M12.eq.0D0 .AND. M22.ne.0D0)then
       B0T=  1- Log(M22/Q2)
      elseif(M12.gt.0D0 .AND. M22.eq.0D0)then
       B0T=  1- Log(M12/Q2)
      elseif(abs(M12-M22).eq. 0D0 ) then
       B0T=  - Log(M22/Q2) 
      else
       B0T= 1. - Log(M22/Q2) + M12*Log(M12/M22)/(M22-M12)
      endif
      return
      end
*
***********************************************************************
*

      double precision function BEpT(M12,M22,Q2)
      double precision M12, M22, Q2,C,Zeta2, Pi,
     -    AEpT,c1,c2
       double precision regMass2,regmass,logX,logx2,xinverse,xinverse2
       common/regularmass/regMass2,regMass,logX,logx2,xinverse,xinverse2
      c1= M12; c2=M22
      Pi   = 3.141592653589793D0
      Zeta2= Pi**2/6.

      if(M12.gt.M22)then
           C=M22; M22=M12; M12=C
      endif

      if(M12.eq.0D0 .AND. M22.eq.0)then
       BEpT= 0.5D0*Zeta2+ 0.5D0* logx2 
      elseif(M12.eq.0D0 .AND. M22.ne.0)then
       BEpT= 1. +0.5D0* Zeta2 - Log(M22/Q2) + (Log(M22/Q2))**2/2.
      elseif(abs(M12-M22).eq. 0D0) then
       BEpT=  0.5D0*Zeta2+ 0.5D0* Log(M22/Q2)**2 
      else
       BEpT= (AEpT(M22,Q2)- AEpT(M12,Q2))/(M22-M12)
      endif
      M12=c1; M22=c2      
      return
      end

*
***********************************************************************
*

      double complex function B0P(P2,M12,M22,Q2)
      double precision P2, M12, M22, Q2, c1, c2,  B0T
      double precision pi, is, ix(2)
      double complex cI,x(2),y(2),a,b,c, CPLOG

      Pi   = 3.1415926535897932384626433832795029D0
      cI=dcmplx(0.,1.)
      c1= M12; c2=M22
      is =-1d0
      if (P2.eq.0D0) then
         B0P=   B0T(c1,c2,Q2)
         return
      else
         if ( c1.eq.0D0 .AND. c2.gt.0D0) then
           if (c2.eq.p2) then
            x(1)=0
            x(2)=0
            B0P = 2 - Log(p2/q2)
           else
            x(1)=0 
            x(2)=1.- c2/p2
            ix(2) =- is/x(2)
        B0P=-Log(p2/q2)-(Log(c2/p2)-x(2)*CPLOG(1d0-1d0/x(2),ix(2))-2d0)
           endif

         elseif ( c1.gt.0D0 .AND. c2.eq.0D0) then
           if (c1.eq.p2) then
            B0P = 2 - Log(p2/q2)
           else
            x(1)=0 
            x(2)=1.- c1/p2
            ix(2) = -is/x(2)
         B0P=-Log(p2/q2)-(Log(c1/p2)- x(2)*CPLOG(1.-1./x(2),ix(2))-2.)
           endif
         elseif(c1.eq.0d0 .AND. c2.eq.0d0) then
            x(1)=0; x(2) =1; ix(2)=- is
            B0P = -(Log(p2/q2) - 2 )+ cI*pi
         else
            a= p2
            b=(-p2 +c2-c1)
            c=c1

            call CYPRoot2(a,b,c, is, x, ix)

            B0P=-log(p2/q2)-(CPLOG(1-x(1),-ix(1))-x(1)*
     -          CPLOG(1.-1/x(1),ix(1))-1.)- ( CPLOG(1.- x(2),-ix(2)) - 
     -          x(2)*CPLOG(1.-1./x(2),ix(2))- 1.)

         endif
         
      endif
           
      end

*
***********************************************************************
*

      double complex function B1P(P2,M12,M22,Q2)
      double precision P2, M12, M22, Q2, c1, c2,  B0T, A0T
      double precision pi, is, ix(2)
      double complex cI,x(2),y(2),a,b,c, CPLOG,B0P

      Pi   = 3.1415926535897932384626433832795029D0
      cI=dcmplx(0.,1.)
      c1= M12; c2=M22
      is =-1d0
      if (P2.eq.0D0) then
         if (c1.eq.0D0.AND. c2.gt.0D0) then
          x(2) =0; ix(2) = -is/(c2)
          B1P=-0.5D0* ( Log(q2/c2)  ) -0.25D0
         elseif (c2.eq.0D0.AND. c1.gt.0D0) then
          B1P=-0.5D0* ( Log(q2/c1)  ) -0.25D0         
         elseif (c2.eq.0D0.AND. c1.eq.0D0) then
           B1P=0D0
         elseif (abs(c1-c2).le.1D-10) then
           B1P=-0.5D0* ( Log(q2/c1))
         else
          x(2) =-c1/(c2-c1);ix(2) = -is/(c2-c1)
          B1P=-0.5D0* ( Log(q2/c1)  -CPLOG(1.-1/x(2), ix(2)) +
     -          1/3D0/x(2) + 1/4D0/(x(2)**2) +1/5D0/(x(2)**3)+
     -          1/6D0/(x(2)**4)+ 1/7D0/(x(2)**5)  )
         endif        
         return
      else
         if ( c1.eq.0D0 .AND. c2.gt.0D0) then
           if (c2.eq.p2) then
            B1P =-0.5D0*(1- Log(p2/q2))
           else
            B1P=((c2-p2)* B0P(p2,0D0,c2,q2) - A0T(c2,q2) )/(2D0*p2)
           endif

         elseif ( c1.gt.0D0 .AND. c2.eq.0D0) then
           if (c1.eq.p2) then
            B1P = -0.5D0*(1- Log(p2/q2))-1D0
           else

            B1P=(-(c1+p2)* B0P(p2,0D0,c1,q2) + A0T(c1,q2) )/(2D0*p2)
           endif
         elseif(c1.eq.0d0 .AND. c2.eq.0d0) then
            x(1)=0; x(2) =1; ix(2)=- is
            B1P =-0.5D0*( -(Log(p2/q2) - 2 )+ cI*pi)
         else
            B1P =-0.5d0*(( p2+c1-c2)*B0P(p2,c1,c2,q2)-A0T(c1,q2)+
     -           A0T(c2,q2))/(p2)
         endif
         
      endif
           
      end
*
***********************************************************************
*

      double complex function B1EpP(P2,M12,M22,Q2)
      implicit none
      double precision P2, M12, M22, Q2, c1, c2, AEpT
      double complex BEpP

      c1= M12; c2=M22
      if (P2.eq.0D0) then
         B1EpP=0D0 ! this situation have not been evaluated
         return
      else
         if ( c1.eq.0D0 .AND. c2.gt.0D0) then
            B1EpP=((c2-p2)* BEpP(p2,0D0,c2,q2)- AEpT(c2,q2) )/(2D0*p2)
         elseif ( c1.gt.0D0 .AND. c2.eq.0D0) then
            B1EpP=(-(c1+p2)* BEpP(p2,0D0,c1,q2)+ AEpT(c1,q2) )/(2D0*p2)
         elseif(c1.eq.0d0 .AND. c2.eq.0d0) then
            B1EpP= (- BEpP(p2,0D0,0D0,q2)  )/(2D0)
         else
            B1EpP=-0.5d0*((p2+c1-c2)*BEpP(p2,c1,c2,q2)-AEpT(c1,q2)
     &            +AEpT(c2,q2))/(p2)

         endif
         
      endif
           
      end

*
***********************************************************************
*
* e.q 1.6 in Z. Phys. C57, 605-613 U. Nierste 1992
* this has been check against mathematica within agreement
* keep in mind that in mathematica one needs to introduce a small negative imaginary part
* in the Log

      double complex function BEpP(P2,M12,M22,Q2)
      implicit none
      double precision P2, M12, M22, Q2, c1, c2,  BEpT
      double precision Pi, Zeta2, is,ix(2),dx(2)
      double complex cI,x(2),y(2),a,b,c, B0P,CPLOG,CPSp

      Pi   = 3.1415926535897932384626433832795029D0
      Zeta2= Pi**2/6.
      c1= M12; c2=M22
      cI=dcmplx(0.,1.)
      is =-1d0
      if (P2.eq.0D0) then
         BEpP=   BEpT(c1,c2,Q2)
         return
      else
         if ( c1.eq.0D0 .AND. c2.gt.0D0) then
           if (c2.eq.p2) then
            x(1)=0
            x(2)=0

            BEpP= 0.5D0*Zeta2 + 0.5D0* Log(p2/q2)*Log(p2/q2)
     -       - (Log(p2/q2)-2.)*( 2 )

           else
            x(1)=0
            x(2)=1-c2/p2
            ix(2) = -is/x(2)

            BEpP= 0.5D0*Zeta2 + 0.5D0* Log(p2/q2)*Log(p2/q2)
     -       - (Log(p2/q2)-2.)*(B0P(p2,c1,c2,q2) + Log(p2/q2) )
     -       +0.5D0*(1- x(2))*CPLOG(1-x(2),-ix(2))*CPLOG(1-x(2),-ix(2))
     -       +0.5D0*x(2)*CPLOG(-x(2), -ix(2))*CPLOG(-x(2), -ix(2))
     -       +(- x(2))*( CPLOG(x(2), ix(2))*CPLOG((x(2)-1.)/x(2),ix(2)) 
     -       +Zeta2- CPSp((x(2)-1)/(x(2)) , ix(2))  ) 
           endif

         elseif ( c1.gt.0D0 .AND. c2.eq.0D0) then
           if (c1.eq.p2) then
            x(1) =0
            x(2) =0
            BEpP= 0.5D0*Zeta2 + 0.5D0* Log(p2/q2)*Log(p2/q2)
     -       - (Log(p2/q2)-2.)*( 2 )
           else
            x(1)=0
            x(2)=1-c1/p2
            ix(2) =- is/x(2)
            BEpP= 0.5D0*Zeta2 + 0.5D0* Log(p2/q2)*Log(p2/q2)
     -       - (Log(p2/q2)-2.)*(B0P(p2,c1,c2,q2) + Log(p2/q2) )+0.5D0*
     -       (1.-x(2))*CPLOG(1.-x(2),-ix(2))*CPLOG(1.-x(2),-ix(2))
     -       +0.5D0*x(2)*CPLOG(-x(2), -ix(2))*CPLOG(-x(2), -ix(2))+(
     -       - x(2))*( CPLOG(x(2), ix(2))* CPLOG((x(2)-1.)/x(2),ix(2)) 
     -       +Zeta2- CPSp((x(2)-1.)/(x(2)) , ix(2))  ) 
           endif
         elseif(c1.eq.0d0 .AND. c2.eq.0d0) then
            x(1)=0;ix(1)=is; x(2)=1D0; ix(2) =-is
            dx(1)=DBLE(x(1))
            dx(2)=DBLE(x(2))
            BEpP= 0.5D0*Zeta2 + 0.5D0* Log(p2/q2)*Log(p2/q2)
     -       -(Log(p2/q2)-2.)*(  2. + cI*pi  )+0.5D0*x(2)*
     -       CPLOG(-x(2), -ix(2))*CPLOG(-x(2), -ix(2))+(- x(2))*
     -       (CPSp(dcmplx(1D0,0D0), dx(2)*ix(1)-dx(1)*ix(2))-
     -       CPSp((x(2)-1.)/(x(2)),dx(2)*ix(1)-dx(1)*ix(2)-ix(1)+ix(2)))
         else
            a= p2
            b=(-p2 +c2-c1)
            c=c1
            call CYPRoot2(a,b,c, is, x, ix)
            y(1)= x(2)/(x(2)-x(1))
            y(2)= (x(2)-1.)/(x(2)-x(1)) 
            dx(1)=DBLE(x(1))
            dx(2)=DBLE(x(2))

            BEpP = 0.5D0*Zeta2 + 0.5D0* Log(p2/q2)*Log(p2/q2)
     -       - (Log(p2/q2)-2.)*(B0P(p2,c1,c2,q2) + Log(p2/q2) )+0.5D0*
     -       (1.- x(1))*CPLOG((1.-x(1)),-ix(1))*CPLOG((1.-x(1)),-ix(1))
     -       +0.5D0*x(1)*CPLOG(-x(1),-ix(1))*CPLOG(-x(1), -ix(1))+0.5D0
     -       *(1.- x(2))*CPLOG(1.-x(2),-ix(2))*CPLOG(1.-x(2),-ix(2))
     -       +0.5D0*x(2)*CPLOG(-x(2), -ix(2))*CPLOG(-x(2), -ix(2))
     -       + (1.- x(1))*CPLOG(1.-x(1),-ix(1))*CPLOG(1.-x(2),-ix(2))
     -       + x(1)*CPLOG(-x(1), -ix(1))*CPLOG(-x(2),-ix(2))
     -       + (x(1)- x(2))*(CPLOG(x(2)-x(1), ix(2))* 
     -       CPLOG((x(2)-1.)/x(2), ix(2)) 
     -       + CPSp(y(1),dx(2)*ix(1)-dx(1)*ix(2))
     -       - CPSp(y(2),dx(2)*ix(1)-dx(1)*ix(2)-ix(1)+ix(2))  )
         endif       
      endif
           
      end
************************************************************************
	subroutine CYPRoot2(a, b, c, is, x, ix)
************************************************************************
* a part of Ninh's code
* Find the 2 roots of the equation: a*x^2 + b*x + c + is*I = 0
* where "is" is infinitesimal, Ref0. Eq. (A.2).
* Input: a, b, c are complex; "is" is real.
* Output: x(2) and ix(2).
************************************************************************
	implicit none
	double complex x(2),a, b, c, d
	double precision  is, ix(2)

	if ( abs(a) .le. 0 ) then
	 print*,'Error in CYPRoot2: a vanishes, STOP'
	 stop
	endif

	ix(1) = is

	if ( abs(c) .le. 0) then
	x(1) = 0
	x(2) = -b/a
	d = sqrt(b**2)
	if ( DBLE(d) .lt. 0 ) ix(1) = -ix(1) 

	else
	d = b**2 - 4*a*c
	d = sqrt(d)
	x(1) = (-b - d)/(2*a)
	x(2) = (-b + d)/(2*a)
	if ( DBLE(d) .lt. 0 ) ix(1) = -ix(1) 
	
	if ( abs(x(1)) .lt. abs(x(2)) ) then
	 x(1) = c/a/x(2)
	else
	 x(2) = c/a/x(1)
	endif 
	 
	endif

	ix(2) = -ix(1)


	end

	double complex function CPLOG(x, is)
************************************************************************
* Def. Log(x + i*is) where "is" is infinitesimal.
* Author: Le Duc Ninh (2011)
************************************************************************
	implicit none
	double precision is,pi
	double complex x, cipi
        Pi   = 3.1415926535897932384626433832795029D0
        cipi = dcmplx(0D0, pi)

	CPLOG = 0

***[singular cases
	if (abs(x) .le. 0) then
	 print*,'Error in CPLOG(): log(0) encountered, return 0'
         return
	endif
***]singular cases

	if (DIMAG(x) .eq. 0) then
	 if (DBLE(x) .gt. 0) then
	  CPLOG = log(x)
	 else
	  CPLOG = log(-x) + cipi*is/abs(is)
	 endif 	
	else
	CPLOG = log(x)	
	endif
	end

************************************************************************
	double complex function CPSp(x, is)
************************************************************************
* Computes the dilogarithm (Li2 or Sp) for any (complex) x 	
* to a precision prec.
* Author: Le Duc Ninh (2011)
************************************************************************
	implicit none
	double complex x, CPSp1, CPLOG
	double precision is,pi
	external CPSp1, CPLOG
        Pi   = 3.1415926535897932384626433832795029D0
	CPSp = 0

***[special cases
	if ( abs(x-1) .le. 0 ) then 
	 CPSp = pi**2/6D0 
	 return
	endif  

	if ( abs(x-1) .le. epsi ) then 
	 CPSp = -(1-x) + pi**2/6D0 - CPLOG(x, is)*CPLOG(1-x, -is) 
	 return
	endif  
***]special cases

	if ( abs(x) .le. 1 .and. DBLE(x) .le. 0.5D0 ) then 
	 CPSp = CPSp1(x, is)
	elseif ( abs(x) .gt. 1 .and. DBLE(x) .le. 0.5D0 ) then
	 CPSp = -CPSp1(1/x, -is) - pi**2/6D0 - CPLOG(-x, -is)**2/2
	
	elseif ( abs(x) .le. 1 .and. DBLE(x) .gt. 0.5D0 ) then
	 CPSp = -CPSp1(1-x, -is) + pi**2/6D0 
     &	  - CPLOG(x, is)*CPLOG(1-x, -is) 

	else
* here we have |x| > 1 AND Re(x) > 0.5	
	 if ( DBLE(1/x) .le. 0.5D0 ) then
	  CPSp = -CPSp1(1/x, -is) - pi**2/6D0 - CPLOG(-x, -is)**2/2
	 else
	  CPSp = -CPSp1(1-x, -is) + pi**2/6D0 
     &	  - CPLOG(x, is)*CPLOG(1-x, -is) 
         endif
	 
	endif

	end

************************************************************************
	double complex function CPSp1(x, is)
************************************************************************
* Computes the dilogarithm (Li2 or Sp) for complex x with 
* |x| <= 1 and Re(x) <= 0.5 to a precision epsi.
* Ref0. 't Hooft and Veltman, Nucl. Phys. B153 (1979) 365.
* Author: Le Duc Ninh (2011)
************************************************************************
	implicit none
	integer i, init, nn
	save init
	data init /0/
        parameter(nn = 60)
	double complex x, z, CPLOG, ctemp
	double precision is, bern(nn), temp,pi
	external CPLOG
        Pi   = 3.1415926535897932384626433832795029D0
	CPSp1 = 0
	if ( abs(x) .gt. 1 .or. DBLE(x) .gt. 0.5D0 ) then 
	 print*,'Error in CPSp11(): invalid input, STOP'
	 stop
	endif 

***[special cases
	if ( abs(x) .le. epsi ) then 
	 CPSp1 = x
	 return
	endif  

	if ( abs(x-0.5D0) .le. 0 ) then 
	 CPSp1 = pi**2/12D0 - log(2D0)**2/2D0 
	 return
	endif
***]special cases

***[Bernouilli numbers
c        if (init .eq. 0) then
c        init = 1

        do i = 3, nn-1, 2
          bern(i) = 0
        enddo

        bern( 1) = -1D0/2D0
        bern( 2) =  1D0/6D0
        bern( 4) = -1D0/30D0
        bern( 6) =  1D0/42D0
        bern( 8) = -1D0/30D0
        bern(10) =  5D0/66D0
        bern(12) = -691D0/2730D0
        bern(14) =  7D0/6D0
        bern(16) = -3617D0/510D0
        bern(18) =  43867D0/798D0
        bern(20) = -174611D0/330D0
        bern(22) =  854513D0/138D0
        bern(24) = -236364091D0/2730D0
        bern(26) =  8553103D0/6D0
        bern(28) = -23749461029D0/870D0
        bern(30) =  8615841276005D0/14322D0
        bern(32) = -7709321041217D0/510D0
        bern(34) =  2577687858367D0/6D0
        bern(36) = -26315271553053477373D0/1919190D0
        bern(38) =  2929993913841559D0/6D0
        bern(40) = -261082718496449122051D0/13530D0

	bern(42) = 1520097643918070802691D0/1806D0
	bern(44) = -27833269579301024235023D0/690D0
	bern(46) = 596451111593912163277961D0/282D0
	bern(48) = -5609403368997817686249127547D0/46410D0
	bern(50) = 495057205241079648212477525D0/66D0
	bern(52) = -801165718135489957347924991853D0/1590D0
	bern(54) = 29149963634884862421418123812691D0/798D0
	bern(56) = -2479392929313226753685415739663229D0/870D0
	bern(58) = 84483613348880041862046775994036021D0/354D0
	bern(60) = -1215233140483755572040304994079820246041491D0/
     &   56786730D0
c        endif
***]Bernouilli numbers

	z = -CPLOG(1 - x, -is)
	ctemp = bern(1)*z**2/2D0
	CPSp1 = z + ctemp 
c        print*, CPSp1, x, ctemp, bern(1),z**2,1/2D0
      
        i = 0
	temp = 1

	do while ( abs(ctemp) .gt. epsi )
	 i = i + 2

c	print*,'From CPSp1(): i, z, ctemp =', i, z, ctemp

	 if ( i .gt. nn) then 
	  print*,'Error in CPSp1(): 
     &	  Bernouilli series is too short, return at', nn
	  ctemp = 0
	 
	 else
	  temp = temp*i*(i+1)
	  ctemp = bern(i)*z**(i + 1)/temp	  
	 endif  

	CPSp1 = CPSp1 + ctemp
	enddo

	end

*
***********************************************************************
*
      double precision function C0T(Mass12,Mass22,Mass32,Q2)
      double precision Mass12,Mass22,Mass32,x, y, z, Q2,C
      double precision B0T
       double precision regMass2,regmass,logX,logx2,xinverse,xinverse2
       common/regularmass/regMass2,regMass,logX,logx2,xinverse,xinverse2
        x=Mass12
        y=Mass22
        z=Mass32
   
       if (z.lt.y) then
          c=z; z=y; y=c
       endif  
 
       if(z.lt.x) then
        c=z;        z=x;        x=c
       endif
 
       if(y.lt.x) then
        c=y; y=x; x=c
       endif
      if (abs(z-x) .gt. 0D0) then
       C0T =(B0T(x,y,Q2)-B0T(y,z,Q2))/(x-z)
      else
        if(abs(y-x) .gt. 0D0)then
       C0T =(B0T(x,z,Q2)-B0T(y,z,Q2))/(x-y)
        else
        if(z.gt.epsi)then
       C0T=-0.5D0/z
        else
       C0T=-0.5D0*xinverse
        endif
        endif
      endif


      return
      end
*
***********************************************************************
*
      
      double precision function CEpT(Mass12,Mass22,Mass32,Q2)
      double precision Mass12,Mass22,Mass32, x, y, z, Q2,C
      double precision BEpT
       double precision regMass2,regmass,logX,logx2,xinverse,xinverse2
       common/regularmass/regMass2,regMass,logX,logx2,xinverse,xinverse2
        x=Mass12
        y=Mass22
        z=Mass32

       if (z.lt.y) then
          c=z; z=y; y=c
       endif  
 
       if(z.lt.x) then
        c=z;        z=x;        x=c
       endif
 
       if(y.lt.x) then
        c=y; y=x; x=c
       endif

      if (abs(z-x) .gt. 0D0) then
       CEpT =(BEpT(x,y,Q2)-BEpT(y,z,Q2))/(x-z)
      else
        if(abs(y-x) .gt. 0D0)then
       CEpT =(BEpT(x,z,Q2)-BEpT(y,z,Q2))/(x-y)
        else
        if(z.gt.epsi)then
       CEpT=0.5D0* Log(z/Q2)/z
        else
       CEpT=0.5D0* logx*xinverse
        endif
        endif
      endif

      return
      end
*
***********************************************************************
*
** note that this formula are of 2.34 of hep-ph/0501132 but difference
* in sign for AepT and A0T 

      double complex function K0T0(Mass12,Mass22,Mass32,Q2)
      double precision Mass12,Mass22,Mass32,x, y, z, Q2
      double precision res1,c
      double precision AEpT,I0N
      double complex EtaN,res2
        x=Mass12
        y=Mass22
        z=Mass32
       res1= -AEpT(x,Q2)- AEpT(y,Q2)- AEpT(z,Q2)

       if (z.lt.y) then
          c=z; z=y; y=c
       endif  

       if(z.lt.x) then
        c=z; z=x; x=c
       endif

       if(y.lt.x) then
        c=y; y=x; x=c
       endif
       res2 = I0N(x,y,z,Q2)
       K0T0= (res1+res2)
      return
      end

*
***********************************************************************
*
      double complex function SKK(s,Mass12,Mass22,Mass32,Q2)
      double precision Mass12,Mass22,Mass32,s, x, y,z,c,Q2,ix1,ix2
      double precision I0N,Zeta2,pi
      double complex CPSp,CPLOG
       ix1=1D0; ix2=-1D0
       pi= 3.1415926535897932384626433832795029D0
       Zeta2= pi**2/6D0
        x=Mass12
        y=Mass22
        z=Mass32
       if (z.lt.y) then
          c=z; z=y; y=c
       endif  
       if(z.lt.x) then
        c=z; z=x; x=c
       endif
       if(y.lt.x) then
        c=y; y=x; x=c
       endif

c[special case s=0
       if(s.le.epsi) then
        SKK= I0N(x,y,z,Q2)
       endif
c]
c[special case x=y=z=0
       if(x.eq.0D0 .AND. y.eq.0D0 .AND. z.eq.0D0) then
          SKK= -13*s/8D0 +s/2D0*Log(s/Q2)
          goto 99
       endif
c]
 
c[special case x=y=z=0
       if(x.eq.0D0 .AND. y.eq.0D0 .AND. z.gt.0D0) then
          SKK=(13*s)/8. - z*(2 + Zeta2) + ((-s**2 + z**2)
     -        *CPLog(dcmplx(1 - s/z,0D0),-ix1))/(2.*s)+ (-s/2. + 2*z)*
     -        Log(z/Q2)-z*(Log(z/Q2)**2/2.+CPSp(dcmplx(s/z,0D0),ix1))
          goto 99
       endif
c]      

99      return
      end

*
***********************************************************************
*
      double complex function TKK(s,Mass12,Mass22,Mass32,Q2)
      double precision Mass12,Mass22,Mass32,s, x, y,z,Q2,ix1,ix2
      double precision Zeta2,pi
      double complex CPSp,CPLOG
       ix1=1D0; ix2=-1D0
       pi= 3.1415926535897932384626433832795029D0
       Zeta2= pi**2/6D0
        x=Mass12
        y=Mass22
        z=Mass32

c[special case s=0
       if(s.le.epsi) then
        if (z.eq.0) then
          if(abs(x-y).eq.0D0) then
          TKK= -(1/2D0)*(Log(x/Q2)-1)**2
          else
          TKK=-0.5 - Zeta2 + 2*Log(x/Q2) + Log(x/Q2)**2/2.
     -    -CPLog(dcmplx((x - y)/Q2,0D0),ix2)*Log(x/y)- Log(y/Q2) 
     -    -Log(x/Q2)*Log(y/Q2) + (x - y)*(Log(x/Q2)/x - 
     -    CPLog(dcmplx((x - y)/Q2,0D0), ix2)/x- Log(x/y)/(x-y)+
     -    CPLog(dcmplx(1-y/x,0D0),ix2)/x) 
     -    + CPSp(dcmplx(y/x,0D0), ix1)
          endif
        endif
        goto 99
       endif
c]
99      return
      end
*
***********************************************************************
*
      double precision function K0T0N(Mass12,Mass22,Mass32,aet1,aet2,
     &              aet3,Q2)
      double precision Mass12,Mass22,Mass32,x, y, z,Q2,aet1,aet2,aet3
      double precision res1,c,I0N,res2
        x=Mass12
        y=Mass22
        z=Mass32
       res1= -aet1-aet2-aet3
       if (z.lt.y) then
          c=z; z=y; y=c
       endif  
       if(z.lt.x) then
        c=z; z=x; x=c
       endif
       if(y.lt.x) then
        c=y; y=x; x=c
       endif
       res2 = I0N(x,y,z,Q2)
       K0T0N= (res1+res2)
      return
      end


*
***********************************************************************
*
      double precision function K0T1(M12,M22,M32,Q2)
      double precision M12, M22, M32, Q2
      double precision A0T
       K0T1=( -A0T(M12,Q2)- A0T(M22,Q2)-A0T(M32,Q2)-0.5D0*(M12+M22+M32))
      end
*
***********************************************************************
*
      double precision function K0T2(M12,M22,M32,Q2)
      double precision M12, M22, M32, Q2
       K0T2= -0.5D0*(M12+M22+M32)
      end

*
***********************************************************************
*
      double precision function LambdaN(x,y,z)
      double precision x,y,z
       LambdaN=x**2+y**2+z**2-2*x*y-2*x*z-2*y*z

      end
*
***********************************************************************
*
      double complex function EtaN(Mass12,Mass22,Mass32)
      double precision Mass12,Mass22,Mass32,x,y,z,c,pi,pi2,LambdaN
     .  ,alambda,is
      double complex CPSp,R, CPLOG
       x= Mass12
       y= Mass22
       z= Mass32
       alambda=LambdaN(x,y,z)
       if (alambda .ge. 0D0) then
        R=sqrt(alambda)
       else
        R=dcmplx(0.,Sqrt(-alambda))
       endif
        is=-1
       pi= 3.1415926535897932384626433832795029D0
       pi2=pi**2
       if (z.lt.y) then
          c=z; z=y; y=c
       endif  

       if(z.lt.x) then
        c=z; z=x; x=c
       endif
       EtaN= R*( 2.* Log((z+x-y-R)/(2.*z))*Log((z+y-x-R)/(2.*z)) -
     -     Log(x/z)*Log(y/z) - 2.*CPSp((z+x-y-R)/(2.*z),is) 
     -     -2.* CPSp((z+y-x-R)/(2.*z), is) + Pi2/3.)

      end
*
***********************************************************************
*
      double precision function I0N(x,y,z,Q2)
      double precision x,y,z,c,pi,pi2,LambdaN
     .  ,alambda,is,EtaN,Q2
      double complex CPSp,R, CPLOG

       is=-1
       pi= 3.1415926535897932384626433832795029D0
       pi2=pi**2



      if(x.gt.epsi)then
       alambda=LambdaN(x,y,z)
       if (alambda .ge. 0D0) then
        R=sqrt(alambda)
       else
        R=dcmplx(0.,Sqrt(-alambda))
       endif

       EtaN= R*( 2.* Log((z+x-y-R)/(2.*z))*Log((z+y-x-R)/(2.*z)) -
     -     Log(x/z)*Log(y/z) - 2.*CPSp((z+x-y-R)/(2.*z),is) 
     -     -2.* CPSp((z+y-x-R)/(2.*z), is) + Pi2/3.)
       I0N= 0.5D0*(x-y-z)* Log(y/Q2)*Log(z/Q2) +
     -         0.5D0*(y-x-z)* Log(x/Q2)*Log(z/Q2) +
     -         0.5D0*(z-x-y)* Log(x/Q2)*Log(y/Q2) +
     -         2*x*Log(x/Q2) + 2*y*Log(y/Q2)+2*z*Log(z/Q2)
     -         -2.5D0*(x+y+z)-0.5D0*EtaN
      else
       if(z.gt.epsi)then
        if ( (z-y)/z .gt. epsi ) then
         if (y .gt. epsi) then
         I0N= (z-y)*( CPsp(dcmplx(y/z,0d0),1D0)-Log(z/y)*Log((z-y)/q2) 
     -    +0.5D0*Log(z/q2)**2- pi2/6D0) - 2.5D0* (z+y) + 2*z*Log(z/q2)
     -    + 2*y*Log(y/q2) -z*Log(z/q2)*Log(y/q2)

         else
         I0N= -0.5D0 *z*Log(z/q2)**2+ 2*z*Log(z/q2)-2.5D0*z-pi2/6D0*z
         endif
        else
         if (z.gt.epsi) then
         I0N = -z*Log(z/q2)**2 + 4.*z* Log(z/q2) - 5*z 
         else
         I0N=0
         endif
        endif
       else
         I0N=0D0
       endif
      endif
      end
*
***********************************************************************
*
      double precision function I0A(Mass12,Mass22,Mass32,Q2)
      double precision x,y,z,c,pi,pi2,LambdaN
     .  ,alambda,is,EtaN,Q2,Mass12,Mass22,Mass32
      double complex CPSp,R, CPLOG

        x=Mass12
        y=Mass22
        z=Mass32

       if (z.lt.y) then
          c=z; z=y; y=c
       endif  
       if(z.lt.x) then
        c=z; z=x; x=c
       endif
       if(y.lt.x) then
        c=y; y=x; x=c
       endif

       is=-1
       pi= 3.1415926535897932384626433832795029D0
       pi2=pi**2

      if(x.gt.0)then
       alambda=LambdaN(x,y,z)
       if (alambda .ge. 0D0) then
        R=sqrt(alambda)
       else
        R=dcmplx(0.,Sqrt(-alambda))
       endif

       EtaN= R*( 2.* Log((z+x-y-R)/(2.*z))*Log((z+y-x-R)/(2.*z)) -
     -     Log(x/z)*Log(y/z) - 2.*CPSp((z+x-y-R)/(2.*z),is) 
     -     -2.* CPSp((z+y-x-R)/(2.*z), is) + Pi2/3.)
       I0A= 0.5D0*(x-y-z)* Log(y/Q2)*Log(z/Q2) +
     -         0.5D0*(y-x-z)* Log(x/Q2)*Log(z/Q2) +
     -         0.5D0*(z-x-y)* Log(x/Q2)*Log(y/Q2) +
     -         2*x*Log(x/Q2) + 2*y*Log(y/Q2)+2*z*Log(z/Q2)
     -         -2.5D0*(x+y+z)-0.5D0*EtaN
      else
       if ( (z-y)/z .gt. 0D0 ) then
         if (y .gt. 0D0) then
         I0A= (z-y)*( CPsp(dcmplx(y/z,0d0),1D0)-Log(z/y)*Log((z-y)/q2) 
     -    +0.5D0*Log(z/q2)**2- pi2/6D0) - 2.5D0* (z+y) + 2*z*Log(z/q2)
     -    + 2*y*Log(y/q2) -z*Log(z/q2)*Log(y/q2)

         else
         I0A= -0.5D0 *z*Log(z/q2)**2+ 2*z*Log(z/q2)-2.5D0*z-pi2/6D0*z
         endif
       else
         if (z.gt.0D0) then
         I0A = -z*Log(z/q2)**2 + 4.*z* Log(z/q2) - 5*z 
         else
         I0A=0
         endif
       endif

      endif
      end

*
***********************************************************************
*
*(assume x>=y I(x,y)=I(y,x))

      double precision function I0(x,y,q2)
      double precision x, y, q2,c, pi, pi2
      double complex CPsp
       pi= 3.1415926535897932384626433832795029D0
       pi2=pi**2/6D0
       if ( (x-y)/x .gt. 0D0 ) then
         if (y .gt. 0D0) then
         I0= (x-y)*( CPsp(dcmplx(y/x,0D0),1D0) - Log(x/y)*Log((x-y)/q2) 
     -    +0.5D0*Log(x/q2)**2- pi2) - 2.5D0* (x+y) + 2*x*Log(x/q2)
     -    + 2*y*Log(y/q2) -x*Log(x/q2)*Log(y/q2)
         else
         I0= -0.5D0 * x * Log(x/q2)**2 + 2* x* Log(x/q2)- 2.5D0*x - pi2*x
         endif
       else
         if (x.gt.0D0) then
         I0 = -x*Log(x/q2)**2 + 4.*x* Log(x/q2) - 5*x 
         else
         I0=0
         endif
       endif
      end

*
***********************************************************************
*
      
      double precision function D0T(Mass12,Mass22,Mass32,Mass42,Q2)
      implicit none
      double precision Mass12,Mass22,Mass32,Mass42,x,y,z,t,Q2,C
      double precision C0T
        x=Mass12;        y=Mass22;        z=Mass32;        t=Mass42

       if (t.lt.z) then
          c=t; t=z; z=c
       endif  
        
       if (t.lt.y) then
          c=t; t=y; y=c
       endif  
 
       if(t.lt.x) then
        c=t;        t=x;        x=c
       endif
 

       if(z.lt.y) then
        c=z; z=y; y=c
       endif
       if(z.lt.x) then
        c=z; z=x; x=c
       endif

       if(y.lt.x) then
        c=y; y=x; x=c
       endif



      if (abs(t-x) .gt. 0D0) then

       D0T =(C0T(y,z,t,Q2)-C0T(x,y,z,Q2))/(t-x)


      else
       D0T=1D0/6D0/t**2

      endif


      return
      end

*
***********************************************************************
*
      
      double precision function DEpT(Mass12,Mass22,Mass32,Mass42,Q2)
      implicit none
      double precision Mass12,Mass22,Mass32,Mass42,x,y,z,t,Q2,C
      double precision CEpT
        x=Mass12;        y=Mass22;        z=Mass32;        t=Mass42

       if (t.lt.z) then
          c=t; t=z; z=c
       endif  
        
       if (t.lt.y) then
          c=t; t=y; y=c
       endif  
 
       if(t.lt.x) then
        c=t;        t=x;        x=c
       endif 

       if(z.lt.y) then
        c=z; z=y; y=c
       endif
       if(z.lt.x) then
        c=z; z=x; x=c
       endif

       if(y.lt.x) then
        c=y; y=x; x=c
       endif

      if (abs(t-x) .gt. 0D0) then

       DEpT =(CEpT(t,y,z,Q2)-CEpT(x,y,z,Q2))/(t-x)
      else
       DEpT=1./6./t**2*(1- Log(t/Q2) )
      endif


      return
      end


*
***********************************************************************
*
c Input: M1**2, M2**2, M3**3, Q2.
c output: coef(5) coresponding to 
c     F^D00000_({1,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(1),
c     F^D00001_({1,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(2),  
c     F^D01000_({1,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(3),  
c     F^D10000_({1,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(4),
c     F^D10001_({1,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(5),
c     F^D11000_({1,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(6),
c     F^D00002_({1,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(7),
c     F^D01001_({1,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(8),
c     F^D02000_({1,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(9),
c     F^D20000_({1,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(10),

      subroutine FD111C(Mass22,Mass12,Mass32,a0t2,a0t1,a0t3,aet2,aet1,
     .                  aet3,Q2,coef,id)
      implicit none
      integer id
      double precision Mass22,Mass12,Mass32 
      double precision M12,M22,M32, Q2
      double precision M14,M24,M34,M16,M26,M36,M18,M28,M38
      double precision abr1,abr2,abr3,abr4,
     .   a0t1,a0t2,a0t3,aet1,aet2,aet3
      double precision lambdaN, A0T, AEpT
      double precision K0T0N,coef(10),ak0t0

      M12= Mass12; M22=Mass22; M32=Mass32
      M14=M12**2;  M24=M22**2 ; M34=M32**2
      M16=M12*M14; M26=M22*M24; M36=M32*M34
      M18=M14**2;  M28=M24**2;  M38=M34**2

      abr1=(M12 + M22 - M32);abr2=(M12 + M22 + M32)
      abr3=(M12 - M22 - M32);abr4=(M12 - M22 + M32)

      if(id.eq.2) then
       coef(1)=(-M12 - M22 - M32)/2.
       coef(2)=(-M14 - M24 - 2*M12*M32 - 2*M22*M32 + M34)/4.

       coef(3)=-(abr2*M12)/2. - M22*M32
       coef(4)=-(abr2*M22)/2. - M12*M32
       coef(5)=(-M26 - 2*M12*M22*M32 - 2*M24*M32 - M14*(M22 + 4*M32) 
     -  + M22*M34)/4. 
       coef(6)=(-2*M24*M32 - M14*(M22 + 2*M32)-M12*(M24 + M22*M32))/2.  
       coef(7)=(-M16-M26-5*M24*M32-M14*(M22+5*M32)-M12*(M24+4*M22*M32-
     &  3*M34)+3*M22*M34-M36)/8.
       coef(8)=(-M16-2*(M14+2*M24)*M32+M12*(-M24-2*M22*M32+M34))/4.
       coef(9)=-(abr2*M14)/2. - M12*M22*M32 - M24*M32 - M22*M34
       coef(10)=-(M12**2*M32)-M12*M22*M32-M12*M32**2-(M22**2*(M12+M22+M32))/2.       
      else
       if(id.eq.1) then 
       coef(1)=(-2*a0t1 - 2*a0t2 - 2*a0t3 - M12 - M22 - M32)/2.
       coef(2)=(-2*a0t1*M12 - M14 - 2*a0t2*M22 - 2*M12*M22 - M24 + 
     -  a0t3*(-4*M12 - 4*M22 + 2*M32) + M34)/4.

       coef(3)=-(a0t1*M12) - a0t3*M12 - (abr2*M12)/2. - a0t3*M22 -
     -  a0t2*(M12 + M32)
       coef(4)=-((2*a0t2 + abr2)*M22)/2. - a0t3*(M12 + M22) - 
     -  a0t1*(M22 + M32)
       coef(5)=(-2*a0t1*M12*(M22 + 2*M32) - 2*a0t3*(2*M14 + 2*M12*M22 
     -    + 2*M24 - M22*M32) - M22*(M14 + 2*a0t2*M22 + 2*M12*M22 + M24
     -    - M34))/4.
       coef(6)=a0t3*(-M14 - M12*M22 - M24) - a0t2*M22*(M12 + M32) - 
     -  a0t1*M12*(M22 + M32) + (-(M14*M22) - M12*(M24 + M22*M32))/2.
       coef(7)=(-(abr1**2*abr2)-2*(a0t1*abr2*M12+a0t2*abr2*M22+a0t3*(4
     &  *M14+4*M12*M22+4*M24-3*M12*M32-3*M22*M32+M34)))/8.
       coef(8)=(-2*a0t1*M14-2*a0t2*M22*(M12+2*M32)-2*a0t3*(2*M14+2*M12
     &  *M22+2*M24-M12*M32)-M12*(M14+2*M12*M22+M24-M34))/4.
       coef(9)=-(a0t1*M14)-(abr2*M14)/2.-a0t3*(M14+M12*M22+M24+M22*M32
     &  )-a0t2*(M14+M12*M32+M22*M32+M34)
       coef(10)=-(a0t3*M12**2)-a0t3*M12*M22-a0t1*M12*M32-a0t3*M12*M32-
     &  a0t1*M22*M32-a0t1*M32**2-(M22**2*(2*a0t1+2*a0t2+2*a0t3+M12+M22+
     &  M32))/2.      
       elseif(id.eq.0) then
       ak0t0= K0T0N(M12,M22,M32,aet1,aet2,aet3,Q2) 
       coef(1)=ak0t0
       coef(2)=(a0t1*a0t2)/2. - (a0t1*a0t3)/2. - (a0t2*a0t3)/2. + 
     -  (abr1*ak0t0)/2. - (aet3*(M12 + M22))/2. + 
     -  (aet2*(M12 - M32))/2. + (aet1*(M22 - M32))/2.

       coef(3)=-(a0t2*a0t3) + ak0t0*M12 - aet3*M22 - aet2*M32
       coef(4)=-(a0t1*a0t3) - aet3*M12 + ak0t0*M22 - aet1*M32      
       coef(5)=(-(a0t2*a0t3*M22) + a0t1*(a0t3*(-2*M12 - M22) + a0t2*M22) 
     -  + aet3*(-2*M14 - M12*M22 - M24) + aet2*(M12*M22 - M22*M32) + 
     -  ak0t0*(M12*M22 + M24 - M22*M32) + 
     -  aet1*(M24 - 2*M12*M32 - M22*M32))/2.
       coef(6)=-(a0t1*a0t3*M12) - a0t2*a0t3*M22 + ak0t0*M12*M22  
     -  + aet3*(-M14 - M24) - aet1*M12*M32 - aet2*M22*M32
       coef(7)=(abr1**2*ak0t0+aet1*(M12*(M22-3*M32)+(M22-M32)**2)+a0t2
     &  *a0t3*(-M12-3*M22+M32)+aet3*(-3*M14-3*M24+M22*M32+M12*(-2*M22+M
     &  32))+a0t1*(a0t2*abr1+a0t3*(-3*M12-M22+M32))+aet2*(M14+M12*(M22-
     &  2*M32)-3*M22*M32+M34))/4.
       coef(8)=(a0t1*(a0t2-a0t3)*M12+aet2*M14-aet3*M14+ak0t0*M14+aet1*
     &  M12*M22-aet3*M12*M22+ak0t0*M12*M22-a0t2*a0t3*(M12+2*M22)-2*aet3
     &  *M24-aet1*M12*M32-aet2*M12*M32-ak0t0*M12*M32-2*aet2*M22*M32)/2.
       coef(9)=-(a0t2*a0t3*abr2)+ak0t0*M14-abr2*(aet3*M22+aet2*M32)
       coef(10)=-(aet3*M12**2)-aet3*M12*M22+ak0t0*M22**2-aet3*M12*M32-
     &  a0t1*a0t3*(M12+M22+M32)-aet1*M32*(M12+M22+M32)       
       endif
      endif
      end subroutine FD111C


*
***********************************************************************
*
c Input: M1**2, M2**2, M3**3, Q2.
c output: coef(5) coresponding to , M1 =0
c     F^D00000_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(1),
c     F^D00001_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(2),  
c     F^D10000_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(3),  
c     F^D00002_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(4),  
c     F^D01000_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(5),
c     F^D10001_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(6),
c     F^D11000_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(7),
c     F^D00001_({2,M1}{1,M3}{0,0}{0,0}{2,M2}) coef(8),
  
      subroutine FD221X(Mass12,Mass22,Mass32,a0t1,a0t2,a0t3,aet1,aet2,
     .   aet3,Q2,coef,id)
      implicit none
      integer id
      double precision Mass12,Mass32,Mass22
      double precision M12,M22,M32, Q2
      double precision a0t1,a0t2,a0t3,aet1,aet2,aet3
      double precision lambdaN, A0T, AEpT,LogM22,pi, zeta2
      double precision K0T0N,ak0t0,coef(10),I0A,ITNX,LogM12
       double precision regMass2,regmass,logX,logx2,xinverse,xinverse2
       common/regularmass/regMass2,regMass,logX,logx2,xinverse,xinverse2

      M12=Mass12; M22=Mass22;M32=Mass32

      pi= 3.1415926535897932384626433832795029D0
      zeta2=pi**2/6D0

      if(M12 .eq.0D0 )then

         if( abs(M22-M32).gt.epsi )then
           if(M22.gt.epsi)then         
          ITNX=I0A(0D0,M22,M32,Q2)
       coef(1)=(2*ITNX*M22*M32+M22*(M22*(a0t3+a0t3*logx+M22-logx*M22)+
     &  (a0t3-a0t3*logx+2*logx*M22)*M32-(-3+logx)*M32**2)+a0t2*((a0t3-
     &  M22)*M22+(a0t3+3*M22-logx*M22)*M32+logx*M32**2))/(M22*(M22-
     &  M32)**3)
       coef(2)=(-2*a0t2+2*a0t3+M22-M32)/(2.*(M22-M32))
       coef(3)=(ITNX*M22+M22*(a0t3-aet2+M22)+a0t2*(a0t3+2*M22-M32)+
     &  (aet2+M22)*M32)/(M22*(M22-M32))
       coef(4)=(-2*a0t2*(a0t3+M22)+M22*(4*a0t3-2*aet2-4*aet3+M22)+2*
     &  ITNX*(M22-2*M32)+2*(-3*a0t3+aet2+2*aet3-2*M22)*M32-M32**2)/(4.*
     &  (M22-M32))
       coef(5)=(12*ITNX*(-M22**2+2*M22*M32+M32**2)+6*(M22*(-2*a0t2*
     &  a0t3+2*(a0t3+a0t2*(-3+logx))*M22-(2*logx+logx2)*M22**2)+(6*
     &  a0t2*a0t3+2*(a0t2*(5-3*logx)+a0t3*(-1+logx))*M22+(-2+4*logx+3*
     &  logx2)*M22**2)*M32+(-2*a0t3*(-2+logx)+4*a0t2*logx+(8-2*logx-3*
     &  logx2)*M22)*M32**2+(2+logx2)*M32**3)-(M22-M32)**3*Pi**2)/(12.*
     &  (M22-M32)**3)
       coef(6)=a0t2+a0t3-aet2-aet3+ITNX+M22/2.+M32/2.
       coef(7)=(M22*(a0t3-2*aet2-aet3+M22)+ITNX*(2*M22-M32)+a0t2*(a0t3+
     &  2*M22-M32)+(2*aet2+aet3+M22)*M32)/((M22-M32))
       coef(8)=(2*a0t2*a0t3+6*a0t2*M22-2*aet2*M22+2*ITNX*M22+M22**2-2*
     &  a0t2*M32+2*aet2*M32+3*M22*M32)/(2*M22*M22-2*M22*M32)

           else
           ITNX=I0A(0D0,0D0,M32,Q2)
       coef(1)=(-2*ITNX+2*a0t3*(-1+logx)+(-3+logx**2)*M32)/M32**2
       coef(2)=0.5-a0t3/M32
       coef(3)=-(12*ITNX-12*a0t3*(-2+logx)+M32*(12+6*logx2+Pi**2))/(12.*M32)
       coef(4)=ITNX+(6*a0t3-4*aet3+M32)/4.
       coef(5)=-(12*ITNX-12*a0t3*(-2+logx)+M32*(12+6*logx2+Pi**2))/(12.*M32)
       coef(6)=a0t3-aet3+ITNX+M32/2.
       coef(7)=-aet3+ITNX
       coef(8)=-(12*ITNX-12*a0t3*(-1+logx)+M32*(18+6*logx2+Pi**2))/(12.*M32)      
           endif
         else
           if(M22.gt.epsi)then 
            LogM22=Log(M22/Q2)   
       coef(1)=(1+logM22-logx)/(2.*M22)
       coef(2)=(-a0t2**2+2*a0t2*(1-2*logx)*M22+2*(4+logx*(2+logx)-
     &  logx2)*M22**2+M22*(-5*M22+4*logM22*M22-logM22**2*M22+2*logM22*
     &  (2+logM22-2*logx)*M22))/(8.*M22**2)
       coef(3)=(-a0t2**2+6*a0t2*M22+2*M22*(-2*aet2+M22)+M22*(-5*M22+4*
     &  logM22*M22-logM22**2*M22))/(4.*M22**2)
       coef(4)=-(a0t2**2-2*a0t2*M22+6*aet2*M22-2*M22*(-5*M22+4*logM22*
     &  M22-logM22**2*M22))/(4.*M22)
       coef(5)=(4+logM22*(3+logM22-2*logx)-logx-logx2-Zeta2)/2.
       coef(6)=a0t2-2*aet2-a0t2**2/(2.*M22)+(-5*M22+4*logM22*M22-
     &  logM22**2*M22)/2.
       coef(7)=(6*a0t2-a0t2**2/M22+2*(-6*aet2+M22)+5*(-5*M22+4*logM22*
     &  M22-logM22**2*M22))/4.
       coef(8)=-(a0t2**2-2*a0t2*(5+2*logx)*M22+2*logM22*(2+logM22-2*
     &  logx)*M22**2-M22*(-5*M22+4*logM22*M22-logM22**2*M22)+2*M22*(4*
     &  aet2+(2+logx*(2+logx)-logx2)*M22))/(8.*M22**2)
       coef(9)=(-a0t2**2+2*(a0t2-4*aet2-2*a0t2*logx)*M22+2*logM22*(2+
     &  logM22-2*logx)*M22**2+2*(4+logx*(2+logx)-logx2)*M22**2+5*M22*(-
     &  5*M22+4*logM22*M22-logM22**2*M22))/(8.*M22)
           else
       coef(1)=(0.7813024128964863)*xinverse
       coef(2)=(0.6719536193447295)+logx
       coef(3)=(-0.15051341407938382)+logx-logx**2
       coef(4)=0.
       coef(5)=(-0.15051341407938382)+logx-logx**2
       coef(6)=0.
       coef(7)=0.
       coef(8)=-0.8224670334241131D0-logx**2
       coef(9)=0.
           endif

         endif
      else
          ITNX=I0A(0D0,M12,M32,Q2)
         if( abs(M12-M32).gt.epsi )then
       coef(1)=(2*ITNX*M12*M32+M12*(M12*(a0t3+a0t3*logx+M12-logx*M12)+
     &  (a0t3-a0t3*logx+2*logx*M12)*M32-(-3+logx)*M32**2)+a0t1*((a0t3-
     &  M12)*M12+(a0t3+3*M12-logx*M12)*M32+logx*M32**2))/(M12*(M12-M32)
     &  **3)
       coef(2)=(-2*a0t1+2*a0t3+M12-M32)/(2.*(M12-M32))
       coef(3)=(12*ITNX*(-M12**2+2*M12*M32+M32**2)+6*(M12*(-2*a0t1*
     &  a0t3+2*(a0t3+a0t1*(-3+logx))*M12-(2*logx+logx2)*M12**2)+(6*
     &  a0t1*a0t3+2*(a0t1*(5-3*logx)+a0t3*(-1+logx))*M12+(-2+4*logx+3*
     &  logx2)*M12**2)*M32+(-2*a0t3*(-2+logx)+4*a0t1*logx+(8-2*logx-3*
     &  logx2)*M12)*M32**2+(2+logx2)*M32**3)-(M12-M32)**3*Pi**2)/(12.*
     &  (M12-M32)**3)
       coef(4)=(-2*a0t1*(a0t3+M12)+M12*(4*a0t3-2*aet1-4*aet3+M12)+2*
     &  ITNX*(M12-2*M32)+2*(-3*a0t3+aet1+2*aet3-2*M12)*M32-M32**2)/(4.*
     &  (M12-M32))
       coef(5)=(ITNX*M12+M12*(a0t3-aet1+M12)+a0t1*(a0t3+2*M12-M32)+
     &  (aet1+M12)*M32)/(M12*(M12-M32))
       coef(6)=-((2*a0t1*a0t3+4*a0t1*M12-2*a0t3*M12+2*aet3*M12+2*a0t3*
     &  M32-2*aet3*M32+2*ITNX*M32+3*M12*M32+M32**2)/(2*M12-2*M32))
       coef(7)=(M12*(a0t3-2*aet1-aet3+M12)+ITNX*(2*M12-M32)+a0t1*(a0t3+
     &  2*M12-M32)+(2*aet1+aet3+M12)*M32)/(M12-M32)
       coef(8)=(12*ITNX*(-M12**2+2*M12*M32+M32**2)+6*(M12*(-2*a0t1*
     &  a0t3+2*a0t1*(-2+logx)*M12-(1+2*logx+logx2)*M12**2)+(6*a0t1*
     &  (a0t3+M12-logx*M12)+M12*(2*a0t3+2*a0t3*logx+M12+4*logx*M12+3*
     &  logx2*M12))*M32+(2*(a0t1+a0t3+2*a0t1*logx-a0t3*logx)+(5-2*logx-
     &  3*logx2)*M12)*M32**2+(3+logx2)*M32**3)-(M12-M32)**3*Pi**2)
     &  /(12.*(M12-M32)**3)
       coef(9)=a0t1+a0t3-aet1-aet3+ITNX+M12/2.+M32/2.
         else
            LogM12=Log(M12/Q2) 
       coef(1)=(1+logM12-logx)/(2.*M12)
       coef(2)=(-a0t1**2+2*a0t1*(1-2*logx)*M12+2*(4+logx*(2+logx)-
     &  logx2)*M12**2+M12*(ITNX+2*logM12*(2+logM12-2*logx)*M12))/(8.*
     &  M12**2)
       coef(3)=(4+logM12*(3+logM12-2*logx)-logx-logx2-Zeta2)/2.
       coef(4)=-(a0t1**2-2*a0t1*M12+6*aet1*M12-2*ITNX*M12)/(4.*M12)
       coef(5)=(-a0t1**2+6*a0t1*M12+ITNX*M12+2*M12*(-2*aet1+M12))/(4.*M12**2)
       coef(6)=(-a0t1**2+5*ITNX*M12+2*(a0t1-4*aet1-2*a0t1*logx)*M12+2*
     &  logM12*(2+logM12-2*logx)*M12**2+2*(4+logx*(2+logx)-logx2)*M12**
     &  2)/(8.*M12)
       coef(7)=(6*a0t1+5*ITNX-a0t1**2/M12+2*(-6*aet1+M12))/4.
       coef(8)=(a0t1**2-ITNX*M12+2*a0t1*(-1+2*logx)*M12+2*logM12*(4+
     &  logM12-2*logx)*M12**2-2*M12**2*(-4+logx*(4+logx)+logx2+2*Zeta2)
     &  )/(8.*M12**2)
       coef(9)=a0t1-2*aet1+ITNX/2.-a0t1**2/(2.*M12)
         endif

      endif


      end

*
***********************************************************************
*
c Input: M1**2=0, M2**2=x, M3**3, Q2.
c output: coef(5)
c     F^D00000_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(1),
c     F^D00001_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(2),  
c     F^D10000_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(3),  
c     F^D00002_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(4),  
c     F^D01000_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(5),
c     F^D10001_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(6),
c     F^D11000_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(7),
c     F^D00001_({2,M1}{1,M3}{0,0}{0,0}{2,M2}) coef(8),
  
      subroutine FD221Z(Mass12,Mass22,Mass32,a0t1,a0t2,a0t3,aet1,aet2,
     .   aet3,Q2,coef,id)
      implicit none
      integer id
      double precision Mass12,Mass32,Mass22
      double precision M12,M22,M32, Q2
      double precision a0t1,a0t2,a0t3,aet1,aet2,aet3
      double precision lambdaN, A0T, AEpT,LogM32,pi, zeta2
      double precision K0T0N,ak0t0,coef(10),I0A,ITNX,LogM12
       double precision regMass2,regmass,logX,logx2,xinverse,xinverse2
       common/regularmass/regMass2,regMass,logX,logx2,xinverse,xinverse2

      M12=Mass12; M22=Mass22;M32=Mass32

      pi= 3.1415926535897932384626433832795029D0
      if (M12.eq.0.and.M22.eq.0)then
           if (M32.gt.0)then
       LogM32=Log(M32/Q2)
      zeta2=pi**2/6D0
       coef(1)=(-2*logM32*(-2+logx)*M32**2+2*aet3*M32-4*M32**2*(-2.5+2*
     &  logM32-logM32**2/2.-Pi**2/6.)+M32**2*(-10+2*logx-logx2-Zeta2))
     &  /(2.*M32**3)
       coef(2)=(a0t3*(-4+logx)-(-3+logx)*M32+logM32*(-2+logx)*M32)/(2.*M32)
       coef(3)=(2*a0t3*(-2+logx)-2*M32*(-2.5+2*logM32-logM32**2/2.-Pi**
     &  2/6.)-M32*(2+logx2+Zeta2))/(2.*M32)
       coef(4)=(-8*aet3-2*a0t3*(-8+logx)-2*logM32*(-2+logx)*M32+(-2-(-
     &  2+logx)*logx+logx2)*M32+8*M32*(-2.5+2*logM32-logM32**2/2.-Pi**
     &  2/6.))/8.
       coef(5)=(-2*a0t3+aet3-M32-M32*(-2.5+2*logM32-logM32**2/2.-Pi**2/6.))/M32
       coef(6)=a0t3-aet3+((2-logx**2+logx2)*M32)/4.+M32*(-2.5+2*logM32-
     &  logM32**2/2.-Pi**2/6.)
       coef(7)=-aet3+M32*(-2.5+2*logM32-logM32**2/2.-Pi**2/6.)
       coef(8)=(M32**2*(a0t3*logx-logM32*(-2+logx)*M32-2*M32*(-2.5+2*
     &  logM32-logM32**2/2.-Pi**2/6.)+M32*(-5+logx-logx2-Zeta2)))/(2.*
     &  M32**3)
       coef(9)=a0t3-aet3+M32/2.+M32*(-2.5+2*logM32-logM32**2/2.-Pi**2/6.)
           endif
      endif
      
      end

*
***********************************************************************
*
c Input: M1**2, M2**2, M3**3, Q2.
c output: coef(5) coresponding to 
c     F^D00000_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(1),
c     F^D00001_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(2),  
c     F^D10000_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(3),  
c     F^D00002_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(4),  
c     F^D01000_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(5),
c     F^D10001_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(6),
c     F^D11000_({2,M1}{2,M2}{0,0}{0,0}{1,M3}) coef(7),
c     F^D00001_({2,M1}{1,M3}{0,0}{0,0}{2,M2}) coef(8),
  
      subroutine FD221C(Mass12,Mass22,Mass32,a0t1,a0t2,a0t3,aet1,aet2,
     .                  aet3,Q2,coef,id)
      implicit none
      integer id
      double precision Mass12,Mass32,Mass22
      double precision M12,M22,M32, Q2
      double precision M14,M24,M34,M16,M26,M36,M18,M28,M38,
     .   M1422, M1222,M1224,M1424,M1226,M1434,M1432,M1622,
     .   M2432, M1232,M2232,M1234,M2234
      double precision abr1,abr2,abr3,abr4, alambda, alambda2,
     .   a0t1,a0t2,a0t3,aet1,aet2,aet3
      double precision lambdaN, A0T, AEpT,coef(10)
      double precision K0T0N,ak0t0

      M12=Mass12; M22=Mass22;M32=Mass32
      if(id.eq.2)then
       coef(1) =0D0
       coef(2) =0D0
       coef(3) =-0.5D0
       coef(4) =(-M12 - M22 - 2*M32)/4.
       coef(5) =-0.5D0
       coef(6) =(-M22 - M32)/2.
       coef(7) =-M12 - M22 - M32/2.
       coef(8) =-1/2d0   
      else 

      abr1=(M12 + M22 - M32);abr2=(M12 + M22 + M32)
      abr3=(M12 - M22 - M32);abr4=(M12 - M22 + M32)
      if(id.eq.1)then
       coef(1) =0D0
       coef(2) =-0.5D0
       coef(3) =0.5 - a0t2/M22
       coef(5) =0.5 - a0t1/M12
       coef(4) =(-2*a0t1-2*a0t2-4*a0t3+abr1-3*M12-3*M22+2*M32)/4.
       coef(6)=-a0t2 - a0t3 - M12
       coef(7)=-2*a0t1 - 2*a0t2 - a0t3 - M32/2.
       coef(8)=((-a0t2 + M22))/(M22)

      elseif(id.eq.0)then
      M14=M12**2;  M24=M22**2 ; M34=M32**2
      M16=M12*M14; M26=M22*M24; M36=M32*M34
      M18=M14**2;  M28=M24**2;  M38=M34**2
      M1422=M14*M22; M1222=M12*M22;M1224=M12*M24
      M1424=M14*M24;M1226=M12*M26;M1434=M14*M34
      M1432=M14*M32; M1622=M16*M22;M2432=M24*M32
      M1232=M12*M32; M2232=M22*M32; M1234=M12*M34
      M2234=M22*M34
      alambda=LambdaN(M12,M22,M32)
      alambda2=alambda**2
      ak0t0=K0T0N(M12,M22,M32,aet1,aet2,aet3,Q2)
       if (M12.gt.epsi )then
          if(M22.gt.epsi)then 
            if(alambda2.gt.epsi)then
       coef(1) =(2*abr1*aet1*M32+2*abr1*aet2*M32+2*abr1*aet3*M32+2*abr1
     &  *(abr2+ak0t0)*M32+2*a0t3*(M14-M2232+M24-M12*(2*M22+M32))+(a0t2*
     &  (M18-3*M16*M22+4*M14*M2232+2*M12*M22*M2232+3*M14*M24-M12*M22*M2
     &  4-3*M16*M32-2*M12*M2232*M32+M12*M24*M32+a0t3*M12*(2*M1232-M14+M
     &  24-M34)+3*M14*M34+M12*M22*M34-M12*M32*M34))/(M12*M22)+(a0t1*(-M
     &  16+a0t3*(M14-(M22-M32)**2)+(M22-M32)**3+3*M14*(M22+M32)+(a0t2*(
     &  (-(M22)+M32)**2*M32+M14*M32+2*M12*(M22-M32)*M32))/M22-M12*(-4*
     &  M2232+3*M24+M34)))/M12)/alambda2
       coef(2) =(1+aet1/M12-(2*a0t2)/M22+aet2/M22+(a0t1*(a0t2-2*M22))/(
     &  M12*M22)+(8*aet3*M1222*M32+8*(abr2+ak0t0)*M1222*M32+(2*a0t2*(M1
     &  8-3*M16*M22+3*M14*M2232+7*M12*M22*M2232+3*M14*M24-M12*M22*M24-4
     &  *M16*M32-M22**3*M32+7*M12*M2232*M32-M12*M24*M32-3*M22*M32**3+M3
     &  2**4+2*a0t3*M22*(-M14+M12*(M22+M32))+6*M14*M34-4*M12*M22*M34+3*
     &  M22**2*M34-4*M12*M32*M34))/M22+2*a0t3*(M16+(M22-M32)**3-M14*(M2
     &  2+3*M32)+M12*(2*M2232-M24+3*M34))+aet1*(-(M18/M12)-(M22-M32)**4
     &  /M12+(4*M16*(M22+M32))/M12+4*(M22-M32)**2*(M22+M32)+(2*M14*(2*M
     &  2232-3*(M24+M34)))/M12)-(aet2*(M18+(M22-M32)**4-4*M16*(M22+M32)
     &  +2*M14*(2*M2232+3*(M24+M34))-4*M12*(-M2234+M2432+M26+M36)))/M22
     &  +(a0t1*(4*a0t3*abr4*M1222+2*(-(M16*(M22+M32))+3*M14*(M22+M32)**
     &  2+(M22-M32)**2*((M22-M32)**2-3*M12*(M22+M32)))-(a0t2*(M18+(M22-
     &  M32)**4-4*M16*(M22+M32)+6*M14*(M24+M34)-4*M12*(-2*M2234+M26+M36
     &  )))/M22))/M12)/alambda2)/2.

       coef(3) =((a0t2*(2*M18-8*M16*M22+2*M22**4+9*M14*M2232+M12*M22*M2
     &  232+12*M14*M24-8*M12*M22*M24-7*M16*M32-7*M22**3*M32-M12*M2232*M
     &  32+8*M12*M24*M32-5*M22*M32**3+M32**4-a0t3*(M14*(M22+M32)-(M22-M
     &  32)*(M22**2-2*M12*M32-2*M22*M32+M32**2))+9*M14*M34+5*M12*M22*M3
     &  4+9*M22**2*M34-5*M12*M32*M34))/M22+a0t3*(M16+(M22-M32)**3-M14*(
     &  M22+M32)+M12*(-M24+M34))+aet1*(-M16+(M22-M32)**3+3*M14*(M22+M32
     &  )-M12*(-4*M2232+3*M24+M34))+aet3*(-M16+(M22-M32)**3+3*M14*(M22+
     &  M32)-M12*(-4*M2232+3*M24+M34))+(-abr2-ak0t0)*(M16-(M22-M32)**3-
     &  3*M14*(M22+M32)+M12*(-4*M2232+3*M24+M34))+a0t1*(a0t3*(-M14-3*(M
     &  22-M32)**2+4*M12*(M22+M32))-2*(M16+3*M12*(-M2232+M24)-(M22-M32)
     &  **3-M14*(3*M22+2*M32))+(a0t2*(-M16+3*M14*M22-3*M2234-3*M12*M24+
     &  M26+4*M14*M32-5*M12*M34+2*M36))/M22)+(aet2*(-M18+(M22-M32)**3*M
     &  32+M16*(3*M22+4*M32)-M14*(M2232+3*M24+6*M34)+M12*(-5*M2234+M26+
     &  4*M36)))/M22)/alambda2

       coef(4)=(abr1-(a0t2*(3*M12+3*M22-2*M32))/M22+(aet1*(2*M12+2*M22
     &  -M32))/M12+(aet2*(2*M12+2*M22-M32))/M22+(a0t1*(a0t2*(2*M12+2*M2
     &  2-M32)+M22*(-3*M12-3*M22+2*M32)))/(M12*M22)+(2*a0t3*(2*M18+(2*M
     &  22-3*M32)*(M22-M32)**3-M16*(4*M22+9*M32)+M14*(5*M2232+4*M24+15*
     &  M34)+M12*(10*M2234+5*M2432-4*M26-11*M36))+a0t1*(M18+((3*M22-2*M
     &  32)*(M22-M32)**4)/M12-(M18*(5*M22+8*M32))/M12-(M22-M32)**2*(12*
     &  M2232+7*M24-11*M34)+(2*M16*(7*M2232+3*M24+10*M34))/M12+2*a0t3*(
     &  -M16-(M22-M32)**3+M14*(5*M22+3*M32)-M12*(2*M2232+3*(M24+M34)))-
     &  (a0t2*(2*M12*M18+(M22-M32)**4*(2*M22-M32)-3*M18*(2*M22+3*M32)-2
     &  *M12*(M22-M32)**2*(4*M2232+3*M24-3*M34)+4*M16*(M2232+M24+4*M34)
     &  +2*M14*(8*M2234-3*M2432+2*M26-7*M36)))/(M12*M22)+(2*M14*(7*M223
     &  4+11*M2432+M26-11*M36))/M12)+aet1*(-2*M18-((M22-M32)**4*(2*M22-
     &  M32))/M12+(M18*(6*M22+7*M32))/M12+(2*M16*(3*M2232-2*M24-5*M34))
     &  /M12+2*(M22-M32)**2*(3*M2232+3*M24-2*M34)-(4*M14*(5*M2234+M26-2
     &  *M36))/M12)+(a0t2*(-7*M18*M22+2*M16*M2232-5*M22**3*M2232+28*M14
     &  *M2234+2*M16*M24+M22**3*M24+22*M14*M2432+6*M14*M26-14*M18*M32+1
     &  5*M22**2*M2232*M32-3*M22**2*M24*M32+5*M2232*M32**3-M24*M32**3-2
     &  *a0t3*(M16*M22+M22**4-3*M14*M2232+3*M14*M24-3*M22**3*M32+3*M22*
     &  *2*M32**2-M22*M32**3)+26*M16*M34+2*M22**3*M34-15*M22*M2232*M34+
     &  3*M22*M24*M34-6*M22**2*M32*M34-2*M32**3*M34+6*M22*M34**2+M12*(3
     &  *M18+(M22-M32)*(6*a0t3*M2232+23*M2234+10*a0t3*M24+9*M2432-5*M26
     &  -11*M36))-24*M14*M36))/M22+2*aet3*(-M18-M22*(M22-M32)**3+M16*(4
     &  *M22+3*M32)+M14*(M2232-3*(2*M24+M34))+M12*(-6*M2234+M2432+4*M26
     &  +M36))+2*(ak0t0*(M18+(M22-2*M32)*(M22-M32)**3-M16*(4*M22+5*M32)
     &  +M14*(9*M2232+6*M24+9*M34)+M12*(2*M2234+9*M2432-4*M26-7*M36))+M
     &  32*(-M18+2*M14*(3*M2232+5*M24)-(M22-M32)**3*(M22+M32)+2*M16*(2*
     &  M22+M32)-2*M12*(4*M2234-3*M2432-2*M26+M36)))+(aet2*(-2*M12*M18+
     &  M18*(6*M22+9*M32)+(M22-M32)**3*(M2232-2*M24-M34)-2*M16*(3*M2232
     &  +2*M24+8*M34)-2*M14*(5*M2234+2*M26-7*M36)+2*M12*(3*M28+3*M26*M3
     &  2-10*M24*M34+7*M22*M36-3*M38)))/M22)/alambda2)/4.

       coef(5)=(a0t3*(M16+M2234-M12*M24-M2432+M26-M14*(M22+3*M32)+3*M1
     &  2*M34-M36)+aet2*(M16-M2234+3*M2432-M26-3*M14*(M22+M32)+M12*(4*M
     &  2232+3*(M24+M34))-M36)+aet3*(M16-M2234+3*M2432-M26-3*M14*(M22+M
     &  32)+M12*(4*M2232+3*(M24+M34))-M36)+(abr2+ak0t0)*(M16-M2234+3*M2
     &  432-M26-3*M14*(M22+M32)+M12*(4*M2232+3*(M24+M34))-M36)+a0t2*(-(
     &  a0t3*(3*M14-4*M12*M22-4*M2232+M24-6*M12*M32+3*M34))-2*(-M16-2*M
     &  2432+M26+3*M14*(M22+M32)-3*M12*(M2232+M24+M34)+M36))-(aet1*((M2
     &  2-M32)**4-M16*(M22+M32)+3*M14*(M24+M34)+M12*(5*M2234+M2432-3*(M
     &  26+M36))))/M12+(a0t1*(-8*M1226+12*M1424+9*M1434-8*M1622+2*M18+2
     &  *M28+9*M1224*M32+9*M1422*M32-7*M16*M32-7*M26*M32-a0t3*(3*M1432-
     &  M16+(-(M22)+M32)**2*M32+M12*(2*M2232+M24-3*M34))+a0t2*(-3*M142
     &  2+M16-(M22-2*M32)*(M22-M32)**2+3*M12*(M24-M34))+4*M1222*M34+9*M
     &  24*M34-5*M12*M36-5*M22*M36+M38))/M12)/alambda2

        coef(6)=aet1+M12/2.+a0t1*(-1.5+a0t2/M22)-(3*a0t2*M12)/(2.*M22)+ 
     -  (aet2*M12)/M22+(aet1*(M1226-3*M1424-3*M1434+3*M1622-M18 - 
     -  M1224*M32 + 2*M1422*M32 + 3*M16*M32 - M1222*M34 + M12*M36) + 
     -  aet3*(M1226 - 3*M1424 - 3*M1434 + 3*M1622 - M18 - M1224*M32 + 
     -  2*M1422*M32 + 3*M16*M32 - M1222*M34 + M12*M36) + 
     -  a0t3*(-2*M1226 + 2*M1424 + 6*M1434 - 2*M1622 + M18 + M28 + 
     -  4*M1422*M32 - 4*M16*M32 - 4*M26*M32 + 6*M1222*M34 + 6*M24*M34- 
     -  4*M12*M36 - 4*M22*M36 + M38) + 
     -  ak0t0*(-3*M1226 + 3*M1424 + 3*M1434-M1622+M28+3*M1224*M32 + 
     -  6*M1422*M32 - M16*M32 - 4*M26*M32 + 3*M1222*M34 + 6*M24*M34 - 
     -  3*M12*M36 - 4*M22*M36 + M38) - 
     -  (aet2*(M12*M18 - M1424*M22 + 7*M1434*M22 + 3*M1622*M22 - 
     -  3*M18*M22 - 4*M18*M32 - 3*M1224*M22*M32 + 2*M1422*M22*M32 + 
     -  M16*M22*M32 + 6*M16*M34 + 7*M1222*M22*M34 - 4*M14*M36 - 
     -  5*M12*M22*M36 + M12*M38))/M22 + 
     -  a0t2*((-5*M1226)/2. + 8*M1434 + 5*M1622 - 5*M18 + 
     -  (3*M12*M18)/(2.*M22) + M28 + 10*M1422*M32 + 4*M16*M32 - 
     -  (6*M18*M32)/M22 - 4*M26*M32 - 
     -  2*a0t3*(-M1224 - M1234 + M1422 + M1432 + 2*M1222*M32) + 
     -  9*M1222*M34 + (9*M16*M34)/M22 + 6*M24*M34 - 8*M12*M36 - 
     -  (6*M14*M36)/M22 - 4*M22*M36 + M38 + (3*M12*M38)/(2.*M22)) + 
     -  (-(M12*M18) + M18*M22 + 2*M16*M24 - 2*M14*M26 - M12*M28 + 
     -  M22*M28 - 4*M1226*M32 + 10*M1424*M32 + 12*M1622*M32 + M18*M32- 
     -  3*M28*M32 + 10*M1224*M34 + 10*M1422*M34 + 2*M16*M34 + 
     -  2*M26*M34 - 4*M1222*M36 - 2*M14*M36 + 2*M24*M36 - M12*M38 - 
     -  3*M22*M38 + M32*M38)/2. + 
     -  a0t1*(-4*M1226 + 3*M1424 + 3*M1434 - M18/2. + (3*M28)/2. + 
     -  4*M1224*M32 + 6*M1422*M32 - 6*M26*M32 + 4*M1222*M34 + 
     -  9*M24*M34 - 4*M12*M36 - 6*M22*M36 + 
     -  a0t3*(-M1224 - 3*M1234 + 3*M1422 + 3*M1432 - M16 - 3*M2234 + 
     -  3*M2432 - M26 + 4*M1222*M32 + M36) + (3*M38)/2. - 
     -  (a0t2*(6*M1434 + M18 - M1224*M22 + 5*M1234*M22 + 3*M1422*M22+ 
     -  M1432*M22 - 3*M16*M22 + 3*M22*M2234 - M22*M2432 - 
     -  4*M16*M32 - 4*M12*M36 - 3*M22*M36 + M38))/M22))/alambda2

        coef(7)=(M12*M18-3*M18*M22+2*M16*M24+2*M14*M26-3*M12*M28+M22* 
     -  M28-2*M1226*M32+16*M1424*M32-2*M1622*M32-2*M18*M32-2*M28*M32+ 
     -  8*M1224*M34+8*M1422*M34-2*M1222*M36+2*M14*M36 + 2*M24*M36 + 
     -    aet3*(-4*M1226 + 6*M1424 + 3*M1434 - 4*M1622 + M18 + M28 + 
     -  5*M1224*M32+5*M1422*M32 - 3*M16*M32 - 3*M26*M32+3*M24*M34 - 
     -  M12*M36 - M22*M36) + 
     -  a0t3*(-2*M1226 + 2*M1424 + 3*M1434 - 2*M1622 + M18 + M28 + 
     -  M1224*M32 + M1422*M32 - 3*M16*M32 - 3*M26*M32 + 2*M1222*M34 + 
     -  3*M24*M34 - M12*M36 - M22*M36) + 
     -  aet1*(-3*M1434 + M1224*M32 + M1422*M32 + M16*M32 + M26*M32 - 
     -  4*M1222*M34 - 3*M24*M34 + 3*M12*M36 + 3*M22*M36 - M38) + 
     -  aet2*(-3*M1434 + M1224*M32 + M1422*M32 + M16*M32 + M26*M32 - 
     -  4*M1222*M34 - 3*M24*M34 + 3*M12*M36 + 3*M22*M36 - M38) - 
     -  M12*M38 - M22*M38 + a0t2*
     -  (-9*M1226 + 15*M1424 + 12*M1434 - 11*M1622 + 3*M18 + 2*M28 + 
     -  10*M1224*M32 + 11*M1422*M32 - 10*M16*M32 - 7*M26*M32 + 
     -  5*M1222*M34 + 9*M24*M34 + 
     -  a0t3*(-2*M1224 + 3*M1422 + 3*M1432 - 2*M16 + 3*M2234 - 3*M2432 + 
     -  M26 + 2*M1222*M32 - M36) - 6*M12*M36 - 5*M22*M36 + M38) + 
     -  ak0t0*(-8*M1226 + 12*M1424 + 9*M1434 - 8*M1622 + 2*M18 + 2*M28 + 
     -  9*M1224*M32 + 9*M1422*M32 - 7*M16*M32 - 7*M26*M32 + 
     -  4*M1222*M34 + 9*M24*M34 - 5*M12*M36 - 5*M22*M36 + M38) + 
     -  a0t1*(-11*M1226 + 15*M1424 + 9*M1434 - 9*M1622 + 2*M18 + 3*M28 + 
     -  11*M1224*M32 + 10*M1422*M32 - 7*M16*M32 - 10*M26*M32 + 
     -  5*M1222*M34 + 12*M24*M34 + 
     -  a0t3*(3*M1224 + 3*M1234 - 2*M1422 - 3*M1432 + M16 + 3*M2432 - 
     -  2*M26 + 2*M1222*M32 - M36) - 5*M12*M36 - 6*M22*M36 + 
     -  a0t2*(-6*M1234 + 3*M1432 - 6*M2234 + 3*M2432 - 2*M1222*M32 + 
     -  3*M36) + M38))/alambda2

        coef(8)=(4*a0t3*abr3*M1232-3*M18-16*M1224*M32+8*M16*(M22+M32)+ 
     -  (M22 - M32)**3*(M22 + 3*M32) - 2*M14*(-4*M2232 + 3*M24 + M34)+ 
     -  2*(aet1+aet3+ak0t0)*(-M16+(M22-M32)**3+3*M14*(M22+M32)-M12* 
     -  (3*M24+M34))+(2*a0t2*(2*M18 +(M22-M32)**3*(a0t3+3*M22 - M32) - 
     -  M16*(9*M22 + 7*M32)+M14*(10*M2232+15*M24+a0t3*(M22-M32)+9*M34)+ 
     -  M12*(5*M2234 + 7*M2432 - 11*M26 - 2*a0t3*(2*M2232 + M24 - M34)- 
     -  5*M36)))/M22 - (2*a0t1*(M22*(M16 - (M22 - 3*M32)*(M22 - M32)**2
     -  - M14*(3*M22 + M32) +M12*(-4*M2232 + 3*M24 - 3*M34) + 
     -  a0t3*(M14 - 4*M2232 + M24 - 2*M12*(M22 + 2*M32) + 3*M34)) + 
     -  a0t2*(M16 + M2234 + 2*M2432 - M26 - M14*(3*M22 + 4*M32) + 
     -  M12*(2*M2232 + 3*M24 + 5*M34) - 2*M36)))/M22 + 
     -  (2*aet2*(-M18 + (M22 - M32)**3*M32 + M16*(3*M22 + 4*M32) - 
     -  M14*(M2232+3*M24+6*M34)+M12*(-5*M2234-4*M2432+M26+4*M36)
     -  ))/M22)/(2.*alambda2)

       coef(9)=(2*a0t1+2*a0t3+2*aet2+2*ak0t0-3*M12+(4*(M12-M22)*(M12**
     &  4+M12*(a0t1*a0t2-a0t2*a0t3+6*M12**2)*M22+(a0t1*(-a0t2+a0t3)-2*
     &  M12**2)*M22**2-4*M12*M22**3-M22**4)+M32**5+(-5*M12**4-4*M12*
     &  (a0t1*a0t2-a0t2*a0t3+15*M12**2)*M22+2*(2*a0t1*(-a0t2+a0t3)+4*
     &  (a0t1+a0t2+a0t3+aet1+aet2+aet3+ak0t0)*M12-51*M12**2)*M22**2-36*
     &  M12*M22**3-5*M22**4)*M32)/(M12**2+(M22-M32)**2-2*M12*(M22+M32))
     &  **2+(2*(M22*((2*a0t3+aet1+aet2+aet3+ak0t0-16*M12)*M12-(aet1+
     &  aet2+aet3+ak0t0+10*M12)*M22-2*M22**2)+(-5*M12**2-10*M12*M22+
     &  (aet1+aet2+aet3+ak0t0-3*M22)*M22)*M32+a0t1*(a0t2*(M12-3*M22-
     &  M32)+2*M22*(a0t3+M32))+a0t2*(-(a0t3*(M12+M22-M32))+2*M22*(M12-
     &  M22+M32))))/(M12**2+(M22-M32)**2-2*M12*(M22+M32)))/2.
              else
       coef(1)=1/M12
       coef(2)=1.5-a0t1/M12
       coef(3)=(a0t1-aet1+M12)/M12-a0t1**2/(2.*M14)
       coef(4)=(-4*a0t1-2*aet1-a0t1**2/M12+M12)/2.
       coef(5)=(a0t1-aet1+M12)/M12-a0t1**2/(2.*M14)
       coef(6)=(-4*a0t1-2*aet1-a0t1**2/M12+M12)/2.
       coef(7)=-4*aet1-(2*a0t1**2)/M12-M12
       coef(8)=-(a0t1**2*M12-4*a0t1*M14+2*aet1*M14+M12*M14)/(2.*M12*M14)
       coef(9)=(-4*a0t1-2*aet1-a0t1**2/M12+M12)/2.
              endif
             
          else
            if(abs(M12-M32).gt.epsi)then
       coef(1)=(M12*(a0t1*(a0t3-2*M12)+M12*(a0t3+aet3+M12))+(a0t1*a0t3+
     &  (5*a0t1+a0t3+aet1+aet3+2*ak0t0)*M12)*M32+(-a0t1+aet1+3*M12)*
     &  M32**2)/(M12*(M12-M32)**3)
       coef(2)=0.5+(-a0t1+a0t3)/(M12-M32)
       coef(3)=(-(M12*(a0t1*a0t3+(4*a0t1-a0t3+aet3+ak0t0)*M12))-(M12*
     &  (a0t3+aet1-3*aet3-2*ak0t0+M12)-a0t1*(3*a0t3+7*M12))*M32+(-a0t1+
     &  2*a0t3+3*aet1+ak0t0+4*M12)*M32**2+M32**3)/(M12-M32)**3
       coef(4)=-(2*a0t1*(a0t3+M12)-M12*(4*a0t3-2*aet3+2*ak0t0+M12)+2*
     &  (3*a0t3+aet1+2*(ak0t0+M12))*M32+M32**2)/(4.*(M12-M32))
       coef(5)=(a0t1*(a0t3+2*M12-M32)+aet1*M32+M12*(a0t3+aet3+ak0t0+
     &  M12+M32))/(M12*(M12-M32))
       coef(6)=a0t3+aet1+ak0t0+2*M12-(a0t1*(a0t3+2*M12)+M12*(aet1+aet3+
     &  ak0t0+2*M12))/(M12-M32)+M32/2.
       coef(7)=(M12*(a0t3+aet3+2*ak0t0+M12)+a0t1*(a0t3+2*M12-M32)+
     &  (aet1-ak0t0+M12)*M32)/((M12-M32))
       coef(8)=(2*a0t1*(a0t3+3*M12-M32)+2*aet1*M32+M12*(2*aet3+2*ak0t0+
     &  M12+3*M32))/(2.*M12*(M12-M32))
       coef(9)=a0t1+a0t3+ak0t0+M12/2.+M32/2.
             else
       coef(1)=3/(2.*M12)-a0t1/M14
       coef(2)=1.5-a0t1/M12
       coef(3)=4.5-(4*a0t1)/M12+aet1/M12+a0t1**2/(2.*M14)
       coef(4)=(-2*a0t1-6*aet1-(3*a0t1**2)/M12-4*M12)/4.
       coef(5)=(a0t1-aet1)/M12-a0t1**2/(2.*M14)
       coef(6)=(-4*a0t1-2*aet1-a0t1**2/M12+M12)/2.
       coef(7)=-a0t1-3*aet1-(3*a0t1**2)/(2.*M12)-2*M12
       coef(8)=-(a0t1**2*M12-4*a0t1*M14+2*aet1*M14+3*M12*M14)/(2.*M12*M14)
       coef(9)=-((a0t1**2+2*aet1*M12+M12**2)/M12)
             endif
          endif
        else
          if (M22.gt.epsi) then
             if(abs(M22-M32).gt.epsi)then
       coef(1)=(M22*(a0t2*(a0t3-2*M22)+M22*(a0t3+aet3+M22))+(a0t2*a0t3+
     &  (5*a0t2+a0t3+aet2+aet3+2*ak0t0)*M22)*M32+(-a0t2+aet2+3*M22)*
     &  M32**2)/(M22*(M22-M32)**3)
       coef(2)=0.5+(-a0t2+a0t3)/(M22-M32)
       coef(3)=(a0t2*(a0t3+2*M22-M32)+aet2*M32+M22*(a0t3+aet3+ak0t0+
     &  M22+M32))/(M22*(M22-M32))
       coef(4)=-(2*a0t2*(a0t3+M22)-M22*(4*a0t3-2*aet3+2*ak0t0+M22)+2*
     &  (3*a0t3+aet2+2*(ak0t0+M22))*M32+M32**2)/(4.*(M22-M32))
       coef(5)=(-(M22*(a0t2*a0t3+(4*a0t2-a0t3+aet3+ak0t0)*M22))-(M22*
     &  (a0t3+aet2-3*aet3-2*ak0t0+M22)-a0t2*(3*a0t3+7*M22))*M32+(-a0t2+
     &  2*a0t3+3*aet2+ak0t0+4*M22)*M32**2+M32**3)/(M22-M32)**3
       coef(6)=a0t2+a0t3+ak0t0+(M22+M32)/2.
       coef(7)=(M22*(a0t3+aet3+2*ak0t0+M22)+a0t2*(a0t3+2*M22-M32)+
     &  (aet2-ak0t0+M22)*M32)/((M22-M32))
       coef(8)=(-(M22*(2*a0t2*a0t3+2*(3*a0t2+aet3+ak0t0)*M22+M22**2))+
     &  (6*a0t2*a0t3+2*(5*a0t2+a0t3-aet2+3*aet3+2*ak0t0)*M22+M22**2)*
     &  M32+(2*(a0t3+3*aet2+ak0t0)+5*M22)*M32**2+3*M32**3)/(2.*(M22-
     &  M32)**3)
       coef(9)=-((2*a0t2*a0t3+4*a0t2*M22-2*a0t3*M22+2*aet3*M22+2*a0t3*
     &  M32+2*aet2*M32+2*ak0t0*M32+3*M22*M32+M32**2)/(2*M22-2*M32))
              else
       coef(1)=(-2*a0t2+3*M22)/(2.*M22**2)
       coef(2)=1.5-a0t2/M22
       coef(3)=-(a0t2**2-2*a0t2*M22+2*aet2*M22)/(2.*M22**2)
       coef(4)=(-2*a0t2-6*aet2-(3*a0t2**2)/M22-4*M22)/4.
       coef(5)=(a0t2**2-8*a0t2*M22+2*aet2*M22+9*M22**2)/(2.*M22**2)
       coef(6)=-((a0t2**2+2*aet2*M22+M22**2)/M22)
       coef(7)=-a0t2-3*aet2-(3*a0t2**2)/(2.*M22)-2*M22
       coef(8)=3+(a0t2**2-6*a0t2*M22+2*aet2*M22)/(2.*M22**2)
       coef(9)=(-4*a0t2-2*aet2-a0t2**2/M22+M22)/2.
              endif
          else
            if(m32.gt.epsi)then
       coef(1)=(-2*(a0t3+ak0t0+(3*M32)/2.))/M34
       coef(2)=0.5-a0t3/M32
       coef(3)=-((2*a0t3+ak0t0+M32)/M32)
       coef(4)=(6*a0t3+4*ak0t0+M32)/4.
       coef(5)=-((2*a0t3+ak0t0+M32)/M32)
       coef(6)=a0t3+ak0t0+M32/2.
       coef(7)=ak0t0
       coef(8)=-((a0t3+ak0t0+(3*M32)/2.)/M32)
       coef(9)=a0t3+ak0t0+M32/2.
            else
       coef(1)=0
       coef(2)=0
       coef(3)=0
       coef(4)=0
       coef(5)=0
       coef(6)=0
       coef(7)=0
       coef(8)=0
       coef(9)=0
            endif
          endif
        endif
      endif
      endif

      end subroutine FD221C

*
***********************************************************************
*
c Input: M1**2, M2**2, M3**2, Q2. for small M1
c output: coef(5) coresponding to 
c     F^D_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(1),
c     F^D00001_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(2),  
c     F^D10000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(3),  
c     F^D10001_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(4),
c     F^D01000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(5), 
c     F^D11000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(6), 
c     F^D20000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(7), 
 

      subroutine FD311X(Mass12,Mass32,Mass22,a0t1,a0t3,a0t2,aet1,aet3,
     .    aet2,Q2,coef,id)
      implicit none
      integer id
      double precision Mass12,Mass32,Mass22,pi
      double precision M12,M22,M32, Q2
      double precision  a0t1,a0t2,a0t3,aet1,aet2,aet3,Zeta2
      double precision lambdaN,A0T,AEpT,a0tM,aetM,I0A,logm,ITNX
      double precision K0T0N, coef(10),ak0t0
       double precision regMass2,regmass,logX,logx2,xinverse,xinverse2
       common/regularmass/regMass2,regMass,logX,logx2,xinverse,xinverse2
      M12=Mass12; M22=Mass22; M32=Mass32


      pi= 3.1415926535897932384626433832795029D0
      Zeta2= Pi**2/6.
      if(M12 .lt.epsi)then
        if (abs(M22-M32) .lt. epsi)then
           if (M32.gt.epsi)then
            logm=Log(M32/Q2)
            ITNX= I0A(0D0,M32,M32,Q2)
       coef(1)=-((logm+logx)*xinverse)/2.
       coef(2)=(3+logm*(2+logm-2*logx)-logx2-Zeta2)/4.
       coef(3)=(3+logm*(2+logm-2*logx)-logx2-Zeta2)/2.
       coef(4)=(-2*aet3+ITNX)/2.
       coef(5)=((a0t3-logm*M32-2*logx*M32)*xinverse)/2.
       coef(6)=(-2*aet3+2*a0t3*logx+logm*(2+logm-2*logx)*M32-M32*(-3+
     &  logx**2+logx2+2*Zeta2))/2.
       coef(7)=-2*aet3+ITNX
           else
       coef(1)=-0.2813024128964863D0*xinverse-logx*xinverse
       coef(2)=(-0.07525670703969191D0)+0.5*logx-
     &  0.5*logx2
       coef(3)=(-0.15051341407938382D0)+logx-logx2
       coef(4)=0.
       coef(5)=0.5D0-1.*logx
       coef(6)=0.
       coef(7)=0.
           endif

        else
           if (M22.lt.epsi .and. M32.gt.epsi) then
            logm=Log(M32/Q2)
       coef(1)=(logx)/M32+logm*(-1D0/M32-0.5*xinverse)+0.5D0*
     &  xinverse-0.5D0*logx*xinverse
       coef(2)=0.41123351671205655D0+(0.5-0.25*logx)*logx-(a0t3*xinverse)
     &  /4.+0.25*M32*xinverse+logm*(-0.5+0.25*logm-0.5*logx-0.25*M32*
     &  xinverse)
       coef(3)=(logm**2-(-1+logx)**2-2*logm*logx+Zeta2)/2.
       coef(4)=(-2*a0t3*logx-M32+logm*(logm-2*logx)*M32+2*M32*(-2.5+2*
     &  logm-logm**2/2.-Pi**2/6.)+2*M32*(logx+Zeta2))/4.
       coef(5)=0.5+(0.5-0.5*logx)*M32*xinverse+logm*(-1.-0.5*M32*xinverse)
       coef(6)=(M32*(logm**2-(-1+logx)**2-2*logm*logx+Zeta2))/2.
       coef(7)=-aet3+M32*(-2.5+2*logm-logm**2/2.-Pi**2/6.)
           endif

           if (M22.gt.epsi .and. M32.lt.epsi) then
            logm=Log(M22/Q2)
       coef(1)=(M22*xinverse+logx*(2-M22*xinverse)-logm*(2+M22*
     &  xinverse))/(2.*M22)
       coef(2)=(-2-(-2+logx)*logx+a0t2*xinverse-M22*xinverse+logm*(2+
     &  logm-2*logx+M22*xinverse)+Zeta2)/4.
       coef(3)=(logm**2-(-1+logx)**2-2*logm*logx+Zeta2)/2.
       coef(4)=(-4*aet2+2*a0t2*logx+M22+logm*(-logm+2*logx)*M22+2*M22*
     &  (-2.5+2*logm-logm**2/2.-Pi**2/6.)-2*M22*(logx+Zeta2))/4.
       coef(5)=((a0t2-logx*M22)*xinverse)/2.
       coef(6)=-aet2+a0t2*logx-(M22*(logx**2+Zeta2))/2.
       coef(7)=-aet2+M22*(-2.5+2*logm-logm**2/2.-Pi**2/6.)
           endif   

           if (M22.gt.epsi .and. M32.gt.epsi) then
           ITNX= I0A(0D0,M22,M32,Q2)
       coef(1)=((-1+logx)*M22**3-4*ITNX*M22*M32-(3+logx)*M22**2*M32-(3+
     &  logx)*M22*M32**2+(-1+logx)*M32**3-logx*(M22-M32)**4*xinverse+
     &  a0t3*(-M22**2-2*logx*M22**2-4*M22*M32+2*logx*M22*M32+M32**2-
     &  (M22-M32)**3*xinverse)+a0t2*(M22**2-4*M22*M32+2*logx*M22*M32-
     &  M32**2-2*logx*M32**2-2*a0t3*(M22+M32)+(M22-M32)**3*xinverse))
     &  /(2.*(M22-M32)**4)
       coef(2)=(-M22**3-logx*M22**3-logx2*M22**3+M22**2*M32+logx*M22**
     &  2*M32+3*logx2*M22**2*M32+5*M22*M32**2+logx*M22*M32**2-3*logx2*
     &  M22*M32**2+3*M32**3-logx*M32**3+logx2*M32**3+2*ITNX*(-M22**2+2*
     &  M22*M32+M32**2)+a0t3*(M22**2+2*logx*M22*M32+(3-2*logx)*M32**2)+
     &  a0t2*((-5+2*logx)*M22**2-2*a0t3*(M22-3*M32)+(8-6*logx)*M22*M32+
     &  (1+4*logx)*M32**2)-(M22-M32)**3*Zeta2)/(4.*(M22-M32)**3)
       coef(3)=-(2*a0t3*logx*M22+2*M22**2+logx2*M22**2-2*a0t3*(-2+logx)
     &  *M32+4*M22*M32-2*logx2*M22*M32+2*M32**2+logx2*M32**2+2*ITNX*
     &  (M22+M32)+2*a0t2*(2*a0t3-(-2+logx)*M22+logx*M32)+(M22-M32)**2*
     &  Zeta2)/(2.*(M22-M32)**2)
       coef(4)=(4*a0t2*(a0t3+M22)+M22*(-4*aet2+(2-logx**2+logx2)*M22)+
     &  2*ITNX*(M22-M32)+2*(2*(a0t3+aet2)+(2+logx**2-logx2)*M22)*M32+
     &  (2-logx**2+logx2)*M32**2+2*ITNX*(M22+M32))/(4.*(M22-M32))
       coef(5)=(-4*ITNX*M22*M32**2+M32*(M22*(a0t2*(-2*a0t3+M22)+M22*(-
     &  (a0t3*(1+2*logx))+(-1+logx)*M22))-(2*a0t2*a0t3-2*(a0t2+a0t3)*(-
     &  2+logx)*M22+(3+logx)*M22**2)*M32-(a0t2-a0t3+2*a0t2*logx+(3+
     &  logx)*M22)*M32**2+(-1+logx)*M32**3)-(-((M22-M32)**3*(a0t2*M22-
     &  a0t3*M32))+logx*(M22**5+M32**5-M22*M32*(M22+M32)*(3*M22**2-5*
     &  M22*M32+3*M32**2)))*xinverse)/(2.*(M22-M32)**4)
       coef(6)=-(logx**2*M22**3+2*aet2*(M22-M32)**2+2*a0t3*logx*M22*
     &  M32+2*M22**2*M32-2*logx**2*M22**2*M32+logx2*M22**2*M32+4*a0t3*
     &  M32**2-2*a0t3*logx*M32**2+4*M22*M32**2+logx**2*M22*M32**2-2*
     &  logx2*M22*M32**2+2*M32**3+logx2*M32**3+2*ITNX*M32*(M22+M32)+
     &  a0t2*(4*(a0t3+M22)*M32+2*logx*M22*(-M22+M32))+(M22-M32)**2*
     &  (M22+M32)*Zeta2)/(2.*(M22-M32)**2)
       coef(7)=-aet2-aet3+ITNX

           endif 

        endif

      endif
      end
*
***********************************************************************
*
c Input: M1**2, M2**2, M3**2, Q2. for small M1
c output: coef(5) coresponding to 
c     F^D_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(1),
c     F^D00001_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(2),  
c     F^D10000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(3),  
c     F^D10001_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(4),
c     F^D01000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(5), 
c     F^D11000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(6), 
c     F^D20000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(7), 
 
      subroutine FD311ZNEW(Mass12,Mass32,Mass22,a0t1,a0t3,a0t2,aet1,aet3,
     .    aet2,Q2,coef,id)
      implicit none
      integer id
      double precision Mass12,Mass32,Mass22,pi
      double precision M12,M22,M32, Q2
      double precision  a0t1,a0t2,a0t3,aet1,aet2,aet3
      double precision lambdaN,A0T,AEpT,a0tM,aetM,logm
      double precision K0T0N, coef(10),ak0t0,zeta2
       double precision regMass2,regmass,logX,logx2,xinverse,xinverse2
       common/regularmass/regMass2,regMass,logX,logx2,xinverse,xinverse2
      M12=Mass12; M22=Mass22; M32=Mass32

      pi= 3.1415926535897932384626433832795029D0
      Zeta2= Pi**2/6.      
      if(M12 .lt.epsi .AND. M32.lt.epsi .AND. M22.gt.epsi)then
       logm=Log(M22/Q2)
       coef(1)=(logx+M22*xinverse-logx*M22*xinverse-logm*(1+M22*
     &  xinverse))/(2.*M22)
       coef(2)=(-2*M22*(-2.5+2*logm-logm**2/2.-Pi**2/6.)+logm*M22*(1+
     &  M22*xinverse)+a0t2*(-4+2*logx+M22*xinverse)-M22*(2+logx+logx2+
     &  M22*xinverse+Zeta2))/(4.*M22)
       coef(3)=(2*a0t2*(-2+logx)-2*M22*(-2.5+2*logm-logm**2/2.-Pi**
     &  2/6.)-M22*(2+logx2+Zeta2))/(2.*M22)
       coef(4)=a0t2-aet2+((2-logx**2+logx2)*M22)/4.+M22*(-2.5+2*logm-
     &  logm**2/2.-Pi**2/6.)
       coef(5)=((a0t2-logx*M22)*xinverse)/2.
       coef(6)=-aet2+a0t2*logx-(M22*(logx**2+Zeta2))/2.
       coef(7)=-aet2+M22*(-2.5+2*logm-logm**2/2.-Pi**2/6.)
      endif
      if(M12 .lt.epsi .AND. M32.gt.epsi .AND. M22.lt.epsi)then
       logm=Log(M32/Q2)
       coef(1)=(a0t3+a0t3*M32*xinverse+M32*(-1+logx-logx*M32*xinverse))
     &  /(2.*M32**2)
       coef(2)=(a0t3*(-9+6*logx)+M32*(6-12*logm+3*logm**2+3*logx-3*
     &  logx2+Pi**2-3*Zeta2))/(12.*M32)
       coef(3)=(6*a0t3*(-2+logx)+M32*(9-12*logm+3*logm**2-3*logx2+Pi**
     &  2-3*Zeta2))/(6.*M32)
       coef(4)=(-4*a0t3+(-2+logx**2-logx2)*M32)/4.
       coef(5)=(a0t3+a0t3*M32*xinverse+M32*(-1+logx-logx*M32*xinverse))
     &  /(2.*M32)
       coef(6)=(6*a0t3*(-2+logx)+M32*(9-12*logm+3*logm**2-3*logx2+Pi**
     &  2-3*Zeta2))/6.
       coef(7)=-aet3-(M32*(15-12*logm+3*logm**2+Pi**2))/6.
      endif
      end


***********************************************************************
*
c Input: M1**2, M2**2, M3**2, Q2. for small M1
c output: coef(5) coresponding to 
c     F^D_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(1),
c     F^D00001_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(2),  
c     F^D10000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(3),  
c     F^D10001_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(4),
c     F^D01000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(5), 
c     F^D11000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(6), 
c     F^D20000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(7), 
 
      subroutine FD311Z(Mass12,Mass32,Mass22,a0t1,a0t3,a0t2,aet1,aet3,
     .    aet2,Q2,coef,id)
      implicit none
      integer id
      double precision Mass12,Mass32,Mass22,pi
      double precision M12,M22,M32, Q2
      double precision  a0t1,a0t2,a0t3,aet1,aet2,aet3
      double precision lambdaN,A0T,AEpT,a0tM,aetM,logm
      double precision K0T0N, coef(10),ak0t0,zeta2
       double precision regMass2,regmass,logX,logx2,xinverse,xinverse2
       common/regularmass/regMass2,regMass,logX,logx2,xinverse,xinverse2
      M12=Mass12; M22=Mass22; M32=Mass32

      pi= 3.1415926535897932384626433832795029D0
      Zeta2= Pi**2/6.      
      if(M12 .lt.1D-15 .AND. M32.lt.1D-15 .AND. M22.gt.1D-15)then
       logm=Log(M22/Q2)
       coef(1)=(logx+M22*xinverse-logx*M22*xinverse-logm*(1+M22*
     &  xinverse))/(2.*M22)
       coef(2)=(-2*M22*(-2.5+2*logm-logm**2/2.-Pi**2/6.)+logm*M22*(1+
     &  M22*xinverse)+a0t2*(-4+2*logx+M22*xinverse)-M22*(2+logx+logx2+
     &  M22*xinverse+Zeta2))/(4.*M22)
       coef(3)=(2*a0t2*(-2+logx)-2*M22*(-2.5+2*logm-logm**2/2.-Pi**
     &  2/6.)-M22*(2+logx2+Zeta2))/(2.*M22)
       coef(4)=a0t2-aet2+((2-logx**2+logx2)*M22)/4.+M22*(-2.5+2*logm-
     &  logm**2/2.-Pi**2/6.)
       coef(5)=((a0t2-logx*M22)*xinverse)/2.
       coef(6)=-aet2+a0t2*logx-(M22*(logx**2+Zeta2))/2.
       coef(7)=-aet2+M22*(-2.5+2*logm-logm**2/2.-Pi**2/6.)
      endif
      if(M12 .lt.1D-15 .AND. M32.gt.1D-15 .AND. M22.lt.1D-15)then
       logm=Log(M32/Q2)
       coef(1)=(a0t3+a0t3*M32*xinverse+M32*(-1+logx-logx*M32*xinverse))
     &  /(2.*M32**2)
       coef(2)=(a0t3*(-9+6*logx)+M32*(6-12*logm+3*logm**2+3*logx-3*
     &  logx2+Pi**2-3*Zeta2))/(12.*M32)
       coef(3)=(6*a0t3*(-2+logx)+M32*(9-12*logm+3*logm**2-3*logx2+Pi**
     &  2-3*Zeta2))/(6.*M32)
       coef(4)=(-4*a0t3+(-2+logx**2-logx2)*M32)/4.
       coef(5)=(a0t3+a0t3*M32*xinverse+M32*(-1+logx-logx*M32*xinverse))
     &  /(2.*M32)
       coef(6)=(6*a0t3*(-2+logx)+M32*(9-12*logm+3*logm**2-3*logx2+Pi**
     &  2-3*Zeta2))/6.
       coef(7)=-aet3-(M32*(15-12*logm+3*logm**2+Pi**2))/6.
      endif
      end

*
***********************************************************************
*
c Input: M1**2, M2**2, M3**2, Q2.
c output: coef(5) coresponding to 
c     F^D_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(1),
c     F^D00001_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(2),  
c     F^D10000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(3),  
c     F^D10001_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(4),
c     F^D01000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(5), 
c     F^D11000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(6), 
c     F^D20000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(7), 
  
      subroutine FD311CNEW(Mass12,Mass32,Mass22,a0t1,a0t3,a0t2,aet1,aet3,
     .    aet2,Q2,coef,id)
      implicit none
      integer id
      double precision Mass12,Mass32,Mass22
      double precision M12,M22,M32, Q2
      double precision M14,M24,M34,M16,M26,M36,M18,M28,M38,
     .   M1422, M1222,M1224,M1424,M1226,M1434,M1432,M1622,
     .   M2432, M1232,M2232,M1234,M2234
      double precision  alambda, alambda2,
     .   a0t1,a0t2,a0t3,aet1,aet2,aet3,abr1,abr2,abr3,abr4
      double precision lambdaN,A0T,AEpT,a0tM,aetM
      double precision K0T0N, coef(10),ak0t0,ITNX,I0A
       double precision regMass2,regmass,logX,logx2,xinverse,xinverse2
       common/regularmass/regMass2,regMass,logX,logx2,xinverse,xinverse2
      M12=Mass12; M22=Mass22; M32=Mass32
      if (id.eq.2) then
       coef(1)=0D0
       coef(2)=-0.25D0
       coef(3) =-0.5D0
       coef(4)=(-3*M12 - 2*M22)/4.
       coef(5)=0
       coef(6)=-M22 - M32/2.
       coef(7)=(-3*M12-M22-M32)/2.
      else
      M14=M12**2;  M24=M22**2 ; M34=M32**2
      M16=M12*M14; M26=M22*M24; M36=M32*M34
      M18=M14**2;  M28=M24**2;  M38=M34**2
      M1422=M14*M22; M1222=M12*M22;M1224=M12*M24
      M1424=M14*M24;M1226=M12*M26;M1434=M14*M34
      M1432=M14*M32; M1622=M16*M22;M2432=M24*M32
      M1232=M12*M32; M2232=M22*M32; M1234=M12*M34
      M2234=M22*M34
      alambda=LambdaN(M12,M22,M32)
      alambda2=alambda**2
c      a0t1= A0T(M12, Q2);a0t2= A0T(M22, Q2); a0t3= A0T(M32, Q2)
       if (id.eq.1) then
       coef(1)=1/(2.*M12)
       coef(2)=(-a0t1 + M12)/(2.*M12)
       coef(3)= 1 - a0t1/M12
       coef(4)=(-3*a0t1 - 2*a0t2 + M12 - M32)/2.
       coef(5)=(M22 + M32)/(2.*M12)
       coef(6)=-a0t2 + (3*M22)/2. + M32 - (a0t1*(M22 + M32))/M12
       coef(7)=-3*a0t1 - a0t2 - a0t3 + M12 - M22/2. - M32/2.
       elseif (id.eq.0) then
      abr1=M12 + M22 - M32; abr2=M12 + M22 + M32
      abr3=M12 - M22 - M32; abr4=M12 - M22 + M32

c      aet1= AEpT(M12, Q2);aet2= AEpT(M22, Q2); aet3= AEpT(M32, Q2) 
      ak0t0= K0T0N(M12,M22,M32,aet1,aet2,aet3,Q2) 
           if (M12.lt.epsi)then
              if (abs(M22-M32).gt.epsi)then
       coef(1)=-(M22**3+M22*(6*a0t3+2*aet2+4*ak0t0+3*M22)*M32+(-2*
     &  a0t3+2*aet2+3*M22)*M32**2+M32**3+2*aet3*M22*(M22+M32)+2*a0t2*(-
     &  (M22*(M22-3*M32))+a0t3*(M22+M32)))/(2.*(M22-M32)**4)
       coef(2)=(-(M22*(2*a0t2*a0t3+2*(3*a0t2+aet3+ak0t0)*M22+M22**2))+
     &  (6*a0t2*a0t3+2*(5*a0t2+a0t3-aet2+3*aet3+2*ak0t0)*M22+M22**2)*
     &  M32+(2*(a0t3+3*aet2+ak0t0)+5*M22)*M32**2+3*M32**3)/(4.*(M22-
     &  M32)**3)
       coef(3)=-((2*aet3*M22+2*a0t2*(a0t3+M22)+2*(a0t3+aet2)*M32+(M22+
     &  M32)*(ak0t0+M22+M32))/(M22-M32)**2)
       coef(4)=(2*a0t2*(a0t3+M22)+M22*(2*(aet3+ak0t0)+M22)+2*(a0t3+
     &  aet2+M22)*M32+M32**2)/(2.*(M22-M32))
       coef(5)=(M32*(-(M22*(2*a0t2*(a0t3-M22)+M22*(2*aet3+M22)))-(2*
     &  a0t2*a0t3+2*(3*a0t2+3*a0t3+aet2+aet3+2*ak0t0)*M22+3*M22**2)*
     &  M32+(2*a0t3-2*aet2-3*M22)*M32**2-M32**3))/(2.*(M22-M32)**4)
       coef(6)=-((M32*(2*aet3*M22+2*a0t2*(a0t3+M22)+2*(a0t3+aet2)*M32+
     &  (M22+M32)*(ak0t0+M22+M32)))/(M22-M32)**2)
       coef(7)=ak0t0
              else
                if(M22.gt.epsi)then
        coef(1)=(6*a0t2-11*M22)/(18.*M22**2)
       coef(2)=(a0t2**2-6*a0t2*M22+2*M22*(aet2+3*M22))/(4.*M22**2)
       coef(3)=3+(a0t2**2-6*a0t2*M22+2*aet2*M22)/(2.*M22**2)
       coef(4)=-a0t2-aet2-a0t2**2/(2.*M22)-M22
       coef(5)=-0.6111111111111112D0+a0t2/(3.*M22)
       coef(6)=-3*a0t2+aet2+a0t2**2/(2.*M22)+3*M22
       coef(7)=-2*a0t2-a0t2**2/M22-2*(aet2+M22)
                else
                 a0tM= A0T(regMass2, Q2); aetM= AEpT(regMass2,Q2)
      ak0t0= K0T0N(regMass2,regMass2,regMass2,aetM,aetM,aetM,Q2) 
       coef(1)=-(6*a0tM**2-6*a0tM*regMass2+regMass2*(12*aetM+4*ak0t0+
     &  21*regMass2))/(18.*regMass2**3)
       coef(2)=(-6*a0tM**2+2*(21*a0tM-6*aetM+ak0t0)*regMass2-3*
     &  regMass2**2)/(36.*regMass2**2)
       coef(3)=(-6*a0tM**2+2*(21*a0tM-6*aetM+ak0t0)*regMass2-3*
     &  regMass2**2)/(18.*regMass2**2)
       coef(4)=(78*a0tM-12*aetM+26*ak0t0-(6*a0tM**2)/regMass2+15*regMass2)/36.
       coef(5)=-(3*a0tM**2-12*a0tM*regMass2+regMass2*(6*aetM+2*ak0t0+
     &  15*regMass2))/(9.*regMass2**2)
       coef(6)=(48*a0tM-24*aetM+ak0t0-(12*a0tM**2)/regMass2-6*regMass2)/9.
       coef(7)=(78*a0tM-12*aetM+26*ak0t0-(6*a0tM**2)/regMass2+15*regMass2)/18.
                endif
              endif
           else

        if(M32.lt.epsi ) then
          if( abs(M22-M12).lt.epsi)then
       coef(1)=(a0t2-M22)/M22**2
       coef(2)=-(a0t2**2-4*a0t2*M22+2*aet2*M22+M22**2)/(4.*M22**2)
       coef(3)=-(a0t2**2-4*a0t2*M22+2*M22*(aet2+M22))/(2.*M22**2)
       coef(4)=a0t2-(5*a0t2**2)/(4.*M22)-(5*(2*aet2+M22))/4.
       coef(5)=-0.5+a0t2/M22
       coef(6)=3*a0t2-2*aet2-a0t2**2/M22-M22/2.
       coef(7)=a0t2-4*aet2-(2*a0t2**2)/M22-3*M22
          else
          ITNX= I0A(0D0,M12, M22,Q2)
       coef(1)=-((-2*a0t1*M14+a0t2*M14+M12*M14+a0t1*M12*M22-M14*M22)
     &  /(2*M12**2*M14-2*M12*M14*M22))
       coef(2)=(2*a0t1*a0t2+6*a0t1*M12+2*a0t2*M12-2*aet1*M12+2*ITNX*
     &  M12+M12**2-4*a0t1*M22+2*aet1*M22+3*M12*M22)/(4*M12**2-4*M12*
     &  M22)
       coef(3)=(2*a0t1*a0t2+6*a0t1*M12+a0t2*M12-2*aet1*M12+2*ITNX*M12+
     &  M12**2-3*a0t1*M22+2*aet1*M22+3*M12*M22)/(2*M12**2-2*M12*M22)
       coef(4)=(6*a0t2*M12-6*aet1*M12-4*aet2*M12+6*ITNX*M12+3*M12**2+2*
     &  a0t1*(a0t2+5*M12-4*M22)-4*a0t2*M22+6*aet1*M22+4*aet2*M22-4*
     &  ITNX*M22+3*M12*M22-2*M22**2)/(4.*(M12-M22))
       coef(5)=(a0t2*M14+a0t1*M12*M22-M14*M22)/(2.*M12*M14)
       coef(6)=-(2*a0t1*a0t2-3*a0t2*M12+2*aet2*M12-3*a0t1*M22+2*aet1*
     &  M22+M12*M22)/(2.*M12)
       coef(7)=(4*a0t1*a0t2+10*a0t1*M12+3*a0t2*M12-6*aet1*M12-2*aet2*
     &  M12+6*ITNX*M12+3*M12**2-5*a0t1*M22+6*aet1*M22+2*aet2*M22-2*
     &  ITNX*M22+5*M12*M22)/(2*M12-2*M22)
          endif
        elseif(M22.lt.epsi ) then
           if( abs(M32-M12).lt.epsi)then
       coef(1)=a0t3/M32**2-1/M32
       coef(2)=(-3-a0t3**2/M32**2+(4*a0t3-2*aet3)/M32)/4.
       coef(3)=-1-a0t3**2/(2.*M32**2)+(2*a0t3-aet3)/M32
       coef(4)=(-6*aet3-(3*a0t3**2)/M32-7*M32)/4.
       coef(5)=-1+a0t3/M32
       coef(6)=2*a0t3-aet3-a0t3**2/(2.*M32)-M32
       coef(7)=a0t3-4*aet3-(2*a0t3**2)/M32-3*M32
            else
          ITNX= I0A(0D0,M12, M32,Q2)
       coef(1)=-((-2*a0t1*M14+a0t3*M14+M12*M14+a0t1*M12*M32-M14*M32)
     &  /(2*M12**2*M14-2*M12*M14*M32))
       coef(2)=(2*a0t1*a0t3+6*a0t1*M12-2*aet1*M12+2*ITNX*M12+M12**2-2*
     &  a0t1*M32+2*aet1*M32+3*M12*M32)/(4*M12**2-4*M12*M32)
       coef(3)=(2*a0t1*a0t3+6*a0t1*M12+a0t3*M12-2*aet1*M12+2*ITNX*M12+
     &  M12**2-3*a0t1*M32+2*aet1*M32+3*M12*M32)/(2*M12**2-2*M12*M32)
       coef(4)=(6*a0t1*a0t3+10*a0t1*M12-6*aet1*M12+6*ITNX*M12+3*M12**2-
     &  2*a0t1*M32+4*a0t3*M32+6*aet1*M32+7*M12*M32+2*M32**2)/(4*M12-4*
     &  M32)
       coef(5)=-(M32*(M14*(a0t3+M12-M32)+a0t1*(-2*M14+M12*M32)))/(2.*
     &  M12*M14*(M12-M32))
       coef(6)=(M32*(2*ITNX*M12+M12*(a0t3-2*aet1+M12)+a0t1*(2*a0t3+6*
     &  M12-3*M32)+(2*aet1+3*M12)*M32))/(2.*M12*(M12-M32))
       coef(7)=(4*a0t1*a0t3+10*a0t1*M12+3*a0t3*M12-6*aet1*M12-2*aet3*
     &  M12+6*ITNX*M12+3*M12**2-5*a0t1*M32+6*aet1*M32+2*aet3*M32-2*
     &  ITNX*M32+5*M12*M32)/(2*M12-2*M32)
            endif
        else
        coef(1)=-(4*aet1*M12**2*M2232+4*aet2*M12**2*M2232+4*aet3*M12**2
     &  *M2232-a0t1*(2*M18+2*M14*M2232+9*M14*M24-5*M12*M24*(M22-M32)+(M
     &  22-M32)**4-2*a0t2*abr1*M12*M32-7*M16*(M22+M32)-2*a0t3*M22*(M14+
     &  M12*(-M22+M32))+9*M14*M34+5*M12*(M22-M32)*M34)-a0t2*M12*(2*a0t3
     &  *abr3*M12-M16+3*M14*M22-2*M12*M2232-2*M22*M2232-3*M12*M24+M22*M
     &  24+M14*M32+2*M2232*M32-M24*M32+M12*M34+M22*M34-M32*M34)+a0t3*M1
     &  2*(M16+(M22-M32)**3-M14*(M22+3*M32)+M12*(2*M2232-M24+3*M34))+M1
     &  2*(M18+4*ak0t0*M12*M2232+8*M12*M2432-4*M12*M26+(M22-M32)**4+8*M
     &  12*M2232*M32-4*M16*(M22+M32)+M14*(8*M2232+6*(M24+M34))-4*M12*M3
     &  6))/(2.*alambda2*M14)

       coef(2)=(-(a0t3/M12)+M32/M12-(a0t1*M32)/M14+(2*aet2*(M16-M2234+
     &  3*M2432-M26-3*M14*(M22+M32)+3*M12*(M24+M34)-M36)+2*aet3*(M16-M2
     &  234+3*M2432-M26-3*M14*(M22+M32)+3*M12*(M24+M34)-M36)-2*a0t2*(-M
     &  16+3*M14*M22-4*M12*M2232-3*M2234-3*M12*M24-M2432+M26+5*M14*M32-
     &  7*M12*M34+a0t3*(M14-4*M2232+M24-2*M12*(M22+2*M32)+3*M34)+3*M36)
     &  +a0t3*(M18/M12+(M22-M32)**4/M12-(4*M16*(M22+M32))/M12+(6*M14*(M
     &  24+M34))/M12-4*(-2*M2432+M26+M36))-(2*aet1*((M22-M32)**4-M16*(M
     &  22+M32)+M14*(4*M2232+3*(M24+M34))+M12*(5*M2234+M2432-3*(M26+M36
     &  ))))/M12+a0t1*((6*M12*M18)/M14+((M22-M32)**4*M32)/M14-(M18*(22*
     &  M22+19*M32))/M14-(2*M12*(M22-M32)**2*(5*M2232-2*M24+M34))/M14+(
     &  10*M16*(M2232+3*M24+2*M34))/M14+(2*a0t2*M12*(M16-(M22-2*M32)*(M
     &  22-M32)**2-M14*(3*M22+2*M32)-M12*(2*M2232-3*M24+M34)))/M14+(2*a
     &  0t3*M12*(M16-(-(M22)+M32)**2*M32-M14*(2*M22+3*M32)+M12*(-4*M22
     &  32+M24+3*M34)))/M14+2*(7*M2234+13*M2432-3*(3*M26+M36)))-(6*M16*
     &  M24-8*M14*M26-12*M1226*M32-2*M1424*M32+12*M1622*M32+M18*M32+M28
     &  *M32+6*M1224*M34+4*M1422*M34+2*M16*M34-4*M26*M34+4*M1222*M36-2*
     &  M14*M36+6*M24*M36+2*ak0t0*M12*(-M16+M2234-3*M12*M24-3*M2432+M26
     &  +3*M14*(M22+M32)-3*M12*M34+M36)-4*M22*M38+M32*M38-M12*(M18-3*M2
     &  8+M38))/M12)/alambda2)/4.

       coef(3)=(aet2*(M16-3*M14*(M22+M32)-(M22-M32)**2*(M22+M32)+3*M12
     &  *(M24+M34))+aet3*(M16-3*M14*(M22+M32)-(M22-M32)**2*(M22+M32)+3*
     &  M12*(M24+M34))+(a0t3*(M16-(M22-M32)**2*(3*M22+M32)-M14*(5*M22+3
     &  *M32)+M12*(2*M2232+7*M24+3*M34)))/2.+(aet1*(-(M22-M32)**4+M16*(
     &  M22+M32)+3*M12*(M22-M32)**2*(M22+M32)-M14*(4*M2232+3*(M24+M34))
     &  ))/M12+a0t2*(a0t3*(-M14-2*(M22-M32)**2+3*M12*(M22+M32))+(M16-(M
     &  22-M32)**2*(M22+3*M32)-M14*(3*M22+5*M32)+M12*(2*M2232+3*M24+7*M
     &  34))/2.)+a0t1*((a0t2*(M16+3*M12*(-M2232+M24)-(M22-M32)**3-M14*(
     &  3*M22+2*M32)))/M12+(a0t3*(M16+(M22-M32)**3-M14*(2*M22+3*M32)-3*
     &  M12*(M2232-M34)))/M12+((6*M18)/M12+(3*(M22-M32)**4)/M12-(21*M16
     &  *(M22+M32))/M12-15*(M22-M32)**2*(M22+M32)+(M14*(14*M2232+27*(M2
     &  4+M34)))/M12)/2.)+(M18-(M22-M32)**2*(2*M2232+3*(M24+M34))-2*M14
     &  *(8*M2232+3*(M24+M34))+2*ak0t0*(M16-3*M14*(M22+M32)-(M22-M32)**
     &  2*(M22+M32)+3*M12*(M24+M34))+4*M12*(M2234+M2432+2*(M26+M36)))/2
     &  .)/alambda2

        coef(4)=(-3*a0t3+2*aet3+(a0t1*(2*a0t3-3*M32))/M12+M32+(2*aet1*M
     &  32)/M12+(3*M12*M18-6*M18*M22-2*M16*M24+12*M14*M26-9*M12*M28+2*M
     &  22*M28+4*M1226*M32+22*M1424*M32-20*M1622*M32-3*M18*M32-3*M28*M3
     &  2-2*M1224*M34-6*M16*M34+a0t3*(3*M18+12*M12*(M2432-M26)+(M22-M32
     &  )**3*(3*M22+M32)-4*M16*(3*M22+2*M32)+2*M14*(2*M2232+9*M24+3*M34
     &  ))+2*a0t2*(3*M18+2*M22*(M22-M32)**3-11*M16*(M22+M32)+M14*(10*M2
     &  232+15*M24+13*M34)+a0t3*(-3*M16+2*(M22-M32)**3+M14*(8*M22+6*M32
     &  )-M12*(-8*M2232+7*M24+M34))+M12*(7*M2234+7*M2432-9*M26-5*M36))+
     &  2*ak0t0*(3*M18+2*M22*(M22-M32)**3-M16*(11*M22+9*M32)+3*M14*(2*M
     &  2232+5*M24+3*M34)+3*M12*(M2234+3*M2432-3*M26-M36))+4*M1222*M36+
     &  6*M14*M36-2*M24*M36+2*aet3*(2*M18+(M22-M32)**3*(M22+M32)-M16*(7
     &  *M22+5*M32)+M14*(2*M2232+9*M24+3*M34)+M12*(-M2234+5*M2432-5*M26
     &  +M36))+a0t1*(10*M18+(3*(M22-M32)**4*M32)/M12-(M18*(38*M22+29*M3
     &  2))/M12+2*a0t2*(M16-(M22-6*M32)*(M22-M32)**2+M14*(-3*M22+2*M32)
     &  +M12*(-10*M2232+3*M24-9*M34))-2*(M22-M32)**2*(11*M2232-4*M24+5*
     &  M34)+(2*M16*(7*M2232+27*M24+12*M34))/M12+(2*M14*(15*M2234+25*M2
     &  432-17*M26+M36))/M12+2*a0t3*((2*M18)/M12-3*M2432+2*M26-(M22-M32
     &  )**4/M12-(M16*(4*M22+5*M32))/M12+(M14*(-4*M2232+M24+3*M34))/M12
     &  +M36))+2*aet2*(M18+2*(M22-M32)**3*M32-M16*(3*M22+M32)+M14*(-2*M
     &  2232+3*M24-3*M34)+M12*(-5*M2234+M2432-M26+5*M36))+aet1*((-2*(M2
     &  2-M32)**4*M32)/M12+(2*M18*(M22+2*M32))/M12+2*(M22-M32)**2*(8*M2
     &  232-M24+M34)-(2*M16*(2*M2232+3*M24+5*M34))/M12-(2*M14*(13*M2234
     &  +9*M2432-3*(M26+M36)))/M12)+3*M12*M38+6*M22*M38-3*M32*M38)/alam
     &  bda2)/4.

        coef(5)=(-4*aet1*M12**2*M2234-4*aet2*M12**2*M2234-4*aet3*M12**2
     &  *M2234+a0t2*M12*(M18-4*M16*M22-2*a0t3*M12*M2232+7*M14*M2232+M22
     &  *M2234+6*M14*M24+M12*M2432-2*M22*M2432-4*M12*M26+M22*M26+2*a0t3
     &  *M14*M32-5*M16*M32+2*M12*M2232*M32-M2234*M32+2*M2432*M32-M26*M3
     &  2-2*a0t3*M12*M34+7*M14*M34-3*M12*M32*M34)+a0t3*M12*(-2*M12*M223
     &  4-M16*M32+M14*M22*M32+M12*M24*M32-(M22-M32)**3*M32+3*M14*M34-3*
     &  M12*M36)+a0t1*(13*M14*M2432+6*M14*M26-5*M12*M2432*(M22-M32)-4*M
     &  12*M26*(M22-M32)+4*M12*M2232*(M22-M32)*M32+(M22-M32)**4*(M22+M3
     &  2)+M18*(M22+2*M32)+2*a0t3*(M12*M2232*(M22-M32)-M14*M22*M32)-2*a
     &  0t2*abr1*M12*M34+8*M14*M22*M34-M16*(11*M2232+4*M24+7*M34)+9*M14
     &  *M36+5*M12*(M22-M32)*M36)+M12*(8*M16*M2232-4*ak0t0*M12*M2234+4*
     &  M16*M24-10*M14*M2432-6*M14*M26+4*M12*M28-M24*(M22-M32)**3-4*M12
     &  *M2234*M32-M18*(M22+M32)+4*M16*M34-14*M14*M22*M34-12*M12*M24*M3
     &  4+(M22-M32)**3*M34-6*M14*M36+4*M12*M38))/(2.*alambda2*M14)

        coef(6)=(M18*(-M22+M32)+2*M16*(2*M2232+2*M24+ak0t0*M32)-(M22-M3
     &  2)**2*(M22+M32)*(M24+2*ak0t0*M32+3*M34)+2*aet3*M32*(M16-3*M14*(
     &  M22+M32)-(M22-M32)**2*(M22+M32)+3*M12*(M24+M34))+a0t3*M32*(M16-
     &  (M22-M32)**2*(3*M22+M32)-M14*(5*M22+3*M32)+M12*(2*M2232+7*M24+3
     &  *M34))-2*M14*(5*M2432+3*M26+3*(ak0t0+M32)*M34+M22*(3*ak0t0*M32+
     &  11*M34))+2*aet2*(-M18+M16*(4*M22+5*M32)+(M22-M32)**2*(M2232-M24
     &  -2*M34)-M14*(7*M2232+6*M24+9*M34)-M12*(4*M2234+M2432-4*M26-7*M3
     &  6))+a0t2*(3*M18+9*M14*M2232+18*M14*M24+15*M12*M2432-12*M12*M26-
     &  7*M2232*(M22-M32)**2+3*M24*(M22-M32)**2-M16*(12*M22+11*M32)+13*
     &  M14*M34+14*M12*M22*M34+a0t3*(-2*M14*M32-4*(M22-M32)**2*M32+6*M1
     &  2*(M22*M32+M34))-5*M12*M36)-(2*aet1*(M18*M22+(M22-M32)**4*(M22+
     &  M32)-M16*(5*M2232+4*M24+M34)-M12*(M22-M32)**2*(7*M2232+4*M24+3*
     &  M34)+M14*(10*M2234+7*M2432+6*M26+3*M36)))/M12+2*a0t1*((a0t3*(M1
     &  6*M32-M14*(2*M2232+3*M34)+(M22-M32)*(M22**2*M32+M32**3-3*M12*M3
     &  4-2*M22*M34)))/M12+(3*(M22-M32)*(4*M2234-5*M2432-4*M26+5*M36)+(
     &  3*M22**3*M24+39*M14*M2432+18*M14*M26+32*M14*M2232*M32-9*M22**2*
     &  M24*M32-3*M24*M32**3+3*M18*(M22+2*M32)-3*M22**3*M34+9*M22*M24*M
     &  34+9*M22**2*M32*M34+3*M32**3*M34-9*M22*M34**2-3*M16*(11*M2232+4
     &  *M24+7*M34)+27*M14*M36)/M12)/2.-(a0t2*(M18+M22*(M22-M32)**3-M16
     &  *(4*M22+5*M32)+M14*(7*M2232+6*M24+8*M34)+M12*(7*M2234+M2432-4*(
     &  M26+M36))))/M12)+M12*(6*ak0t0*(M2432+M36)+4*(M28+M26*M32+2*M22*
     &  M36+2*M38)))/(2.*alambda2)

       coef(7)=(4*aet1*(-(M22-M32)**4+M16*(M22+M32)+3*M12*(M22-M32)**2
     &  *(M22+M32)-3*M14*(M2232+M24+M34))+a0t3*M12*(3*M16-(M22-M32)**2*
     &  (5*M22+3*M32)-M14*(11*M22+9*M32)+M12*(6*M2232+13*M24+9*M34))+a0
     &  t2*M12*(3*M16-(M22-M32)**2*(3*M22+5*M32)-M14*(9*M22+11*M32)-2*a
     &  0t3*(3*M14+4*(M22-M32)**2-7*M12*(M22+M32))+M12*(6*M2232+9*M24+1
     &  3*M34))+2*ak0t0*(3*M18+(M22-M32)**4-10*M16*(M22+M32)-6*M12*(M22
     &  -M32)**2*(M22+M32)+6*M14*(M2232+2*(M24+M34)))+4*aet2*M12*(M16-3
     &  *M14*(M22+M32)-(M22-M32)**2*(M22+M32)+M12*(M2232+3*(M24+M34)))+
     &  4*aet3*M12*(M16-3*M14*(M22+M32)-(M22-M32)**2*(M22+M32)+M12*(M22
     &  32+3*(M24+M34)))+2*a0t1*(a0t3*(2*M16+2*(M22-M32)**3-3*M14*(M22+
     &  2*M32)-M12*(5*M2232+M24-6*M34))+a0t2*(2*M16-2*(M22-M32)**3-3*M1
     &  4*(2*M22+M32)-M12*(5*M2232-6*M24+M34))+(10*M18+5*(M22-M32)**4-3
     &  5*M16*(M22+M32)-25*M12*(M22-M32)**2*(M22+M32)+M14*(26*M2232+45*
     &  (M24+M34)))/2.)+M12*(3*M18-4*M16*(M22+M32)-6*M14*(4*M2232+M24+M
     &  34)-(M22-M32)**2*(6*M2232+5*(M24+M34))+4*M12*(4*M2234+4*M2432+3
     &  *(M26+M36))))/(2.*alambda2)
         endif
        endif
        endif
      endif
      end

*
***********************************************************************
*
c Input: M1**2, M2**2, M3**2, Q2.
c output: coef(5) coresponding to 
c     F^D_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(1),
c     F^D00001_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(2),  
c     F^D10000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(3),  
c     F^D10001_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(4),
c     F^D01000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(5), 
c     F^D11000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(6), 
c     F^D20000_({3,M1}{1,M3}{0,0}{0,0}{1,M2}) coef(7), 
  
      subroutine FD311C(Mass12,Mass32,Mass22,a0t1,a0t3,a0t2,aet1,aet3,
     .    aet2,Q2,coef,id)
      implicit none
      integer id
      double precision Mass12,Mass32,Mass22
      double precision M12,M22,M32, Q2
      double precision M14,M24,M34,M16,M26,M36,M18,M28,M38,
     .   M1422, M1222,M1224,M1424,M1226,M1434,M1432,M1622,
     .   M2432, M1232,M2232,M1234,M2234
      double precision  alambda, alambda2,
     .   a0t1,a0t2,a0t3,aet1,aet2,aet3,abr1,abr2,abr3,abr4
      double precision lambdaN,A0T,AEpT,a0tM,aetM
      double precision K0T0N, coef(10),ak0t0
       double precision regMass2,regmass,logX,logx2,xinverse,xinverse2
       common/regularmass/regMass2,regMass,logX,logx2,xinverse,xinverse2
      M12=Mass12; M22=Mass22; M32=Mass32
      if (id.eq.2) then
       coef(1)=0D0
       coef(2)=-0.25D0
       coef(3) =-0.5D0
       coef(4)=(-3*M12 - 2*M22)/4.
       coef(5)=0
       coef(6)=-M22 - M32/2.
       coef(7)=(-3*M12-M22-M32)/2.
      else
      M14=M12**2;  M24=M22**2 ; M34=M32**2
      M16=M12*M14; M26=M22*M24; M36=M32*M34
      M18=M14**2;  M28=M24**2;  M38=M34**2
      M1422=M14*M22; M1222=M12*M22;M1224=M12*M24
      M1424=M14*M24;M1226=M12*M26;M1434=M14*M34
      M1432=M14*M32; M1622=M16*M22;M2432=M24*M32
      M1232=M12*M32; M2232=M22*M32; M1234=M12*M34
      M2234=M22*M34
      alambda=LambdaN(M12,M22,M32)
      alambda2=alambda**2
c      a0t1= A0T(M12, Q2);a0t2= A0T(M22, Q2); a0t3= A0T(M32, Q2)
       if (id.eq.1) then
       coef(1)=1/(2.*M12)
       coef(2)=(-a0t1 + M12)/(2.*M12)
       coef(3)= 1 - a0t1/M12
       coef(4)=(-3*a0t1 - 2*a0t2 + M12 - M32)/2.
       coef(5)=(M22 + M32)/(2.*M12)
       coef(6)=-a0t2 + (3*M22)/2. + M32 - (a0t1*(M22 + M32))/M12
       coef(7)=-3*a0t1 - a0t2 - a0t3 + M12 - M22/2. - M32/2.
       elseif (id.eq.0) then
      abr1=M12 + M22 - M32; abr2=M12 + M22 + M32
      abr3=M12 - M22 - M32; abr4=M12 - M22 + M32

c      aet1= AEpT(M12, Q2);aet2= AEpT(M22, Q2); aet3= AEpT(M32, Q2) 
      ak0t0= K0T0N(M12,M22,M32,aet1,aet2,aet3,Q2) 
           if (M12.eq.0)then
              if (M22.ne.M32)then
       coef(1)=-(M22**3+M22*(6*a0t3+2*aet2+4*ak0t0+3*M22)*M32+(-2*
     &  a0t3+2*aet2+3*M22)*M32**2+M32**3+2*aet3*M22*(M22+M32)+2*a0t2*(-
     &  (M22*(M22-3*M32))+a0t3*(M22+M32)))/(2.*(M22-M32)**4)
       coef(2)=(-(M22*(2*a0t2*a0t3+2*(3*a0t2+aet3+ak0t0)*M22+M22**2))+
     &  (6*a0t2*a0t3+2*(5*a0t2+a0t3-aet2+3*aet3+2*ak0t0)*M22+M22**2)*
     &  M32+(2*(a0t3+3*aet2+ak0t0)+5*M22)*M32**2+3*M32**3)/(4.*(M22-
     &  M32)**3)
       coef(3)=-((2*aet3*M22+2*a0t2*(a0t3+M22)+2*(a0t3+aet2)*M32+(M22+
     &  M32)*(ak0t0+M22+M32))/(M22-M32)**2)
       coef(4)=(2*a0t2*(a0t3+M22)+M22*(2*(aet3+ak0t0)+M22)+2*(a0t3+
     &  aet2+M22)*M32+M32**2)/(2.*(M22-M32))
       coef(5)=(M32*(-(M22*(2*a0t2*(a0t3-M22)+M22*(2*aet3+M22)))-(2*
     &  a0t2*a0t3+2*(3*a0t2+3*a0t3+aet2+aet3+2*ak0t0)*M22+3*M22**2)*
     &  M32+(2*a0t3-2*aet2-3*M22)*M32**2-M32**3))/(2.*(M22-M32)**4)
       coef(6)=-((M32*(2*aet3*M22+2*a0t2*(a0t3+M22)+2*(a0t3+aet2)*M32+
     &  (M22+M32)*(ak0t0+M22+M32)))/(M22-M32)**2)
       coef(7)=ak0t0
              else
                if(M22.gt.1D-15)then
        coef(1)=(6*a0t2-11*M22)/(18.*M22**2)
       coef(2)=(a0t2**2-6*a0t2*M22+2*M22*(aet2+3*M22))/(4.*M22**2)
       coef(3)=3+(a0t2**2-6*a0t2*M22+2*aet2*M22)/(2.*M22**2)
       coef(4)=-a0t2-aet2-a0t2**2/(2.*M22)-M22
       coef(5)=-0.6111111111111112D0+a0t2/(3.*M22)
       coef(6)=-3*a0t2+aet2+a0t2**2/(2.*M22)+3*M22
       coef(7)=-2*a0t2-a0t2**2/M22-2*(aet2+M22)
                else
                 a0tM= A0T(regMass2, Q2); aetM= AEpT(regMass2,Q2)
      ak0t0= K0T0N(regMass2,regMass2,regMass2,aetM,aetM,aetM,Q2) 
       coef(1)=-(6*a0tM**2-6*a0tM*regMass2+regMass2*(12*aetM+4*ak0t0+
     &  21*regMass2))/(18.*regMass2**3)
       coef(2)=(-6*a0tM**2+2*(21*a0tM-6*aetM+ak0t0)*regMass2-3*
     &  regMass2**2)/(36.*regMass2**2)
       coef(3)=(-6*a0tM**2+2*(21*a0tM-6*aetM+ak0t0)*regMass2-3*
     &  regMass2**2)/(18.*regMass2**2)
       coef(4)=(78*a0tM-12*aetM+26*ak0t0-(6*a0tM**2)/regMass2+15*regMass2)/36.
       coef(5)=-(3*a0tM**2-12*a0tM*regMass2+regMass2*(6*aetM+2*ak0t0+
     &  15*regMass2))/(9.*regMass2**2)
       coef(6)=(48*a0tM-24*aetM+ak0t0-(12*a0tM**2)/regMass2-6*regMass2)/9.
       coef(7)=(78*a0tM-12*aetM+26*ak0t0-(6*a0tM**2)/regMass2+15*regMass2)/18.
                endif
              endif
       

           else

        if(M32.eq.0 .AND. M22.eq.M12) then
       coef(1)=(a0t2-M22)/M22**2
       coef(2)=-(a0t2**2-4*a0t2*M22+2*aet2*M22+M22**2)/(4.*M22**2)
       coef(3)=-(a0t2**2-4*a0t2*M22+2*M22*(aet2+M22))/(2.*M22**2)
       coef(4)=a0t2-(5*a0t2**2)/(4.*M22)-(5*(2*aet2+M22))/4.
       coef(5)=-0.5+a0t2/M22
       coef(6)=3*a0t2-2*aet2-a0t2**2/M22-M22/2.
       coef(7)=a0t2-4*aet2-(2*a0t2**2)/M22-3*M22
        elseif(M22.eq.0 .AND. M32.eq.M12) then
       coef(1)=a0t3/M32**2-1/M32
       coef(2)=(-3-a0t3**2/M32**2+(4*a0t3-2*aet3)/M32)/4.
       coef(3)=-1-a0t3**2/(2.*M32**2)+(2*a0t3-aet3)/M32
       coef(4)=(-6*aet3-(3*a0t3**2)/M32-7*M32)/4.
       coef(5)=-1+a0t3/M32
       coef(6)=2*a0t3-aet3-a0t3**2/(2.*M32)-M32
       coef(7)=a0t3-4*aet3-(2*a0t3**2)/M32-3*M32
        else
        coef(1)=-(4*aet1*M12**2*M2232+4*aet2*M12**2*M2232+4*aet3*M12**2
     &  *M2232-a0t1*(2*M18+2*M14*M2232+9*M14*M24-5*M12*M24*(M22-M32)+(M
     &  22-M32)**4-2*a0t2*abr1*M12*M32-7*M16*(M22+M32)-2*a0t3*M22*(M14+
     &  M12*(-M22+M32))+9*M14*M34+5*M12*(M22-M32)*M34)-a0t2*M12*(2*a0t3
     &  *abr3*M12-M16+3*M14*M22-2*M12*M2232-2*M22*M2232-3*M12*M24+M22*M
     &  24+M14*M32+2*M2232*M32-M24*M32+M12*M34+M22*M34-M32*M34)+a0t3*M1
     &  2*(M16+(M22-M32)**3-M14*(M22+3*M32)+M12*(2*M2232-M24+3*M34))+M1
     &  2*(M18+4*ak0t0*M12*M2232+8*M12*M2432-4*M12*M26+(M22-M32)**4+8*M
     &  12*M2232*M32-4*M16*(M22+M32)+M14*(8*M2232+6*(M24+M34))-4*M12*M3
     &  6))/(2.*alambda2*M14)

       coef(2)=(-(a0t3/M12)+M32/M12-(a0t1*M32)/M14+(2*aet2*(M16-M2234+
     &  3*M2432-M26-3*M14*(M22+M32)+3*M12*(M24+M34)-M36)+2*aet3*(M16-M2
     &  234+3*M2432-M26-3*M14*(M22+M32)+3*M12*(M24+M34)-M36)-2*a0t2*(-M
     &  16+3*M14*M22-4*M12*M2232-3*M2234-3*M12*M24-M2432+M26+5*M14*M32-
     &  7*M12*M34+a0t3*(M14-4*M2232+M24-2*M12*(M22+2*M32)+3*M34)+3*M36)
     &  +a0t3*(M18/M12+(M22-M32)**4/M12-(4*M16*(M22+M32))/M12+(6*M14*(M
     &  24+M34))/M12-4*(-2*M2432+M26+M36))-(2*aet1*((M22-M32)**4-M16*(M
     &  22+M32)+M14*(4*M2232+3*(M24+M34))+M12*(5*M2234+M2432-3*(M26+M36
     &  ))))/M12+a0t1*((6*M12*M18)/M14+((M22-M32)**4*M32)/M14-(M18*(22*
     &  M22+19*M32))/M14-(2*M12*(M22-M32)**2*(5*M2232-2*M24+M34))/M14+(
     &  10*M16*(M2232+3*M24+2*M34))/M14+(2*a0t2*M12*(M16-(M22-2*M32)*(M
     &  22-M32)**2-M14*(3*M22+2*M32)-M12*(2*M2232-3*M24+M34)))/M14+(2*a
     &  0t3*M12*(M16-(-(M22)+M32)**2*M32-M14*(2*M22+3*M32)+M12*(-4*M22
     &  32+M24+3*M34)))/M14+2*(7*M2234+13*M2432-3*(3*M26+M36)))-(6*M16*
     &  M24-8*M14*M26-12*M1226*M32-2*M1424*M32+12*M1622*M32+M18*M32+M28
     &  *M32+6*M1224*M34+4*M1422*M34+2*M16*M34-4*M26*M34+4*M1222*M36-2*
     &  M14*M36+6*M24*M36+2*ak0t0*M12*(-M16+M2234-3*M12*M24-3*M2432+M26
     &  +3*M14*(M22+M32)-3*M12*M34+M36)-4*M22*M38+M32*M38-M12*(M18-3*M2
     &  8+M38))/M12)/alambda2)/4.

       coef(3)=(aet2*(M16-3*M14*(M22+M32)-(M22-M32)**2*(M22+M32)+3*M12
     &  *(M24+M34))+aet3*(M16-3*M14*(M22+M32)-(M22-M32)**2*(M22+M32)+3*
     &  M12*(M24+M34))+(a0t3*(M16-(M22-M32)**2*(3*M22+M32)-M14*(5*M22+3
     &  *M32)+M12*(2*M2232+7*M24+3*M34)))/2.+(aet1*(-(M22-M32)**4+M16*(
     &  M22+M32)+3*M12*(M22-M32)**2*(M22+M32)-M14*(4*M2232+3*(M24+M34))
     &  ))/M12+a0t2*(a0t3*(-M14-2*(M22-M32)**2+3*M12*(M22+M32))+(M16-(M
     &  22-M32)**2*(M22+3*M32)-M14*(3*M22+5*M32)+M12*(2*M2232+3*M24+7*M
     &  34))/2.)+a0t1*((a0t2*(M16+3*M12*(-M2232+M24)-(M22-M32)**3-M14*(
     &  3*M22+2*M32)))/M12+(a0t3*(M16+(M22-M32)**3-M14*(2*M22+3*M32)-3*
     &  M12*(M2232-M34)))/M12+((6*M18)/M12+(3*(M22-M32)**4)/M12-(21*M16
     &  *(M22+M32))/M12-15*(M22-M32)**2*(M22+M32)+(M14*(14*M2232+27*(M2
     &  4+M34)))/M12)/2.)+(M18-(M22-M32)**2*(2*M2232+3*(M24+M34))-2*M14
     &  *(8*M2232+3*(M24+M34))+2*ak0t0*(M16-3*M14*(M22+M32)-(M22-M32)**
     &  2*(M22+M32)+3*M12*(M24+M34))+4*M12*(M2234+M2432+2*(M26+M36)))/2
     &  .)/alambda2

        coef(4)=(-3*a0t3+2*aet3+(a0t1*(2*a0t3-3*M32))/M12+M32+(2*aet1*M
     &  32)/M12+(3*M12*M18-6*M18*M22-2*M16*M24+12*M14*M26-9*M12*M28+2*M
     &  22*M28+4*M1226*M32+22*M1424*M32-20*M1622*M32-3*M18*M32-3*M28*M3
     &  2-2*M1224*M34-6*M16*M34+a0t3*(3*M18+12*M12*(M2432-M26)+(M22-M32
     &  )**3*(3*M22+M32)-4*M16*(3*M22+2*M32)+2*M14*(2*M2232+9*M24+3*M34
     &  ))+2*a0t2*(3*M18+2*M22*(M22-M32)**3-11*M16*(M22+M32)+M14*(10*M2
     &  232+15*M24+13*M34)+a0t3*(-3*M16+2*(M22-M32)**3+M14*(8*M22+6*M32
     &  )-M12*(-8*M2232+7*M24+M34))+M12*(7*M2234+7*M2432-9*M26-5*M36))+
     &  2*ak0t0*(3*M18+2*M22*(M22-M32)**3-M16*(11*M22+9*M32)+3*M14*(2*M
     &  2232+5*M24+3*M34)+3*M12*(M2234+3*M2432-3*M26-M36))+4*M1222*M36+
     &  6*M14*M36-2*M24*M36+2*aet3*(2*M18+(M22-M32)**3*(M22+M32)-M16*(7
     &  *M22+5*M32)+M14*(2*M2232+9*M24+3*M34)+M12*(-M2234+5*M2432-5*M26
     &  +M36))+a0t1*(10*M18+(3*(M22-M32)**4*M32)/M12-(M18*(38*M22+29*M3
     &  2))/M12+2*a0t2*(M16-(M22-6*M32)*(M22-M32)**2+M14*(-3*M22+2*M32)
     &  +M12*(-10*M2232+3*M24-9*M34))-2*(M22-M32)**2*(11*M2232-4*M24+5*
     &  M34)+(2*M16*(7*M2232+27*M24+12*M34))/M12+(2*M14*(15*M2234+25*M2
     &  432-17*M26+M36))/M12+2*a0t3*((2*M18)/M12-3*M2432+2*M26-(M22-M32
     &  )**4/M12-(M16*(4*M22+5*M32))/M12+(M14*(-4*M2232+M24+3*M34))/M12
     &  +M36))+2*aet2*(M18+2*(M22-M32)**3*M32-M16*(3*M22+M32)+M14*(-2*M
     &  2232+3*M24-3*M34)+M12*(-5*M2234+M2432-M26+5*M36))+aet1*((-2*(M2
     &  2-M32)**4*M32)/M12+(2*M18*(M22+2*M32))/M12+2*(M22-M32)**2*(8*M2
     &  232-M24+M34)-(2*M16*(2*M2232+3*M24+5*M34))/M12-(2*M14*(13*M2234
     &  +9*M2432-3*(M26+M36)))/M12)+3*M12*M38+6*M22*M38-3*M32*M38)/alam
     &  bda2)/4.

        coef(5)=(-4*aet1*M12**2*M2234-4*aet2*M12**2*M2234-4*aet3*M12**2
     &  *M2234+a0t2*M12*(M18-4*M16*M22-2*a0t3*M12*M2232+7*M14*M2232+M22
     &  *M2234+6*M14*M24+M12*M2432-2*M22*M2432-4*M12*M26+M22*M26+2*a0t3
     &  *M14*M32-5*M16*M32+2*M12*M2232*M32-M2234*M32+2*M2432*M32-M26*M3
     &  2-2*a0t3*M12*M34+7*M14*M34-3*M12*M32*M34)+a0t3*M12*(-2*M12*M223
     &  4-M16*M32+M14*M22*M32+M12*M24*M32-(M22-M32)**3*M32+3*M14*M34-3*
     &  M12*M36)+a0t1*(13*M14*M2432+6*M14*M26-5*M12*M2432*(M22-M32)-4*M
     &  12*M26*(M22-M32)+4*M12*M2232*(M22-M32)*M32+(M22-M32)**4*(M22+M3
     &  2)+M18*(M22+2*M32)+2*a0t3*(M12*M2232*(M22-M32)-M14*M22*M32)-2*a
     &  0t2*abr1*M12*M34+8*M14*M22*M34-M16*(11*M2232+4*M24+7*M34)+9*M14
     &  *M36+5*M12*(M22-M32)*M36)+M12*(8*M16*M2232-4*ak0t0*M12*M2234+4*
     &  M16*M24-10*M14*M2432-6*M14*M26+4*M12*M28-M24*(M22-M32)**3-4*M12
     &  *M2234*M32-M18*(M22+M32)+4*M16*M34-14*M14*M22*M34-12*M12*M24*M3
     &  4+(M22-M32)**3*M34-6*M14*M36+4*M12*M38))/(2.*alambda2*M14)

        coef(6)=(M18*(-M22+M32)+2*M16*(2*M2232+2*M24+ak0t0*M32)-(M22-M3
     &  2)**2*(M22+M32)*(M24+2*ak0t0*M32+3*M34)+2*aet3*M32*(M16-3*M14*(
     &  M22+M32)-(M22-M32)**2*(M22+M32)+3*M12*(M24+M34))+a0t3*M32*(M16-
     &  (M22-M32)**2*(3*M22+M32)-M14*(5*M22+3*M32)+M12*(2*M2232+7*M24+3
     &  *M34))-2*M14*(5*M2432+3*M26+3*(ak0t0+M32)*M34+M22*(3*ak0t0*M32+
     &  11*M34))+2*aet2*(-M18+M16*(4*M22+5*M32)+(M22-M32)**2*(M2232-M24
     &  -2*M34)-M14*(7*M2232+6*M24+9*M34)-M12*(4*M2234+M2432-4*M26-7*M3
     &  6))+a0t2*(3*M18+9*M14*M2232+18*M14*M24+15*M12*M2432-12*M12*M26-
     &  7*M2232*(M22-M32)**2+3*M24*(M22-M32)**2-M16*(12*M22+11*M32)+13*
     &  M14*M34+14*M12*M22*M34+a0t3*(-2*M14*M32-4*(M22-M32)**2*M32+6*M1
     &  2*(M22*M32+M34))-5*M12*M36)-(2*aet1*(M18*M22+(M22-M32)**4*(M22+
     &  M32)-M16*(5*M2232+4*M24+M34)-M12*(M22-M32)**2*(7*M2232+4*M24+3*
     &  M34)+M14*(10*M2234+7*M2432+6*M26+3*M36)))/M12+2*a0t1*((a0t3*(M1
     &  6*M32-M14*(2*M2232+3*M34)+(M22-M32)*(M22**2*M32+M32**3-3*M12*M3
     &  4-2*M22*M34)))/M12+(3*(M22-M32)*(4*M2234-5*M2432-4*M26+5*M36)+(
     &  3*M22**3*M24+39*M14*M2432+18*M14*M26+32*M14*M2232*M32-9*M22**2*
     &  M24*M32-3*M24*M32**3+3*M18*(M22+2*M32)-3*M22**3*M34+9*M22*M24*M
     &  34+9*M22**2*M32*M34+3*M32**3*M34-9*M22*M34**2-3*M16*(11*M2232+4
     &  *M24+7*M34)+27*M14*M36)/M12)/2.-(a0t2*(M18+M22*(M22-M32)**3-M16
     &  *(4*M22+5*M32)+M14*(7*M2232+6*M24+8*M34)+M12*(7*M2234+M2432-4*(
     &  M26+M36))))/M12)+M12*(6*ak0t0*(M2432+M36)+4*(M28+M26*M32+2*M22*
     &  M36+2*M38)))/(2.*alambda2)

       coef(7)=(4*aet1*(-(M22-M32)**4+M16*(M22+M32)+3*M12*(M22-M32)**2
     &  *(M22+M32)-3*M14*(M2232+M24+M34))+a0t3*M12*(3*M16-(M22-M32)**2*
     &  (5*M22+3*M32)-M14*(11*M22+9*M32)+M12*(6*M2232+13*M24+9*M34))+a0
     &  t2*M12*(3*M16-(M22-M32)**2*(3*M22+5*M32)-M14*(9*M22+11*M32)-2*a
     &  0t3*(3*M14+4*(M22-M32)**2-7*M12*(M22+M32))+M12*(6*M2232+9*M24+1
     &  3*M34))+2*ak0t0*(3*M18+(M22-M32)**4-10*M16*(M22+M32)-6*M12*(M22
     &  -M32)**2*(M22+M32)+6*M14*(M2232+2*(M24+M34)))+4*aet2*M12*(M16-3
     &  *M14*(M22+M32)-(M22-M32)**2*(M22+M32)+M12*(M2232+3*(M24+M34)))+
     &  4*aet3*M12*(M16-3*M14*(M22+M32)-(M22-M32)**2*(M22+M32)+M12*(M22
     &  32+3*(M24+M34)))+2*a0t1*(a0t3*(2*M16+2*(M22-M32)**3-3*M14*(M22+
     &  2*M32)-M12*(5*M2232+M24-6*M34))+a0t2*(2*M16-2*(M22-M32)**3-3*M1
     &  4*(2*M22+M32)-M12*(5*M2232-6*M24+M34))+(10*M18+5*(M22-M32)**4-3
     &  5*M16*(M22+M32)-25*M12*(M22-M32)**2*(M22+M32)+M14*(26*M2232+45*
     &  (M24+M34)))/2.)+M12*(3*M18-4*M16*(M22+M32)-6*M14*(4*M2232+M24+M
     &  34)-(M22-M32)**2*(6*M2232+5*(M24+M34))+4*M12*(4*M2234+4*M2432+3
     &  *(M26+M36))))/(2.*alambda2)
         endif
        endif
        endif
      endif
      end

*
***********************************************************************
*
c Input: M1**2, M2**2, M3**3, Q2.
c output: coef(5) coresponding to 
c1     F^D_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(1),
c2     F^D00001_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(2),  
c3     F^D01000_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(3),  
c4     F^D10000_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(4),  
c5     F^D10001_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(5), 
c6     F^D11000_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(6), 
c7     F^D00002_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(7),
c8     F^D20000_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(8),
c9     F^D01001_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(9), 
  
      subroutine FD211X(Mass22,Mass12,Mass32,a0t2,a0t1,a0t3,aet2,aet1,
     .    aet3,Q2,coef,id)
      implicit none
      integer id
      double precision Mass12,Mass32,Mass22
      double precision M12,M22,M32, Q2,pi
      double precision M14,M24,M34,M16,M26,M36,M18,M28,M38,
     .   M1422, M1222,M1224,M1424,M1226,M1434,M1432,M1622,
     .   M2432, M1232,M2232,M1234,M2234
      double precision abr11,abr12,abr13,abr14, alambda,
     .   a0t1,a0t2,a0t3,aet1,aet2,aet3
      double precision lambdaN,A0T,AEpT,log12,ITNX,log32
      double precision K0T0N, coef(10),ak0t0,I0A
       double precision regMass2,regmass,logX,logx2,xinverse,xinverse2
       common/regularmass/regMass2,regMass,logX,logx2,xinverse,xinverse2

      M12=Mass12;M22=Mass22;M32=Mass32
      M14=M12**2;  M24=M22**2 ; M34=M32**2
      M16=M12*M14; M26=M22*M24; M36=M32*M34
      M18=M14**2;  M28=M24**2;  M38=M34**2
      M1422=M14*M22; M1222=M12*M22;M1224=M12*M24
      M1424=M14*M24;M1226=M12*M26;M1434=M14*M34
      M1432=M14*M32; M1622=M16*M22;M2432=M24*M32
      M1232=M12*M32; M2232=M22*M32; M1234=M12*M34
      M2234=M22*M34
       pi= 3.1415926535897932384626433832795029D0
      alambda=LambdaN(M12,M22,M32)
      abr11=(M12 + M22 - M32);abr12=(M12 + M22 + M32)
      abr13=(M12 - M22 - M32);abr14=(M12 - M22 + M32)
        if(M22 .lt.epsi)then
          ITNX=I0A(0D0,M12,M32,Q2)
          if (abs(M12-M32).gt.epsi)then
             If(M12.gt.epsi)then
             Log12= Log(M12/Q2)
                if(M32.gt.epsi)then
       coef(1)=-(6*M12*(2*a0t3*logx+(2+logx2)*M12)-12*(a0t3*(-2+logx)+
     &  (-2+logx2)*M12)*M32+6*(2+logx2)*M32**2+12*ITNX*(M12+M32)+12*
     &  a0t1*(2*a0t3+2*M12-logx*M12+logx*M32)+(M12-M32)**2*Pi**2)/(12.*
     &  (M12-M32)**2)
       coef(2)=-(2*a0t1*(a0t3*(M12-M32)+M12*(M12-M32))+2*ITNX*(M12-M32)
     &  *M32+(M12-M32)*(2*aet3*(M12-M32)+2*a0t3*M32+(M12+M32)**2))/(2.*
     &  (M12-M32)**2)
       coef(3)=-(12*ITNX*M12*(M12+M32)+6*((2+logx2)*M12**3+2*aet3*(M12-
     &  M32)**2+M12*(2*a0t3*(2+logx)-(-4+logx2)*M12)*M32-(2*a0t3*logx+
     &  (-2+logx2)*M12)*M32**2+logx2*M32**3+2*a0t1*M12*(2*a0t3+2*M12-
     &  logx*M12+logx*M32))+(M12-M32)**2*(M12+M32)*Pi**2)/(12.*(M12-
     &  M32)**2)
       coef(4)=-aet1-aet3+ITNX
       coef(5)=(-(a0t1*a0t3)-(aet1+2*aet3)*M12+ITNX*(M12-M32)+aet3*M32)/2.
       coef(6)=-((aet1+aet3-ITNX)*M12)
       coef(7)=-(2*a0t3*(-(M12)+M32)**2*M32-ITNX*(M12-3*M32)*(M12-M32)
     &  **2+(M12-M32)**2*(aet1*M12+4*aet3*M12-3*aet3*M32)+(M12**2-
     &  M32**2)**2+a0t1*(3*a0t3*(M12-M32)**2+2*(M12-M32)**2*M12))/(4.*
     &  (M12-M32)**2)
       coef(8)=-((a0t1*a0t3*(M12-M32)**2+(M12-M32)**2*(aet3*M12+
     &  aet1*M32))/(M12-M32)**2)
       coef(9)=(M12*(-2*aet3*(M12-M32)**2+2*ITNX*M32*(-M12+M32)-
     &  (M12-M32)*(2*a0t1*(a0t3+M12)+2*a0t3*M32+(M12+M32)**2)))/(2.*
     &  (M12-M32)**2)

#ifdef BEFORE52020
       coef(1)=-(6*M12*(2*a0t3*logx+(2+logx2)*M12)-12*(a0t3*(-2+logx)+
     &  (-2+logx2)*M12)*M32+6*(2+logx2)*M32**2+12*ITNX*(M12+M32)+12*
     &  a0t1*(2*a0t3+2*M12-logx*M12+logx*M32)+(M12-M32)**2*Pi**2)/(12.*
     &  (M12-M32)**2)
       coef(2)=-(2*aet3*(M12-M32)**2-2*ITNX*M32*(-M12+M32)+(M12-
     &  M32)*(2*a0t1*(a0t3+M12)+2*a0t3*M32+(M12+M32)**2))/(2.*(M12-M32)
     &  **2)
       coef(3)=-(12*ITNX*M12*(M12+M32)+6*((2+logx2)*M12**3+2*aet3*(M12-
     &  M32)**2+M12*(2*a0t3*(2+logx)-(-4+logx2)*M12)*M32-(2*a0t3*logx+
     &  (-2+logx2)*M12)*M32**2+logx2*M32**3+2*a0t1*M12*(2*a0t3+2*M12-
     &  logx*M12+logx*M32))+(M12-M32)**2*(M12+M32)*Pi**2)/(12.*(M12-
     &  M32)**2)
       coef(4)=-aet1-aet3+ITNX
       coef(5)=-(a0t1*a0t3*(M12-M32)**2-ITNX*(M12-M32)**3+(M12-M32)
     &  **2*(aet1*M12+2*aet3*M12-aet3*M32))/(2.*(M12-M32)**2)
       coef(6)=-((aet1+aet3)*M12)+ITNX*M12
       coef(7)=-(2*a0t3*(-(M12)+M32)**2*M32+a0t1*(3*a0t3+2*M12)*(M12-
     &  M32)**2-ITNX*(M12-3*M32)*(M12-M32)**2+(M12-M32)**2*(aet1*
     &  M12+4*aet3*M12-3*aet3*M32)+(M12**2-M32**2)**2)/(4.*(M12-M32)**
     &  2)
       coef(8)=-(4*a0t1*a0t3*(M12-M32)**2+4*(M12-M32)**2*(aet3*M12+
     &  aet1*M32))/(4.*(M12-M32)**2)
#endif
               else
       coef(1)=(6*log12*(log12-2*logx)-6*(-1+logx)**2+Pi**2)/12.
       coef(2)=(-3*M12)/2.+log12*M12
       coef(3)=(M12*(6*log12*(log12-2*logx)-6*(-1+logx)**2+Pi**2))/12.
       coef(4)=(-6*aet1-3*(-4+log12)*log12*M12-M12*(15+Pi**2))/6.
       coef(5)=-(M12*(6*aet1+3*(-4+log12)*log12*M12+M12*(15+Pi**2)))/12.
       coef(6)=-(M12*(6*aet1+3*(-4+log12)*log12*M12+M12*(15+Pi**2)))/6.
       coef(7)=-(M12*(6*aet1+3*(-8+log12)*log12*M12+M12*(33+Pi**2)))/24.
       coef(8)=0
       coef(9)=((-3+2*log12)*M12**2)/2.

               endif
             else
                if(M32.gt.epsi)then
                log32=Log(M32/Q2)
       coef(1)=(12*a0t3*(-2+logx)+6*(-4+log32)*log32*M32+M32*(18-6*
     &  logx2+Pi**2))/(12.*M32)
       coef(2)=a0t3-aet3-((-4+log32)*log32*M32)/2.-(M32*(12+Pi**2))/6.
       coef(3)=-aet3+a0t3*logx-(M32*(6*logx2+Pi**2))/12.
       coef(4)=(-6*aet3-3*(-4+log32)*log32*M32-M32*(15+Pi**2))/6.
       coef(5)=(M32*(6*aet3+3*(-4+log32)*log32*M32+M32*(15+Pi**2)))/12.
       coef(6)=0
       coef(7)=(M32*(-4*a0t3+6*aet3+3*(-4+log32)*log32*M32+M32*(13+Pi**2)))/8.
       coef(8)=0
       coef(9)=0
                endif
             endif
          else
            if (M12.gt.epsi)then
c change here 5/5/2020
       Log12= Log(M12/Q2)
       coef(1)=-(log12*logx)+(18+12*log12+6*log12**2-6*logx2-Pi**2)/12.
       coef(2)=(-2*aet1-5*M12-(-4+log12)*log12*M12)/2.
       coef(3)=-(logx2*M12)+(logx*(6*M12-12*log12*M12))/6.+(-6*aet1+9*
     &  M12+6*log12*M12+3*log12**2*M12-M12*Pi**2)/6.
       coef(4)=-2*aet1-5*M12-(-4+log12)*log12*M12
       coef(5)=-(M12*(2*aet1+M12+(-2+log12)*log12*M12))/2.
       coef(6)=-(M12*(2*aet1+5*M12+(-4+log12)*log12*M12))
       coef(7)=-(M12*(2*aet1+M12+(-2+log12)*log12*M12))/4.
       coef(8)=-(M12*(2*aet1+M12+(-2+log12)*log12*M12))
       coef(9)=-(M12*(2*aet1+5*M12+(-4+log12)*log12*M12))/2.
           else
       coef(1)=(-0.15051341407938396D0)+logx-1.*logx2
       coef(2)=0.
       coef(3)=0.
       coef(4)=0.
       coef(5)=0.
       coef(6)=0.
       coef(7)=0.
       coef(8)=0.
       coef(9)=0.
cend  change here 5/5/2020
           endif
        endif
      endif
      end

*
***********************************************************************
*
c Input: M1**2, M2**2, M3**3, Q2.
c output: coef(5) coresponding to 
c1     F^D_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(1),
c2     F^D00001_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(2),  
c3     F^D01000_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(3),  
c4     F^D10000_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(4),  
c5     F^D10001_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(5), 
c6     F^D11000_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(6), 
c7     F^D00002_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(7),
c8     F^D20000_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(8),
c9     F^D01001_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(9), 
  
      subroutine FD211Z(Mass22,Mass12,Mass32,a0t2,a0t1,a0t3,aet2,aet1,
     .    aet3,Q2,coef,id)
      implicit none
      integer id
      double precision Mass12,Mass32,Mass22
      double precision M12,M22,M32, Q2,pi
      double precision M14,M24,M34,M16,M26,M36,M18,M28,M38,
     .   M1422, M1222,M1224,M1424,M1226,M1434,M1432,M1622,
     .   M2432, M1232,M2232,M1234,M2234
      double precision abr11,abr12,abr13,abr14, alambda,
     .   a0t1,a0t2,a0t3,aet1,aet2,aet3
      double precision lambdaN,A0T,AEpT,log12,ITNX
      double precision K0T0N, coef(10),ak0t0,I0A
       double precision regMass2,regmass,logX,logx2,xinverse,xinverse2
       common/regularmass/regMass2,regMass,logX,logx2,xinverse,xinverse2

      M12=Mass12;M22=Mass22;M32=Mass32
      M14=M12**2;  M24=M22**2 ; M34=M32**2
      M16=M12*M14; M26=M22*M24; M36=M32*M34
      M18=M14**2;  M28=M24**2;  M38=M34**2
      M1422=M14*M22; M1222=M12*M22;M1224=M12*M24
      M1424=M14*M24;M1226=M12*M26;M1434=M14*M34
      M1432=M14*M32; M1622=M16*M22;M2432=M24*M32
      M1232=M12*M32; M2232=M22*M32; M1234=M12*M34
      M2234=M22*M34
       pi= 3.1415926535897932384626433832795029D0

      alambda=LambdaN(M12,M22,M32)
      abr11=(M12 + M22 - M32);abr12=(M12 + M22 + M32)
      abr13=(M12 - M22 - M32);abr14=(M12 - M22 + M32)

      if(M22 .eq.0D0 .and. M32.eq.0D0 .and. M12.gt.epsi)then
          
          ITNX=I0A(0D0,M12,0D0,Q2)
       coef(1)=(-12*ITNX+12*a0t1*(-2+logx)-M12*(12+6*logx2+Pi**2))/(12.*M12)
       coef(2)=-a0t1-M12/2.
       coef(3)=-ITNX+a0t1*(-2+logx)-(M12*(12+6*logx2+Pi**2))/12.
       coef(4)=-aet1+ITNX
       coef(5)=-((aet1-ITNX)*M12)/2.
       coef(6)=-((aet1-ITNX)*M12)
       coef(7)=-(M12*(2*a0t1+aet1-ITNX+M12))/4.
       coef(8)=0
       coef(9)=-(M12*(2*a0t1+M12))/2.
      elseif(M22 .eq.0D0 .and. M12.eq.0D0 .and. M32.gt.epsi)then
          ITNX=I0A(0D0,M32,0D0,Q2)
       coef(1)=(-12*ITNX+12*a0t3*(-2+logx)-M32*(12+6*logx2+Pi**2))/(12.*M32)
       coef(2)=a0t3-aet3+ITNX+M32/2.
       coef(3)=-aet3+a0t3*logx-(M32*(6*logx2+Pi**2))/12.
       coef(4)=-aet3+ITNX
       coef(5)=((aet3-ITNX)*M32)/2.
       coef(6)=0
       coef(7)=-(M32*(2*a0t3-3*aet3+3*ITNX+M32))/4.
       coef(8)=0
       coef(9)=0
      endif

      end


*
***********************************************************************
*
c Input: M1**2, M2**2, M3**3, Q2.
c output: coef(5) coresponding to 
c1     F^D_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(1),
c2     F^D00001_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(2),  
c3     F^D01000_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(3),  
c4     F^D10000_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(4),  
c5     F^D10001_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(5), 
c6     F^D11000_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(6), 
c7     F^D00002_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(7),
c8     F^D20000_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(8),
c9     F^D01001_({2,M2}{1,M1}{0,0}{0,0}{1,M3}) coef(9),  
      subroutine FD211C(Mass22,Mass12,Mass32,a0t2,a0t1,a0t3,aet2,aet1,
     .    aet3,Q2,coef,id)
      implicit none
      integer id
      double precision Mass12,Mass32,Mass22
      double precision M12,M22,M32, Q2,pi
      double precision M14,M24,M34,M16,M26,M36,M18,M28,M38,
     .   M1422, M1222,M1224,M1424,M1226,M1434,M1432,M1622,
     .   M2432, M1232,M2232,M1234,M2234
      double precision abr11,abr12,abr13,abr14, alambda,
     .   a0t1,a0t2,a0t3,aet1,aet2,aet3,ITNX,I0A
      double precision lambdaN,A0T,AEpT
      double precision K0T0N, coef(10),ak0t0

      M12=Mass12;M22=Mass22;M32=Mass32
      M14=M12**2;  M24=M22**2 ; M34=M32**2
      M16=M12*M14; M26=M22*M24; M36=M32*M34
      M18=M14**2;  M28=M24**2;  M38=M34**2
      M1422=M14*M22; M1222=M12*M22;M1224=M12*M24
      M1424=M14*M24;M1226=M12*M26;M1434=M14*M34
      M1432=M14*M32; M1622=M16*M22;M2432=M24*M32
      M1232=M12*M32; M2232=M22*M32; M1234=M12*M34
      M2234=M22*M34
       pi= 3.1415926535897932384626433832795029D0
      if (id.eq.2) then
       coef(1)=-0.5D0
       coef(2)= (-M22 - M32)/2.
       coef(3)=-M12/2. - M32
       coef(4)=(-M12 - 2*M22 - M32)/2.
       coef(5) =(-2*M1232 - M14 - 4*M2232 - 3*M24 + M34)/4.
       coef(6)= (-M14 - 4*M2232 - M12*(2*M22 + M32))/2.
       coef(7)=(-M14 - 10*M2232 - 3*M24-2*M12*(M22+2*M32)+3*M34)/8.
       coef(8)=(-3*M24)/2. - M22*M32 - M12*(M22 + M32)
      elseif (id.eq.1)then
       coef(1)= 0.5D0 - a0t2/M22
       coef(2)= -a0t2 - a0t3 - M12/2.
       coef(3)=-a0t3 + M12/2. + M32 - (a0t2*(M12 + M32))/M22
       coef(4)=-a0t1 - 2*a0t2 - a0t3 + (-M12 - M32)/2.
       coef(5) =-(a0t1*M12)/2. - (3*a0t2*M22)/2. + 
     -  (a0t3*(-2*M12 - 4*M22+M32))/2.+(-4*M1222-M14-M24+M34)/4.
       coef(6)= -(a0t1*M12) - M1232/2. - M14/2. + a0t3*(-M12 - 2*M22)
     -   + M2232 - 2*a0t2*(M12 + M32)
       coef(7)=-(a0t1*M12)/4. + (a0t2*(-2*M12 - 3*M22 - 2*M32))/4. + 
     -  a0t3*(-M12 - 2*M22 + (3*M32)/4.) + 
     -  (-4*M1222 + 2*M1232 - 3*M14 + 4*M2232 - M24 + M34)/8.
       coef(8)=-(a0t3*(M12 + 2*M22)) - a0t1*(2*M22 + M32) - 
     -  (M22*(6*a0t2 + 2*M12 + M22 + 2*M32))/2.

      elseif(id.eq.0)then
      alambda=LambdaN(M12,M22,M32)
      abr11=(M12 + M22 - M32);abr12=(M12 + M22 + M32)
      abr13=(M12 - M22 - M32);abr14=(M12 - M22 + M32)
      ak0t0= K0T0N(M12,M22,M32,aet1,aet2,aet3,Q2) 

      if(M22.eq.0)then
        if(M32.eq.M12) then
           if (M12.gt.epsi)then
       coef(1)=3-(3*a0t1)/M12+aet1/M12+a0t1**2/(2.*M14)
       coef(2)=-a0t1-aet1-a0t1**2/(2.*M12)-M12
       coef(3)=aet1+(a0t1*(-6+a0t1/M12))/2.+3*M12
       coef(4)=-2*(aet1+M12)-(a0t1*(a0t1+2*M12))/M12
       coef(5)=-a0t1**2/2.-aet1*M12
       coef(6)=-a0t1**2-2*a0t1*M12-2*M12*(aet1+M12)
       coef(7)=(-a0t1**2-2*aet1*M12)/4.
       coef(8)=-a0t1**2-2*aet1*M12
       coef(9)=-a0t1**2/2.-a0t1*M12-M12*(aet1+M12)
           else
               print*, "we donot encounter this case 2",m22,m12,m32
               coef(1:9)=0D0
c               stop
           endif
        else
         ITNX=I0A(0D0,M12,M32,Q2)
       coef(1)=(-2*a0t1*(a0t3+M12)+(aet1-aet3)*(M12-M32)-2*a0t3*M32-
     &  ITNX*(M12+M32)-(M12+M32)**2)/(M12-M32)**2
       coef(2)=-(2*aet3*M12+2*a0t1*(a0t3+M12)+2*(a0t3-aet3+ITNX)*M32+
     &  (M12+M32)**2)/(2.*(M12-M32))
       coef(3)=-((M12*(2*a0t1*(a0t3+M12)-(aet1-aet3)*(M12-M32)+2*a0t3*
     &  M32+ITNX*(M12+M32)+(M12+M32)**2))/(M12-M32)**2)
       coef(4)=-aet1-aet3+ITNX
       coef(5)=(-(a0t1*a0t3)-(aet1+2*aet3)*M12+ITNX*(M12-M32)+aet3*M32)/2.
       coef(6)=-((aet1+aet3-ITNX)*M12)
       coef(7)=(-((aet1+4*aet3-ITNX)*M12)-a0t1*(3*a0t3+2*M12)+(-2*a0t3+
     &  3*(aet3-ITNX))*M32-(M12+M32)**2)/4.
       coef(8)=-(a0t1*a0t3)-aet3*M12-aet1*M32
       coef(9)=-(M12*(2*aet3*M12+2*a0t1*(a0t3+M12)+2*(a0t3-aet3+ITNX)*
     &  M32+(M12+M32)**2))/(2.*(M12-M32))
       endif
      
      else


        if( abs(M22-M12).lt.epsi) then
           if(M32.gt.epsi .and. M22.gt.epsi)then
        ITNX=I0A(M22,M22,M32,Q2)
       coef(1)=(-a0t2**2+ITNX*M22+M22*(a0t3-4*aet2+2*M22)+a0t2*(a0t3+6*
     &  M22-M32)+(aet2+M22)*M32)/(M22*(4*M22-M32))
       coef(2)=(2*a0t2*(a0t2-a0t3)+2*(2*a0t2+3*a0t3-4*(aet2+aet3))*M22+
     &  4*M22**2+ITNX*(6*M22-2*M32)+2*(-a0t2-a0t3+aet2+aet3)*M32-M32**
     &  2)/(8*M22-2*M32)
       coef(3)=(ITNX*M22**2+M22*(-(a0t2*(a0t2+3*a0t3))+(6*a0t2+5*a0t3-
     &  4*(aet2+aet3))*M22+2*M22**2)+(M22*(-a0t3-3*aet2+aet3+M22)+a0t2*
     &  (a0t3+3*M22))*M32+(-a0t2+aet2)*M32**2)/(M22*(4*M22-M32))
       coef(4)=(-a0t2**2+M22*(a0t3-12*aet2-4*aet3+2*M22)+ITNX*(5*M22-
     &  M32)+a0t2*(a0t3+6*M22-M32)+(3*aet2+aet3+M22)*M32)/(4*M22-M32)
       coef(5)=(2*M22*(3*a0t2**2+a0t2*(-5*a0t3+2*M22)+M22*(3*a0t3-8*
     &  aet2-12*aet3+2*M22))-(a0t2*(a0t2-2*a0t3)+2*(a0t2+a0t3-2*aet2-5*
     &  aet3)*M22)*M32-(aet3+M22)*M32**2+ITNX*(14*M22**2-8*M22*M32+M32*
     &  *2))/(8*M22-2*M32)
       coef(6)=(M22*(-(a0t2*(a0t2+7*a0t3))+(6*a0t2+5*a0t3-12*(aet2+
     &  aet3))*M22+2*M22**2)+ITNX*M22*(5*M22-M32)+(M22*(-a0t3-5*aet2+3*
     &  aet3+M22)+a0t2*(2*a0t3+3*M22))*M32-(a0t2-2*aet2)*M32**2)/(4*
     &  M22-M32)
       coef(7)=(4*M22*(a0t2*(2*a0t2-7*a0t3)+(2*a0t2+5*a0t3-6*(aet2+2*
     &  aet3))*M22+2*M22**2)+ITNX*(10*M22-3*M32)*(2*M22-M32)-(3*a0t2**
     &  2-8*a0t2*a0t3+2*M22*(6*a0t3+aet2-12*aet3+2*M22))*M32+(2*a0t3+2*
     &  aet2-3*aet3-2*M22)*M32**2+M32**3)/(16*M22-4*M32)
       coef(8)=(M22*(-(a0t2*(a0t2+3*a0t3))+(6*a0t2+a0t3-20*aet2-12*
     &  aet3)*M22+2*M22**2)+ITNX*M22*(9*M22-2*M32)+(a0t2*(a0t3-M22)+
     &  M22*(aet2+3*aet3+M22))*M32+aet2*M32**2)/(4*M22-M32)
       coef(9)=(2*M22*(a0t2*(a0t2-9*a0t3)+(2*a0t2+7*a0t3-4*(aet2+3*
     &  aet3))*M22+2*M22**2)+2*ITNX*M22*(3*M22-M32)+2*(2*a0t2*a0t3+(3*
     &  a0t2-2*a0t3-7*aet2+3*aet3)*M22)*M32-(2*a0t2-4*aet2+M22)*M32**2)
     &  /(8*M22-2*M32)
           elseif(M32.lt.epsi .and. M22.gt.epsi)then
       coef(1)=-(a0t2**2-2*a0t2*M22+2*aet2*M22)/(2.*M22**2)
       coef(2)=-a0t2-aet2-a0t2**2/(2.*M22)-M22
       coef(3)=a0t2-aet2-a0t2**2/(2.*M22)
       coef(4)=-a0t2-3*aet2-(3*a0t2**2)/(2.*M22)-2*M22
       coef(5)=-2*aet2*M22-3*M22**2-a0t2*(a0t2+3*M22)
       coef(6)=(-3*a0t2**2)/2.-(a0t2+3*aet2)*M22-2*M22**2
       coef(7)=(-3*a0t2**2-8*a0t2*M22-2*M22*(3*aet2+4*M22))/4.
       coef(8)=(-5*a0t2**2)/2.-3*a0t2*M22-M22*(5*aet2+4*M22)
       coef(9)=-a0t2**2/2.-a0t2*M22-M22*(aet2+M22)
           elseif(M32.gt.epsi .and. M22.lt.epsi)then
           ITNX=I0A(0D0,0D0,M32,Q2)
       coef(1)=-((2*a0t3-aet3+ITNX+M32)/M32)
       coef(2)=a0t3-aet3+ITNX+M32/2.
       coef(3)=0
       coef(4)=-aet3+ITNX
       coef(5)=((aet3-ITNX)*M32)/2.
       coef(6)=0
       coef(7)=-(M32*(2*a0t3-3*aet3+3*ITNX+M32))/4.
       coef(8)=0
       coef(9)=0
           else
       coef(1)=0
       coef(2)=0
       coef(3)=0
       coef(4)=0
       coef(5)=0
       coef(6)=0
       coef(7)=0
       coef(8)=0
       coef(9)=0
           endif
       elseif(abs(M22-M32).lt.epsi) then
         if(M12.gt.epsi .and. M22.gt.epsi)then
        ITNX=I0A(M12,M22,M22,Q2)
       coef(1)=(a0t1*a0t2-a0t2**2-a0t2*M12+aet2*M12+ITNX*M22+(a0t1+6*
     &  a0t2-4*aet2+M12)*M22+2*M22**2)/(M22*(-M12+4*M22))
       coef(2)=-(-4*a0t2**2+4*aet2*M12+M12**2+2*a0t1*(2*a0t2+M12-2*M22)
     &  +4*ITNX*M22+2*(4*a0t2-8*aet2+M12)*M22)/(2.*(M12-4*M22))
       coef(3)=(-4*a0t2**2*M22+ITNX*M12*M22+a0t1*M12*(a0t2+M22)+(M12+2*
     &  M22)*(aet2*(M12-4*M22)+M12*M22)+a0t2*(-M12**2+4*M12*M22+8*M22**
     &  2))/(-(M12*M22)+4*M22**2)
       coef(4)=(a0t2**2+a0t2*(M12-6*M22)+ITNX*(M12-5*M22)-(aet1+3*aet2)
     &  *(M12-4*M22)-a0t1*(a0t2+M22)-M22*(M12+2*M22))/(M12-4*M22)
       coef(5)=-(a0t2**2*(M12-8*M22)+2*a0t1*(2*a0t2+M12-2*M22)*M22+8*
     &  a0t2*M22**2+M12*M22*(M12+2*M22)+ITNX*(-M12**2+4*M12*M22+4*M22**
     &  2)+(M12-4*M22)*(aet1*M12+2*aet2*(M12+3*M22)))/(2.*(M12-4*M22))
       coef(6)=-((M12*(a0t1*a0t2+a0t2**2-a0t2*M12+aet1*M12+3*aet2*M12)-
     &  ITNX*M12*(M12-5*M22)+(-8*a0t2**2+4*a0t2*M12+M12*(a0t1-4*aet1-8*
     &  aet2+M12))*M22+2*(4*a0t2-8*aet2+M12)*M22**2)/(M12-4*M22))
       coef(7)=-(M12**3+a0t2**2*(M12-20*M22)-ITNX*M12*(M12-8*M22)+2*
     &  a0t1*M12*(2*a0t2+M12-2*M22)+2*M12**2*M22+4*a0t2*M22*(M12+4*M22)
     &  +(M12-4*M22)*(aet1*M12+6*aet2*M12+10*aet2*M22))/(4.*(M12-4*M22)
     &  )
       coef(8)=(-(M12*(a0t1*a0t2+aet2*M12))+(3*a0t1*a0t2+a0t2**2+(a0t2-
     &  3*aet1-aet2)*M12)*M22+ITNX*(2*M12-9*M22)*M22-(a0t1+6*a0t2-12*
     &  aet1-20*aet2+M12)*M22**2-2*M22**3)/(M12-4*M22)
       coef(9)=-(2*a0t1*M12*(2*a0t2+M12-2*M22)-16*a0t2**2*M22+4*ITNX*
     &  M12*M22+(M12**2+4*aet2*(M12-4*M22))*(M12+2*M22)+4*a0t2*M22*
     &  (M12+4*M22))/(2.*(M12-4*M22))
          elseif (M12.lt.epsi .and. M22.gt.epsi) then
       coef(1)=-(a0t2**2-2*a0t2*M22+2*aet2*M22)/(2.*M22**2)
       coef(2)=-((a0t2**2+2*aet2*M22+M22**2)/M22)
       coef(3)=-2*aet2+a0t2*(2-a0t2/M22)
       coef(4)=-a0t2-3*aet2-(3*a0t2**2)/(2.*M22)-2*M22
       coef(5)=(-3*a0t2**2)/2.-M22*(3*aet2+M22)
       coef(6)=-4*aet2*M22+2*a0t2*(-a0t2+M22)
       coef(7)=(-5*a0t2**2)/4.+a0t2*M22-(5*aet2*M22)/2.
       coef(8)=(-5*a0t2**2)/2.-3*a0t2*M22-M22*(5*aet2+4*M22)
       coef(9)=-4*aet2*M22+2*a0t2*(-a0t2+M22)
          elseif (M12.gt.epsi .and. M22.lt.epsi) then
          ITNX=I0A(0D0,0D0,M12,Q2)
       coef(1)=-((2*a0t1-aet1+ITNX+M12)/M12)
       coef(2)=-a0t1-M12/2.
       coef(3)=-2*a0t1+aet1-ITNX-M12
       coef(4)=-aet1+ITNX
       coef(5)=-((aet1-ITNX)*M12)/2.
       coef(6)=(-aet1+ITNX)*M12
       coef(7)=-(M12*(2*a0t1+aet1-ITNX+M12))/4.
       coef(8)=0
       coef(9)=-(M12*(2*a0t1+M12))/2.
          else
       coef(1)=0
       coef(2)=0
       coef(3)=0
       coef(4)=0
       coef(5)=0
       coef(6)=0
       coef(7)=0
       coef(8)=0
       coef(9)=0
          endif
       elseif(abs(M12-M32).lt.epsi) then
         if(M22.gt.epsi .and. M12 .gt.epsi)then
        ITNX=I0A(M12,M12,M22,Q2)
       coef(1)=(2*a0t1**2+6*a0t2*M12-4*aet2*M12+4*M12**2+ITNX*(2*M12-
     &  M22)-2*a0t2*M22+aet2*M22-M22**2-2*a0t1*(a0t2-2*M12+M22))/((4*
     &  M12-M22)*M22)
       coef(2)=(2*a0t1*(a0t1-a0t2)+2*(2*a0t1+3*a0t2-4*(aet1+aet2))*M12+
     &  4*M12**2+ITNX*(6*M12-2*M22)+2*(-a0t1-a0t2+aet1+aet2)*M22-M22**
     &  2)/(8*M12-2*M22)
       coef(3)=(2*M12*(a0t1**2+a0t1*(-3*a0t2+2*M12)+M12*(5*a0t2-4*aet2+
     &  2*M12))+ITNX*M12*(2*M12-M22)+(a0t1*a0t2+(2*a0t1-3*a0t2-4*aet1+
     &  2*aet2)*M12)*M22-(a0t1-aet1+M12)*M22**2)/((4*M12-M22)*M22)
       coef(4)=(2*a0t1*(a0t1-a0t2)+2*(2*a0t1+3*a0t2-4*(aet1+aet2))*M12+
     &  4*M12**2+ITNX*(6*M12-2*M22)+2*(-a0t1-a0t2+aet1+aet2)*M22-M22**
     &  2)/(4*M12-M22)
       coef(5)=(-8*aet1*M12**2+2*M12*(3*a0t2-7*aet1-6*aet2+2*M12)*M22+
     &  ITNX*(10*M12-3*M22)*M22+(-2*a0t2+4*aet1+3*aet2)*M22**2-M22**3-
     &  2*a0t1*M22*(a0t2-2*M12+M22)+a0t1**2*(-4*M12+3*M22))/(8*M12-2*
     &  M22)
       coef(6)=(2*M12*(a0t1**2+a0t1*(-5*a0t2+2*M12)+M12*(5*a0t2-4*aet1-
     &  8*aet2+2*M12))+2*ITNX*M12*(3*M12-M22)+((-3*a0t2-6*aet1+4*aet2)*
     &  M12+2*a0t1*(a0t2+M12))*M22-(a0t1-2*aet1+M12)*M22**2)/(4*M12-
     &  M22)
       coef(7)=(-4*M12*(a0t1**2+4*a0t1*a0t2+2*(-a0t2+aet1+2*aet2)*M12)+
     &  (3*a0t1**2+2*M12*(2*a0t2-15*aet1-4*aet2+2*M12)+2*a0t1*(a0t2+6*
     &  M12))*M22+ITNX*(10*M12-3*M22)*M22+(-4*a0t1-2*a0t2+8*aet1+3*
     &  aet2)*M22**2-M22**3)/(16*M12-4*M22)
       coef(8)=(-8*aet1*M12**2+2*M12*(3*a0t2-7*aet1-6*aet2+2*M12)*M22+
     &  ITNX*(10*M12-3*M22)*M22+(-2*a0t2+4*aet1+3*aet2)*M22**2-M22**3-
     &  2*a0t1*M22*(a0t2-2*M12+M22)+a0t1**2*(-4*M12+3*M22))/(4*M12-M22)
       coef(9)=(2*M12*(a0t1*(a0t1-9*a0t2)+(2*a0t1+7*a0t2-4*(aet1+3*
     &  aet2))*M12+2*M12**2)+2*ITNX*M12*(3*M12-M22)+2*(2*a0t1*a0t2+(3*
     &  a0t1-2*a0t2-7*aet1+3*aet2)*M12)*M22-(2*a0t1-4*aet1+M12)*M22**2)
     &  /(8*M12-2*M22)

         elseif(M22.lt.epsi .and. M12 .gt.epsi)then
       coef(1)=3-(3*a0t1)/M12+aet1/M12+a0t1**2/(2.*M14)
       coef(2)=-a0t1-aet1-a0t1**2/(2.*M12)-M12
       coef(3)=aet1+(a0t1*(-6+a0t1/M12))/2.+3*M12
       coef(4)=-2*(aet1+M12)-(a0t1*(a0t1+2*M12))/M12
       coef(5)=-a0t1**2/2.-aet1*M12
       coef(6)=-a0t1**2-2*a0t1*M12-2*M12*(aet1+M12)
       coef(7)=(-a0t1**2-2*aet1*M12)/4.
       coef(8)=-a0t1**2-2*aet1*M12
       coef(9)=-a0t1**2/2.-a0t1*M12-M12*(aet1+M12)
         elseif(M22.gt.epsi .and. M12 .lt.epsi)then
        ITNX=I0A(0D0,0D0,M22,Q2)
       coef(1)=(2*a0t2-aet2+ITNX+M22)/M22
       coef(2)=a0t2-aet2+ITNX+M22/2.
       coef(3)=0
       coef(4)=2*a0t2-2*aet2+2*ITNX+M22
       coef(5)=(M22*(2*a0t2-3*aet2+3*ITNX+M22))/2.
       coef(6)=0
       coef(7)=(M22*(2*a0t2-3*aet2+3*ITNX+M22))/4.
       coef(8)=M22*(2*a0t2-3*aet2+3*ITNX+M22)
       coef(9)=0

         else
       coef(1)=0
       coef(2)=0
       coef(3)=0
       coef(4)=0
       coef(5)=0
       coef(6)=0
       coef(7)=0
       coef(8)=0
       coef(9)=0
         endif

       else

      coef(1)=(-((a0t1*(2*a0t3+abr14)+abr14*(a0t3+abr12+aet1+aet
     &  3+ak0t0))*M22)+aet2*(-M14+M12*M22+2*M12*M32+M22*M32-M34)+a0t2*(
     &  a0t3*abr11-a0t1*abr13+M14-3*M12*M22+2*M24-2*M12*M32-3*M22*M32+M
     &  34))/(alambda*M22)


      coef(2)=(aet1-(a0t2*M12)/M22+(aet2*M12)/M22+(a0t1*(a0t2-M2
     &  2))/M22+(-2*abr13*aet3*M12-M16-(a0t1*abr11*(a0t2*abr13+(2*a0t3+
     &  abr14)*M22))/M22+aet1*(-M14+(M22-M32)**2)-M14*(M22+M32)+(M22-M3
     &  2)**2*(2*ak0t0+M22+M32)+(a0t2*(-M1224+M1234-2*M1422-2*M1432+M16
     &  +4*a0t3*M12*M22+2*M2234-4*M2432+2*M26-4*M1222*M32))/M22+M12*((M
     &  22-M32)**2-2*ak0t0*(M22+M32))+2*a0t3*((M22-M32)**2-M12*(M22+M32
     &  ))+(aet2*M12*(2*M1232-M14+4*M2232+M24-M34))/M22)/alambda)/2.


       coef(3)=(-(abr14*aet1*M12)-abr14*(abr12+ak0t0)*M12-(a0t1*M
     &  12*(a0t2*abr13+(2*a0t3+abr14)*M22))/M22+aet3*(-2*M14-(M22-M32)*
     &  *2+M12*(3*M22+M32))+a0t3*((M22-M32)**2-M12*(M22+3*M32))+(a0t2*(
     &  2*M1224-M1234+M16-2*M2234+M2432-5*M1222*M32+M32**3-M14*(3*M22+M
     &  32)+a0t3*(-(M22-M32)**2+M12*(3*M22+M32))))/M22+(aet2*(-M16-(-(M
     &  22)+M32)**2*M32+M14*(M22+M32)+M12*(3*M2232+M34)))/M22)/alambda

       coef(4)=-((a0t3*abr14*M22+abr14*aet1*M22+abr14*aet3*M22+a0
     &  t1*(a0t2*abr13+(2*a0t3+abr14)*M22)+aet2*(M14+M32*(-M22+M32)-M12
     &  *(M22+2*M32))+M22*(2*M1232+M14-M24+M34)-ak0t0*(-3*M1222-2*M1232
     &  +M14-3*M2232+2*M24+M34)-a0t2*(a0t3*abr11-3*M1222-2*M1232+M14-3*
     &  M2232+2*M24+M34))/alambda)

       coef(5)=-(a0t2*M12)/2.+aet2*M12+a0t1*(a0t2-M22/2.)+aet1*M2
     &  2+(-(ak0t0*(3*M1224-3*M1234-M16+M14*M22-3*M22**3-5*M2234+7*M243
     &  2+4*M1222*M32+3*M14*M32+M36))+2*a0t3*M22*((M22-M32)**2-M12*(
     &  M22+M32))+M22*(-M16+abr12*(M22-M32)**2-M14*(M22+M32))+aet1*((M2
     &  2-M32)**3+2*M1232*(M22+M32)-M14*(M22+M32))+a0t1*(M22*(-M14+(M22
     &  -M32)**2)+a0t3*(2*M1232-M14+4*M2232-3*M24-M34)+a0t2*(2*M1232-M1
     &  4+M24-M34))-aet3*(M16+M26+M14*M22-6*M12*M2232-3*M12*M24-2*M14
     &  *M32-2*M24*M32+M22*M34+M12*M34)+a0t2*(M16-2*M14*(M22+M32
     &  )+2*(M22-M32)**2*M22+a0t3*(-M14-(M22-M32)**2+2*M12*(3*M22+M32)
     &  )+M12*(-4*M2232-M24+M34))+aet2*(M1432-M16-(-(M22)+M32)**2*M32+
     &  M12*(6*M2232+M24+M34)))/(2.*alambda)


       coef(6)=(-(abr14*aet1*M1222)-a0t1*(a0t2*abr13*M12+(2*a0t3+
     &  abr14)*M1222)+a0t3*M22*((M22-M32)**2-M12*(M22+3*M32))+aet3*M22*
     &  (-3*M14-2*(M22-M32)**2+M12*(5*M22+3*M32))+a0t2*(M16+(-(M22)+
     &  M32)**2*M32-M14*(3*M22+M32)+a0t3*(-M14-2*(M22-M32)**2+M12*(5*M22+
     &  3*M32))-M12*(5*M2232-2*M24+M34))+M12*(-(M22*(2*M1232+M14-M24+M3
     &  4))+ak0t0*(-3*M1222-2*M1232+M14-3*M2232+2*M24+M34))+aet2*(M1422
     &  -M16-2*(-(M22)+M32)**2*M32+M12*(5*M2232+3*M34)))/alambda

       coef(7)=((a0t1*(-(abr11*M22)+a0t2*(M12+2*M22-M32)))/M22+ae
     &  t1*(M12+2*M22-M32)+a0t3*(M22+M32)-aet3*(2*M22+M32)-(a0t2*(M14+M
     &  12*M22-M12*M32-M22*M32-M32**2+a0t3*(2*M22+M32)))/M22+(aet2*(M14
     &  +2*M12*M22-2*M2232-M12*M32-M34))/M22+(-((a0t1*(a0t2*abr11**2*ab
     &  r13+M22*(abr11**2*abr14+a0t3*(3*M14+2*M12*(M22-3*M32)+3*(M22-M3
     &  2)**2))))/M22)+abr11*(-M16+M12*(M22-M32)**2-M14*(M22+M32)+(M22-
     &  M32)**2*(M22+M32)+ak0t0*(M14+3*(M22-M32)**2-4*M12*(M22+M32)))+a
     &  et3*(-3*M16-M14*(M22-7*M32)-(M22-M32)**2*(3*M22-M32)+M12*(6*M22
     &  32+7*M24-5*M34))+a0t3*(3*(M22-M32)**3-M14*(M22+3*M32)-2*M12*(2*
     &  M2232+M24-3*M34))+aet1*(-M1422-M16+(M22-2*M32)*(M22-M32)**2+M12
     &  *(M24+3*M34))+(aet2*(-M18-M16*(M22-3*M32)+(-(M22)+M32)**2*M32*
     &  (-3*M22+M32)+M14*(3*M2232+M24-2*M34)-M12*(M2234-9*M2432-M26+M36
     &  )))/M22+(a0t2*(M1226-3*M1424+2*M1434+M18-M16*M22+2*M24**2-4*M22
     &  *M2432-9*M1224*M32-3*M1422*M32-3*M16*M32-M22**3*M32-M22*M32**3+
     &  a0t3*(10*M1224-2*M1234+M14*M22-3*M22**3-5*M2234+7*M2432+M14*M32
     &  +M32**3)+7*M1222*M34+2*M2232*M34+3*M24*M34+M12*M36-M38))/M22)/a
     &  lambda)/4.

        coef(8)=(-(a0t3*abr14*M24)+aet2*M22*(-M14+(M22-M32)*M32+M12*(M22
     &  +2*M32))+a0t2*M22*(a0t3*abr11+M14-3*M12*M22+2*M24-2*M12*M32-3*M2
     &  2*M32+M34)+aet3*(-M16+M26-M24*M32+2*M14*(M22+M32)-M12*(2*M24-2*
     &  M22*M32+M34))+a0t1*(-(a0t2*abr13*M22)-abr14*M22**2-a0t3*(M14+3*M2
     &  4-2*M22*M32-2*M12*(M22+M32)+M34))+M22*(-(M22*(M14-M24+2*M12*M32
     &  +M34))+ak0t0*(2*M14-5*M12*M22+3*M24-4*M12*M32-5*M22*M32+2*M34))
     &  +aet1*(M26-M14*M32-2*M24*M32+2*M22*M34+M12*(-M24+2*(M22*M32+M34
     &  ))-M36))/alambda


       coef(9)=((M12*(-(a0t2*M12)+aet2*M12+a0t1*(a0t2-M22)+aet1*M22))
     &  /M22+(M12*(a0t2*M12-aet2*M12-aet1*M22+a0t1*(-a0t2+M22))*(-M22**
     &  2+(M12-M32)**2))/(alambda*M22)-(2*M12*(M12+M22-M32)*(-(a0t3*
     &  M12)+aet3*M12+a0t1*(a0t3-M32)+aet1*M32))/alambda+(M12*(-((M12+
     &  M22-M32)*(M12-M22+M32)*(2*a0t1+2*a0t2+2*a0t3+M12+M22+M32))-2*
     &  ak0t0*(-(M22-M32)**2+M12*(M22+M32))))/alambda+(a0t3*M22*(M22+
     &  M32)-(2*M22+M32)*(aet3*M22+aet2*M32)+a0t2*(M32*(M22+M32)-a0t3*
     &  (2*M22+M32)))/M22+((aet3*M22+aet2*M32)*(-((M22-M32)**2*(2*M22-
     &  M32))+2*M12*(2*M22-M32)*(M22+M32)+M12**2*(2*M22+M32))+a0t3*M22*
     &  (M12+M22-M32)*((M22-M32)**2-M12*(3*M22+M32))+a0t2*(a0t3*(-
     &  ((M22-M32)**2*(2*M22-M32))+2*M12*(2*M22-M32)*(M22+M32)+M12**2*
     &  (2*M22+M32))-(M12+M22-M32)*M32*(-(M22-M32)**2+M12*(3*M22+M32)))
     &  )/(alambda*M22))/2.
          endif
        endif
      endif
      end
*
***********************************************************************
*
c Input: M1**2, M2**2, M3**2, Q2.
c output: coef(7) coresponding to 
c     F^D_({3,M1}{2,M2}{0,0}{0,0}{1,M1}) coef(1),
c     F^D00001_({3,M1}{2,M2}{0,0}{0,0}{1,M1}) coef(2),  
c     F^D10000_({3,M1}{2,M2}{0,0}{0,0}{1,M1}) coef(3),  
c     F^D10001_({3,M1}{2,M2}{0,0}{0,0}{1,M1}) coef(4),
c     F^D01000_({3,M1}{2,M2}{0,0}{0,0}{1,M1}) coef(5),  5->7
c     F^D11000_({3,M1}{2,M2}{0,0}{0,0}{1,M1}) coef(6), 
c     F^D20000_({3,M1}{2,M2}{0,0}{0,0}{1,M1}) coef(7),  6->5
  
      subroutine FD321C(Mass12,Mass22,Mass32,a0t1,a0t2,a0t3,aet1,aet2,
     .   aet3,Q2,coef,id)
      implicit none
      integer id
      double precision Mass12,Mass32,Mass22
      double precision M12,M22,M32, Q2
      double precision M14,M24,M34,M16,M26,M36,M18,M28,M38,
     .   M1422, M1222,M1224,M1424,M1226,M1434,M1432,M1622,
     .   M2432, M1232,M2232,M1234,M2234
      double precision abr1,abr2,abr3,abr4, alambda, alambda2,
     .   a0t1,a0t2,a0t3,aet1,aet2,aet3
      double precision lambdaN, A0T, AEpT
      double precision K0T0N,ak0t0,coef(10)

      M12=Mass12; M22=Mass22;M32=Mass32
      M14=M12**2;  M24=M22**2 ; M34=M32**2
      M16=M12*M14; M26=M22*M24; M36=M32*M34
      M18=M14**2;  M28=M24**2;  M38=M34**2
      M1422=M14*M22; M1222=M12*M22;M1224=M12*M24
      M1424=M14*M24;M1226=M12*M26;M1434=M14*M34
      M1432=M14*M32; M1622=M16*M22;M2432=M24*M32
      M1232=M12*M32; M2232=M22*M32; M1234=M12*M34
      M2234=M22*M34
      alambda=LambdaN(M12,M22,M32)
      alambda2=alambda**2
      ak0t0= K0T0N(M12,M22,M32,aet1,aet2,aet3,Q2) 
      if (abs(alambda) .gt. 0D0) then
       coef(1)=(a0t2*(-(M12*(M12-M22)**2*((M12-M22)**2-2*a0t3*(M12+2*
     &  M22)))-(M12-M22)*(-3*M12**3+13*M12**2*M22+3*M12*M22**2-M22**3+
     &  2*a0t3*M12*(3*M12+M22)+2*a0t1*(M12+M22)*(M12+2*M22))*M32+2*((3*
     &  (a0t1+a0t3)-M12)*M12**2+2*M12*(a0t1-a0t3+6*M12)*M22+(-3*a0t1+5*
     &  M12)*M22**2+2*M22**3)*M32**2-2*(M12*(3*a0t1+a0t3+M12)+8*M12*
     &  M22+3*M22**2)*M32**3+(2*a0t1+3*M12+4*M22)*M32**4-M32**5)+M22*
     &  ((M12-M22)**2*((M12-M22)*((M12-M22)**2-a0t3*(5*M12+M22))+a0t1*
     &  ((M12-M22)**2-2*a0t3*(M12+2*M22)))+(-M12+M22)*(M12*(-2*a0t1*
     &  a0t3+2*(a0t1-5*a0t3+2*(aet1+aet2+aet3+ak0t0))*M12+7*M12**2)+(6*
     &  a0t1*a0t3+2*(4*a0t1+a0t3+4*(aet1+aet2+aet3+ak0t0))*M12+11*M12**
     &  2)*M22+(2*a0t1-4*a0t3+M12)*M22**2+5*M22**3)*M32+2*(M12*(a0t1*
     &  a0t3-2*(a0t1+a0t3-2*(aet1+aet2+aet3+ak0t0))*M12+3*M12**2)+M12*
     &  (-6*a0t1-3*a0t3-2*(aet1+aet2+aet3+ak0t0)+M12)*M22+(-6*a0t1+3*
     &  a0t3+5*M12)*M22**2-5*M22**3)*M32**2-2*((a0t3+2*(aet1+aet2+aet3+
     &  ak0t0)-3*M12)*M12+a0t1*(a0t3-5*M12-7*M22)+2*(a0t3+M12)*M22-5*
     &  M22**2)*M32**3+(-5*a0t1+a0t3-7*M12-5*M22)*M32**4+M32**5))/(2.*
     &  alambda**3*M12*M22)
       coef(2)=(a0t2*M14*(-alambda**3+M12**6-2*M12**5*(4*M22+3*M32)+
     &  M12**4*(8*a0t3*M22+23*M22**2+14*M22*M32+15*M32**2)+2*M12*(M22-
     &  M32)*(2*(a0t3-2*M22)*M22**3+M22**2*(4*a0t1+7*M22)*M32+M22*(-2*
     &  a0t3+5*M22)*M32**2-11*M22*M32**3+3*M32**4)-4*M12**3*(8*M22**3+
     &  2*M22*(a0t1+3*M22)*M32-3*M22*M32**2+5*M32**3+3*a0t3*M22*(M22+
     &  M32))+(M22-M32)**3*(M22**3-3*M22**2*M32-M32**3+M22*M32*(4*a0t1+
     &  3*M32))+M12**2*(23*M22**4+4*M22*(3*a0t1-10*M32)*M32**2+15*M32**
     &  4+2*M22**2*M32*(-2*a0t1+8*a0t3+9*M32)))+M22*(2*M14*(alambda**3-
     &  (M22-M32)**6+M12**5*(M22+M32)-M12**4*(5*M22**2+14*M22*M32+5*
     &  M32**2)+M12*(M22-M32)**2*(5*M22**3-M22**2*M32+M22*(4*(aet1+
     &  aet2+aet3+ak0t0)-M32)*M32+5*M32**3)+a0t3*M12*(-((M12-M22)**3*
     &  (M12+5*M22))+2*(M12-M22)*(2*M12**2-M12*M22+5*M22**2)*M32+2*(-3*
     &  M12**2+3*M12*M22+2*M22**2)*M32**2+2*(2*M12+M22)*M32**3-M32**4)+
     &  2*M12**3*(5*M22**3+M22**2*M32+5*M32**3+M22*M32*(-4*(aet1+aet2+
     &  aet3+ak0t0)+M32))+2*M12**2*(-5*M22**4+8*M22**3*M32-5*M32**4+2*
     &  M22**2*M32*(aet1+aet2+aet3+ak0t0+M32)+2*M22*M32**2*(aet1+aet2+
     &  aet3+ak0t0+4*M32)))+a0t1*(-(alambda**3*M12)+M12**5*M14-4*M12**
     &  4*M14*(M22+M32)-4*M14*(M22-M32)**3*(M22*(a0t3+M22)-M32**2)+M12*
     &  *3*M14*(-8*a0t3*M22+7*M22**2+10*M22*M32+7*M32**2)+4*M12**2*M14*
     &  (a0t3*M22*(3*M22-M32)-2*(M22+M32)*(M22**2+3*M22*M32+M32**2))+
     &  M12*(M22-M32)*((M22-M32)**5+M14*(7*M22**3+M22*(-8*a0t3+27*M22)*
     &  M32-27*M22*M32**2-7*M32**3)))))/(4.*alambda**3*M12*M14*M22)
       coef(3)=(a0t2*(M12**6+2*a0t1*(M22-M32)**4*M32-M12**5*(6*M22+7*
     &  M32)+M12**2*(M22-M32)*(9*M22**3+M22*(-2*a0t1+2*a0t3+M22)*M32-
     &  (6*(a0t1+a0t3)+M22)*M32**2-13*M32**3)+M12*(M22-M32)**2*(2*
     &  (a0t3-M22)*M22**2+M22*(4*a0t1+5*M22)*M32-2*(3*a0t1+a0t3)*M32**
     &  2-3*M32**3)+2*M12**4*(7*M22**2+6*M22*M32+9*M32**2+a0t3*(2*M22+
     &  M32))-2*M12**3*(8*M22**3+M22*(2*a0t1+3*M22)*M32+a0t1*M32**2+11*
     &  M32**3+3*a0t3*(M22**2+M32**2)))+M22*(M12*((M12-M22)**3*((M12-
     &  M22)**2-a0t3*(M12+5*M22))-(M12-M22)*(M12**2*(2*a0t3+3*M12)+M12*
     &  (2*a0t3+8*(aet1+aet2+aet3+ak0t0)+7*M12)*M22+(-16*a0t3+4*(aet1+
     &  aet2+aet3+ak0t0)+5*M12)*M22**2+9*M22**3)*M32-2*(M12**2*(-4*
     &  a0t3+2*(aet1+aet2+aet3+ak0t0)+M12)+M12*(-a0t3+6*(aet1+aet2+
     &  aet3+ak0t0)+11*M12)*M22+(-9*a0t3+6*(aet1+aet2+aet3+ak0t0)+7*
     &  M12)*M22**2+9*M22**3)*M32**2+2*(M12*(4*(aet1+aet2+aet3+ak0t0)+
     &  3*M12)+6*(aet1+aet2+aet3+ak0t0+M12)*M22+5*M22**2-a0t3*(3*M12+4*
     &  M22))*M32**3+(a0t3-4*aet1-4*aet2-4*aet3-4*ak0t0+M12+3*M22)*M32*
     &  *4-3*M32**5)+a0t1*(-M12**5-2*(M22-M32)**4*(a0t3-M22+M32)+M12**
     &  4*(6*M22+8*M32)+2*M12**2*(M22-M32)*(3*a0t3*M22+8*M22**2-a0t3*
     &  M32+3*M22*M32-9*M32**2)-M12*(M22-M32)**2*(9*M22**2-2*(a0t3+6*
     &  M22)*M32+3*M32**2)-2*M12**3*(2*a0t3*M22+7*M22**2+a0t3*M32+9*
     &  M22*M32+10*M32**2))))/(2.*alambda**3*M12*M22)
       coef(4)=(a0t2*M12*(-5*alambda**3+5*M12**6+(M22-5*M32)*(M22-M32)*
     &  *5-2*M12**5*(14*M22+15*M32)+M12**4*(63*M22**2+74*M22*M32+75*
     &  M32**2)-M12**2*((24*a0t3-43*M22)*M22**3+56*M22**3*M32+6*M22*(4*
     &  a0t3+5*M22)*M32**2+80*M22*M32**3-75*M32**4)+4*M12**3*(-18*M22**
     &  3-10*M22**2*M32-7*M22*M32**2-25*M32**3+3*a0t3*M22*(M22+M32))+2*
     &  M12*(M22-M32)**2*(-6*M22**3+19*M22**2*M32+14*M22*M32**2-15*M32*
     &  *3+6*a0t3*M22*(M22+M32)))+a0t1*(2*a0t2*(alambda**3-M12**6-(M22-
     &  M32)**6+6*M12**5*(M22+M32)+6*M12*(M22-M32)**3*(M22**2+M22*M32-
     &  M32**2)-3*M12**4*(5*M22**2+6*M22*M32+5*M32**2)+2*M12**3*(M22+
     &  M32)*(10*M22**2-7*M22*M32+10*M32**2)-3*M12**2*(M22-M32)*(5*M22*
     &  *3+M22**2*M32+3*M22*M32**2-5*M32**3))+M22*(-5*alambda**3+M12**
     &  6+5*(M22-M32)**6-8*M12**5*(M22+M32)-12*M12*(M22-M32)**3*(M22*
     &  (a0t3+2*M22)-2*M32**2)-4*M12**3*(M22+M32)*(3*M22*(a0t3+4*M22)+
     &  10*M22*M32+12*M32**2)+M12**4*(27*M22**2+50*M22*M32+27*M32**2)+
     &  M12**2*(M22-M32)*(24*a0t3*M22**2+(M22-M32)*(47*M22**2+98*M22*
     &  M32+47*M32**2))))+2*(aet2*M12*(alambda**3-M12**6-(M22-M32)**6+
     &  6*M12**5*(M22+M32)+4*M12**3*(M22+M32)*(5*M22**2-2*M22*M32+5*
     &  M32**2)-3*M12**4*(5*M22**2+6*M22*M32+5*M32**2)+6*M12*(M22-M32)*
     &  *2*(M22**3+M22**2*M32-M22*M32**2+M32**3)-3*M12**2*(5*M22**4+2*
     &  M22**2*M32**2-4*M22*M32**3+5*M32**4))+M22*(aet1*(alambda**3-
     &  M12**6-(M22-M32)**6+6*M12**5*(M22+M32)+6*M12*(M22-M32)**4*(M22+
     &  M32)-3*M12**2*(M22-M32)**2*(5*M22**2+2*M22*M32+5*M32**2)-3*M12*
     &  *4*(5*M22**2+6*M22*M32+5*M32**2)+20*M12**3*(M22**3+M32**3))+
     &  M12*(2*alambda**3+a0t3*(M12**5+2*(M22-M32)**5-2*M12**4*(4*M22+
     &  3*M32)-M12*(M22-M32)**2*(M22**2-4*M22*M32-9*M32**2)+2*M12**3*
     &  (8*M22**2+5*M22*M32+7*M32**2)+2*M12**2*(-5*M22**3+M22*M32**2-8*
     &  M32**3))+(-(M22-M32)**2+M12*(M22+M32))*(M12**4+(M22-M32)**4-4*
     &  M12**3*(M22+M32)+M12**2*(6*M22**2-8*M22*M32+6*M32**2)-4*M12*
     &  (M22**3+M22*(3*(aet3+ak0t0)+2*M22)*M32+2*M22*M32**2+M32**3)))))
     &  )/(4.*alambda**3*M12*M22)
       coef(5)=(a0t2*M14*((M12-M22)**2*(-((M12-M22)**2*(2*M12-M22))+2*
     &  a0t3*M12*(2*M12+M22))-2*(M12-M22)*((2*a0t1+6*a0t3-3*M12)*M12**
     &  2+M12*(3*a0t1+2*a0t3+9*M12)*M22+(a0t1+3*M12)*M22**2-3*M22**3)*
     &  M32+2*(6*(a0t1+a0t3)*M12**2-2*M12**3+M12*(4*a0t1-a0t3+15*M12)*
     &  M22+6*M12*M22**2+7*M22**3)*M32**2-2*(2*M12*(3*a0t1+a0t3+M12)+3*
     &  (a0t1+4*M12)*M22+8*M22**2)*M32**3+(4*a0t1+6*M12+9*M22)*M32**4-
     &  2*M32**5)+M14*(-((M12-M22)**3*((M12-2*M22)*(M12-M22)**2+a0t3*
     &  M12*(M12+5*M22)))+(M12-M22)*(M12**3*(5*a0t3+6*M12)-M12**2*(-7*
     &  a0t3+8*(aet1+aet2+aet3+ak0t0)+23*M12)*M22-M12*(-a0t3+4*(aet1+
     &  aet2+aet3+ak0t0)+11*M12)*M22**2-(a0t3-15*M12)*M22**3-11*M22**4)
     &  *M32+(-5*M12**3*(2*a0t3+3*M12)+2*M12**2*(-a0t3+8*(aet1+aet2+
     &  aet3+ak0t0)+11*M12)*M22+4*M12*(-a0t3+aet1+aet2+aet3+ak0t0+8*
     &  M12)*M22**2+2*(-2*a0t3+13*M12)*M22**3-25*M22**4)*M32**2+2*(5*
     &  M12**2*(a0t3+2*M12)+M12*(3*a0t3-4*(aet1+aet2+aet3+ak0t0)+11*
     &  M12)*M22+3*(a0t3+2*M12)*M22**2+15*M22**3)*M32**3-(5*M12*(a0t3+
     &  3*M12)+(4*a0t3+29*M12)*M22+20*M22**2)*M32**4+(a0t3+6*M12+7*M22)
     &  *M32**5-M32**6)+a0t1*(2*M12**5*M14-M12**4*M14*(10*M22+11*M32)+
     &  M12**3*M14*(-4*a0t3*M22+21*M22**2+24*M22*M32+25*M32**2)+2*M12**
     &  2*M14*(3*(a0t3-4*M22)*M22**2+2*(a0t3-4*M22)*M22*M32-7*M22*M32**
     &  2-15*M32**3)-M14*(M22-M32)**2*(2*a0t3*M22*(M22+2*M32)+(M22-M32)
     &  *(6*M22**2-5*M22*M32-7*M32**2))+M12*(M22-M32)*((M22-M32)**5+2*
     &  M14*(8*M22**3+M22*(-2*a0t3+M22)*M32-5*M22*M32**2-10*M32**3))))
     &  /(2.*alambda**3*M12*M14)
       coef(6)=(a0t3*M12**6+2*aet2*M12**6+2*aet3*M12**6+2*ak0t0*M12**6+
     &  M12**7-8*a0t3*M12**5*M22+2*aet1*M12**5*M22-10*aet2*M12**5*M22-
     &  10*aet3*M12**5*M22-10*ak0t0*M12**5*M22-M12**6*M22+16*a0t3*M12**
     &  4*M22**2-10*aet1*M12**4*M22**2+20*aet2*M12**4*M22**2+20*aet3*
     &  M12**4*M22**2+20*ak0t0*M12**4*M22**2-10*M12**5*M22**2-10*a0t3*
     &  M12**3*M22**3+20*aet1*M12**3*M22**3-20*aet2*M12**3*M22**3-20*
     &  aet3*M12**3*M22**3-20*ak0t0*M12**3*M22**3+30*M12**4*M22**3-
     &  a0t3*M12**2*M22**4-20*aet1*M12**2*M22**4+10*aet2*M12**2*M22**4+
     &  10*aet3*M12**2*M22**4+10*ak0t0*M12**2*M22**4-35*M12**3*M22**4+
     &  2*a0t3*M12*M22**5+10*aet1*M12*M22**5-2*aet2*M12*M22**5-2*aet3*
     &  M12*M22**5-2*ak0t0*M12*M22**5+19*M12**2*M22**5-2*aet1*M22**6-4*
     &  M12*M22**6+(-M12+M22)*(M12**4*(5*a0t3+2*(-aet1+5*(aet2+aet3+
     &  ak0t0)+M12))+M12**3*(-9*a0t3+14*aet1-10*(aet2+aet3+ak0t0)+23*
     &  M12)*M22+(-3*a0t3+2*(aet1+aet2+aet3+ak0t0)-21*M12)*M12**2*M22**
     &  2+M12*(-5*a0t3-14*aet1+10*(aet2+aet3+ak0t0)+M12)*M22**3+(12*
     &  aet1+19*M12)*M22**4)*M32+(5*(2*a0t3-2*aet1+4*(aet2+aet3+ak0t0)-
     &  M12)*M12**4-2*(a0t3-8*aet1+4*(aet2+aet3+ak0t0)-23*M12)*M12**3*
     &  M22-4*M12**2*(-aet1+2*(aet2+aet3+ak0t0)+5*M12)*M22**2+2*(2*
     &  a0t3+4*aet1-8*(aet2+aet3+ak0t0)-7*M12)*M12*M22**3-(30*aet1+31*
     &  M12)*M22**4)*M32**2-2*(5*(a0t3+2*(-aet1+aet2+aet3+ak0t0-M12))*
     &  M12**3+M12**2*(3*a0t3-10*aet1+2*(aet2+aet3+ak0t0)+9*M12)*M22+
     &  (a0t3-4*(4*aet1+aet2+aet3+ak0t0)-6*M12)*M12*M22**2-(20*aet1+11*
     &  M12)*M22**3)*M32**3+(5*(a0t3-4*aet1+2*(aet2+aet3+ak0t0)-5*M12)*
     &  M12**2+(2*(a0t3-17*aet1+aet2+aet3+ak0t0)-13*M12)*M12*M22-10*(3*
     &  aet1+M12)*M22**2)*M32**4+(-((a0t3+2*(-5*aet1+aet2+aet3+ak0t0-7*
     &  M12))*M12)+(12*aet1+7*M12)*M22)*M32**5-(2*aet1+3*M12)*M32**6+
     &  a0t2*M12*((M12-M22)**2*((2*M12-3*M22)*(M12-M22)**2-2*a0t3*(M12*
     &  *2-5*M12*M22+M22**2))-2*(M12-M22)*(M12**2*(-6*a0t3+7*M12)-7*
     &  M12**2*M22+(6*a0t3+M12)*M22**2+5*M22**3)*M32-2*(6*(2*a0t3-3*
     &  M12)*M12**2+M12*(11*a0t3+3*M12)*M22+2*(6*a0t3+M12)*M22**2+3*
     &  M22**3)*M32**2+4*(-11*M12**2-7*M12*M22-3*M22**2+5*a0t3*(M12+
     &  M22))*M32**3+(-6*a0t3+26*M12+17*M22)*M32**4-6*M32**5)+a0t1*
     &  ((M12-M22)**2*(2*a0t2*(M12-M22)**3+2*a0t3*M12*(M12**2-2*M12*
     &  M22-2*M22**2)+(M12-M22)**2*(6*M12**2-10*M12*M22+5*M22**2))-
     &  (M12-M22)*(M12**3*(8*a0t2+10*a0t3+33*M12)+(2*(a0t2+a0t3)-61*
     &  M12)*M12**2*M22+M12*(-10*a0t2+2*a0t3+3*M12)*M22**2+(12*a0t2-2*
     &  a0t3+65*M12)*M22**3-28*M22**4)*M32+(M12**3*(8*a0t2+20*a0t3+75*
     &  M12)+2*(2*a0t2+8*a0t3-33*M12)*M12**2*M22+2*(2*a0t2+7*a0t3-20*
     &  M12)*M12*M22**2-2*(14*a0t2-4*a0t3+39*M12)*M22**3+65*M22**4)*
     &  M32**2-2*(M12**2*(-2*a0t2+10*a0t3+45*M12)+M12*(-9*a0t2+12*a0t3+
     &  17*M12)*M22+2*(-8*a0t2+3*a0t3+6*M12)*M22**2+40*M22**3)*M32**3+
     &  (10*M12*(-a0t2+a0t3+6*M12)+2*(-9*a0t2+4*a0t3+30*M12)*M22+55*
     &  M22**2)*M32**4+(4*a0t2-2*a0t3-21*M12-20*M22)*M32**5+3*M32**6))
     &  /(2.*alambda**3*M12)
       coef(7)=(2*aet2*(-M12**6+(M22-M32)**5*M32+M12*(M22-2*M32)*(M22-
     &  M32)**3*(M22+3*M32)+M12**5*(5*M22+6*M32)-M12**4*(10*M22**2+13*
     &  M22*M32+15*M32**2)-M12**2*(M22-M32)*(5*M22**3-M22**2*M32+5*M22*
     &  M32**2-15*M32**3)+2*M12**3*(5*M22**3+M22**2*M32+M22*M32**2+10*
     &  M32**3))+a0t2*(5*M12**6+2*(M22-M32)**5*(a0t3+2*M22-M32)-M12**5*
     &  (30*M22+29*M32)+2*M12**4*(M22*(a0t3+37*M22)+41*M22*M32+34*M32**
     &  2)+M12**2*(M22-M32)*(69*M22**3+13*M22**2*M32+M22*(6*a0t3-17*
     &  M32)*M32+(6*a0t3-53*M32)*M32**2)-2*M12**3*(M22**2*(a0t3+48*M22)
     &  +M22*(-2*a0t3+27*M22)*M32-(a0t3-26*M22)*M32**2+41*M32**3)-M12*
     &  (M22-M32)**3*(26*M22**2-M22*M32-17*M32**2+2*a0t3*(M22+3*M32))+
     &  2*a0t1*(-M12**5+(M22-M32)**4*(M22+3*M32)+M12**4*(5*M22+6*M32)-
     &  M12*(M22-M32)**2*(5*M22**2+4*M22*M32+12*M32**2)-M12**3*(10*M22*
     &  *2+14*M22*M32+15*M32**2)+M12**2*(10*M22**3+3*M22**2*M32+19*M32*
     &  *3)))+M22*(-((M12-M22)**5*(2*aet1+2*aet3+2*ak0t0+M12+2*M22))+
     &  (M12-M22)*(5*M12**3*(2*(aet1+aet3+ak0t0)+M12)-(10*(aet1+aet3+
     &  ak0t0)-9*M12)*M12**2*M22-M12*(22*(aet1+aet3+ak0t0)+37*M12)*M22*
     &  *2+(10*(aet1+aet3+ak0t0)-9*M12)*M22**3+8*M22**4)*M32-2*(2*M12**
     &  3*(5*(aet1+aet3+ak0t0)+2*M12)+M12**2*(12*(aet1+aet3+ak0t0)+31*
     &  M12)*M22+3*M12*(6*(aet1+aet3+ak0t0)+11*M12)*M22**2-(10*(aet1+
     &  aet3+ak0t0)+3*M12)*M22**3-5*M22**4)*M32**2+2*((8*(aet1+aet3+
     &  ak0t0)-M12)*M12**2+2*M12*(4*(aet1+aet3+ak0t0)+3*M12)*M22-5*(2*
     &  (aet1+aet3+ak0t0)+3*M12)*M22**2)*M32**3+(M12*(-2*(aet1+aet3+
     &  ak0t0)+11*M12)+(10*(aet1+aet3+ak0t0)+19*M12)*M22-10*M22**2)*
     &  M32**4-(2*aet1+2*aet3+2*ak0t0+3*M12-8*M22)*M32**5-2*M32**6+
     &  a0t3*(M12**5+2*(M22-M32)**5-8*M12**4*(M22+M32)-M12*(M22-M32)**
     &  3*(M22+7*M32)+4*M12**3*(4*M22**2+M22*M32+4*M32**2)+2*M12**2*(-
     &  5*M22**3+9*M22**2*M32+3*M22*M32**2-7*M32**3))+a0t1*(-5*M12**5+
     &  6*(M22-M32)**5-M12*(M22-M32)**3*(29*M22+5*M32)+M12**4*(26*M22+
     &  24*M32)+2*M12**2*(M22-M32)*(28*M22**2+9*M22*M32-11*M32**2)-2*
     &  M12**3*(27*M22**2+19*M22*M32+20*M32**2)+2*a0t3*(-M12**4-4*(M22-
     &  M32)**4+M12**3*(4*M22+5*M32)+M12*(M22-M32)**2*(10*M22+11*M32)-
     &  M12**2*(9*M22**2+12*M22*M32+11*M32**2)))))/(2.*alambda**3*M22)
        else
             
        If(abs(M12-M22) .eq.0D0 ) then
          if (m32.eq.0D0) then    
       coef(1)=-1/(4.*M14)
       coef(2)=1/(4.*M12)
       coef(3)=3/(4.*M12)
       coef(4)=1.75-a0t1/M12
       coef(5)=-5/(4.*M12)+a0t1/M14
       coef(6)=-0.25+(2*a0t1-aet1)/M12-a0t1**2/(2.*M14)
       coef(7)=1.75+(a0t1-aet1)/M12-a0t1**2/(2.*M14)                    
          elseif(abs(M12-M32) .eq.0D0 ) then
       coef(1)=-1/(6.*M14)
       coef(2)=M12/(6.*M14)
       coef(3)=(6*a0t1**2+4*(3*(a0t1+aet1)+ak0t0)*M12+9*M12**2)/(18.*M12**3)
       coef(4)=(6*a0t1**2+3*a0t1*M12+2*M12*(6*aet1+2*ak0t0+9*M12))/(9.*M14)
       coef(5)=(-3*a0t1**2+3*a0t1*M12-2*M12*(3*aet1+ak0t0+6*M12))/(9.*M12**3)
       coef(6)=(9*a0t1+ak0t0+M12)/(3.*M12)
       coef(7)=(12*a0t1**2+60*a0t1*M12+M12*(24*aet1+14*ak0t0+39*M12))/(18.*M14)          
          else 
       coef(1)=-(4*M12**2*(a0t1**2+a0t1*(a0t3+2*M12)+M12*(-a0t3+2*aet1+
     &  aet3+ak0t0+2*M12))-2*M12*(3*a0t1**2+2*a0t1*a0t3+(3*a0t3+2*(2*
     &  aet1+aet3+ak0t0-3*M12))*M12)*M32+(2*a0t1**2+2*a0t1*M12+(a0t3-
     &  12*M12)*M12)*M32**2+(-a0t1+M12)*M32**3)/(2.*M14*(4*M12-M32)**3*
     &  M32)
       coef(2)=(4*M12**2*(a0t1**2+a0t1*(a0t3+2*M12)+M12*(-a0t3+2*aet1+
     &  aet3+ak0t0+2*M12))-2*M12*(3*a0t1**2+2*a0t1*a0t3+(3*a0t3+2*(2*
     &  aet1+aet3+ak0t0-3*M12))*M12)*M32+(2*a0t1**2+2*a0t1*M12+(a0t3-
     &  12*M12)*M12)*M32**2+(-a0t1+M12)*M32**3)/(2.*M12*(4*M12-M32)**3*
     &  M32)
       coef(3)=(28*M12**3*(a0t1**2+a0t1*(a0t3+2*M12)+M12*(-a0t3+2*aet1+
     &  aet3+ak0t0+2*M12))-2*M12**2*(17*a0t1**2+2*a0t1*(5*a0t3-4*M12)+
     &  M12*(-7*a0t3+10*(2*aet1+aet3+ak0t0)+14*M12))*M32+M12*(14*a0t1**
     &  2+a0t1*(4*a0t3-26*M12)+(-a0t3+4*(2*aet1+aet3+ak0t0-M12))*M12)*
     &  M32**2-(a0t1-3*M12)*(2*a0t1+M12)*M32**3)/(2.*M14*(4*M12-M32)**
     &  3*M32)
       coef(4)=(36*M12**2*(a0t1**2+a0t1*(a0t3+2*M12)+M12*(-a0t3+2*aet1+
     &  aet3+ak0t0+2*M12))-2*M12*(15*a0t1**2+(-25*a0t3+6*(2*aet1+aet3+
     &  ak0t0)-46*M12)*M12+a0t1*(6*a0t3+40*M12))*M32+(6*a0t1**2+34*
     &  a0t1*M12-M12*(19*a0t3+68*M12))*M32**2+(-5*a0t1+2*a0t3+13*M12)*
     &  M32**3-M32**4)/(2.*(4*M12-M32)**3*M32)
       coef(5)=(-20*M12**3*(a0t1**2+a0t1*(a0t3+2*M12)+M12*(-a0t3+2*
     &  aet1+aet3+ak0t0+2*M12))+2*M12**2*(9*a0t1**2+(-11*a0t3+4*(2*
     &  aet1+aet3+ak0t0)-42*M12)*M12+4*a0t1*(a0t3+13*M12))*M32+M12*(-4*
     &  a0t1**2-66*a0t1*M12+M12*(9*a0t3+64*M12))*M32**2+(15*a0t1-a0t3-
     &  13*M12)*M12*M32**3+(-a0t1+M12)*M32**4)/(2.*M14*(4*M12-M32)**3*
     &  M32)
       coef(6)=(12*M12**3*(a0t1**2+a0t1*(a0t3+2*M12)+M12*(-a0t3+2*aet1+
     &  aet3+ak0t0+2*M12))+2*M12**2*(-27*a0t1**2+(9*a0t3-48*aet1+8*
     &  (aet3+ak0t0)-18*M12)*M12+4*a0t1*(2*a0t3+39*M12))*M32+M12*(4*
     &  a0t1*(7*a0t1-3*a0t3)-(218*a0t1+7*a0t3+12*(-6*aet1+aet3+ak0t0))*
     &  M12+48*M12**2)*M32**2+(2*a0t1*(-2*a0t1+a0t3)+(47*a0t1+a0t3+2*(-
     &  10*aet1+aet3+ak0t0))*M12-21*M12**2)*M32**3+(-3*a0t1+2*aet1+3*
     &  M12)*M32**4)/(2.*M12*(4*M12-M32)**3*M32)
       coef(7)=(60*M12**3*(a0t1**2+a0t1*(a0t3+2*M12)+M12*(-a0t3+2*aet1+
     &  aet3+ak0t0+2*M12))-2*M12**2*(53*a0t1**2+2*a0t1*(3*a0t3-56*M12)+
     &  (-27*a0t3+76*aet1+6*(aet3+ak0t0)-10*M12)*M12)*M32-M12*(-46*
     &  a0t1**2+M12*(17*a0t3-80*aet1+8*(aet3+ak0t0)+20*M12)+2*a0t1*(4*
     &  a0t3+89*M12))*M32**2+(-6*a0t1**2+(2*(a0t3-10*aet1+aet3+ak0t0)-
     &  5*M12)*M12+a0t1*(2*a0t3+37*M12))*M32**3+2*(-a0t1+aet1+M12)*M32*
     &  *4)/(2.*M12*(4*M12-M32)**3*M32)                           
          endif
        elseif(abs(M12-M32) .eq.0D0 ) then
             if(M22.eq.0D0) then
       coef(1)=a0t1/(3.*M12**3)-7/(36.*M14)
       coef(2)=1/(4.*M12)
       coef(3)=47/(36.*M12)-(2*a0t1)/(3.*M14)
       coef(4)=1.75-a0t1/M12
       coef(5)=-(1/M12)+a0t1/M14
       coef(6)=-1+(2*a0t1-aet1)/M12-a0t1**2/(2.*M14)
       coef(7)=5.805555555555555-(14*a0t1)/(3.*M12)+aet1/M12+a0t1**2/(2.*M14)             
            else
       coef(1)=(8*M12**2*(a0t1**2+a0t1*(a0t2+2*M12)+M12*(-a0t2+2*aet1+
     &  aet2+ak0t0+2*M12))-4*M12*(3*a0t1**2+2*a0t1*a0t2+M12*(3*a0t2+2*
     &  (2*aet1+aet2+ak0t0+5*M12)))*M22+2*(2*a0t1**2+2*a0t1*M12+M12*
     &  (a0t2+12*M12))*M22**2-2*(a0t1+5*M12)*M22**3+M22**4)/(2.*M12*(4*
     &  M12-M22)**3*M22**2)
       coef(2)=(4*M12**2*(a0t1**2+a0t1*(a0t2+2*M12)+M12*(-a0t2+2*aet1+
     &  aet2+ak0t0+2*M12))-2*M12*(3*a0t1**2+2*a0t1*a0t2+(3*a0t2+2*(2*
     &  aet1+aet2+ak0t0-3*M12))*M12)*M22+(2*a0t1**2+2*a0t1*M12+(a0t2-
     &  12*M12)*M12)*M22**2+(-a0t1+M12)*M22**3)/(2.*M12*(4*M12-M22)**3*
     &  M22)
       coef(3)=(8*M12**3*(a0t1**2+a0t1*(a0t2+2*M12)+M12*(-a0t2+2*aet1+
     &  aet2+ak0t0+2*M12))+4*M12**2*(a0t1**2+(9*a0t2+2*(2*aet1+aet2+
     &  ak0t0-M12))*M12+2*a0t1*(a0t2+4*M12))*M22-2*M12*(4*a0t1**2+(9*
     &  a0t2+2*(2*aet1+aet2+ak0t0-8*M12))*M12+2*a0t1*(a0t2+9*M12))*M22*
     &  *2+2*(a0t1**2+7*a0t1*M12+(a0t2-7*M12)*M12)*M22**3+(-2*a0t1+M12)
     &  *M22**4)/(2.*M12*(4*M12-M22)**3*M22**2)
       coef(4)=(36*M12**2*(a0t1**2+a0t1*(a0t2+2*M12)+M12*(-a0t2+2*aet1+
     &  aet2+ak0t0+2*M12))-2*M12*(15*a0t1**2+(-25*a0t2+6*(2*aet1+aet2+
     &  ak0t0)-46*M12)*M12+a0t1*(6*a0t2+40*M12))*M22+(6*a0t1**2+34*
     &  a0t1*M12-M12*(19*a0t2+68*M12))*M22**2+(-5*a0t1+2*a0t2+13*M12)*
     &  M22**3-M22**4)/(2.*(4*M12-M22)**3*M22)
       coef(5)=-(8*M12**3*(a0t1**2+a0t1*(a0t2+2*M12)+M12*(-a0t2+2*aet1+
     &  aet2+ak0t0+2*M12))+4*M12**2*(a0t1*(a0t2-26*M12)+M12*(10*a0t2+2*
     &  aet1+aet2+ak0t0+28*M12))*M22-2*M12*(a0t1**2-30*a0t1*M12+6*a0t2*
     &  M12+38*M12**2)*M22**2+M12*(-12*a0t1+a0t2+22*M12)*M22**3+(a0t1-
     &  2*M12)*M22**4)/(2.*M14*(4*M12-M22)**3*M22)
       coef(6)=(-8*M12**3*(a0t1**2+a0t1*(a0t2+2*M12)+M12*(-a0t2+2*aet1+
     &  aet2+ak0t0+2*M12))+4*M12**2*(-4*a0t1**2+(10*a0t2-10*aet1+11*
     &  (aet2+ak0t0)-4*M12)*M12+a0t1*(11*a0t2+82*M12))*M22+2*M12*(3*
     &  a0t1**2+2*M12*(-6*a0t2+14*aet1-5*(aet2+ak0t0)+21*M12)-2*a0t1*
     &  (5*a0t2+57*M12))*M22**2+((3*a0t2+2*(-10*aet1+aet2+ak0t0-19*M12)
     &  )*M12+2*a0t1*(a0t2+28*M12))*M22**3+(-5*a0t1+2*aet1+4*M12)*M22**
     &  4)/(2.*M12*(4*M12-M22)**3*M22)
       coef(7)=(8*M12**3*(a0t1**2+a0t1*(a0t2+2*M12)+M12*(-a0t2+2*aet1+
     &  aet2+ak0t0+2*M12))+4*M12**2*(21*a0t1**2+M12*(69*a0t2+44*aet1-
     &  10*aet2+22*ak0t0+38*M12)+a0t1*(-10*a0t2+48*M12))*M22-2*M12*(26*
     &  a0t1**2+6*a0t1*(-2*a0t2+17*M12)+3*M12*(33*a0t2+4*(6*aet1-aet2+
     &  3*ak0t0+M12)))*M22**2+2*(4*a0t1**2+(24*a0t2+20*aet1-2*aet2+10*
     &  ak0t0-21*M12)*M12+a0t1*(-2*a0t2+35*M12))*M22**3-(8*a0t1+4*a0t2+
     &  4*aet1+2*ak0t0-17*M12)*M22**4-2*M22**5)/(2.*(4*M12-M22)**3*M22*
     &  *2)     
          endif 
        elseif(abs(M22-M32) .eq.0D0 ) then  
             if(M12.eq.0D0) then   
       coef(1)=-a0t2/(6.*M22**3)+5/(36.*M22**2)
       coef(2)=(-3*a0t2+4*M22)/(9.*M22**2)
       coef(3)=(-2*a0t2+3*M22)/(2.*M22**2)
       coef(4)=1.5-a0t2/M22
       coef(5)=(6*a0t2-17*M22)/(36.*M22**2)
       coef(6)=(a0t2**2-8*a0t2*M22+2*aet2*M22+9*M22**2)/(2.*M22**2)
       coef(7)=-(a0t2**2-2*a0t2*M22+2*aet2*M22)/(2.*M22**2)                     
             else    
       coef(1)=(a0t2*(2*a0t2-M12)*M12**2+M12*(-6*a0t2**2+2*a0t2*M12+
     &  M12**2+a0t1*(-4*a0t2+M12))*M22+2*(2*a0t2**2+a0t1*(2*a0t2-3*M12)
     &  -2*M12*(aet1+2*aet2+ak0t0+3*M12))*M22**2+4*(-a0t1+2*a0t2+aet1+
     &  2*aet2+ak0t0+3*M12)*M22**3+8*M22**4)/(2.*M14*(M12-4*M22)**3*
     &  M22)
       coef(2)=(M12**2*(4*a0t2**2-2*a0t2*M12+M12**2)+2*M12*(-6*a0t2**2+
     &  2*a0t2*M12-5*M12**2+a0t1*(-4*a0t2+M12))*M22+4*(2*a0t2*(a0t1+
     &  a0t2)-(3*a0t1+2*(aet1+2*aet2+ak0t0))*M12+6*M12**2)*M22**2+8*(-
     &  a0t1+2*a0t2+aet1+2*aet2+ak0t0-5*M12)*M22**3+16*M22**4)/(2.*M14*
     &  (M12-4*M22)**3)
       coef(3)=(a0t2*M12**3+M12*(6*a0t2**2-(a0t1+14*a0t2)*M12+M12**2)*
     &  M22-2*(6*a0t2*(a0t1+a0t2)-(7*a0t1+20*a0t2)*M12+4*M12**2)*M22**
     &  2-4*(13*a0t1+6*a0t2+3*(aet1+2*aet2+ak0t0)-M12)*M22**3-24*M22**
     &  4)/(2.*M12*(M12-4*M22)**3*M22)
       coef(4)=(M12**3*(-a0t1+a0t2+M12)+M12*(6*a0t2**2-14*a0t2*M12+11*
     &  (a0t1-M12)*M12)*M22-2*(6*a0t2*(a0t1+a0t2)+(17*a0t1-20*a0t2)*
     &  M12-20*M12**2)*M22**2+12*(a0t1-2*a0t2-aet1-2*aet2-ak0t0-5*M12)*
     &  M22**3-24*M22**4)/(M12*(M12-4*M22)**3)
       coef(5)=(-(M12**2*(-4*a0t2**2+3*a0t2*M12+M12*(-2*a0t1+M12)))+
     &  M12*(-8*a0t1*a0t2-18*a0t2**2-21*a0t1*M12+18*a0t2*M12+13*M12**2)
     &  *M22-2*(-10*a0t2*(a0t1+a0t2)+(-35*a0t1+4*(5*a0t2+aet1+2*aet2+
     &  ak0t0))*M12+32*M12**2)*M22**2+4*(-21*a0t1+5*(2*a0t2+aet1+2*
     &  aet2+ak0t0)+21*M12)*M22**3+40*M22**4)/(2.*M14*(M12-4*M22)**3)
       coef(6)=(M12**2*(-2*a0t2*(-2*a0t1+a0t2)+(6*a0t1+3*a0t2+4*aet2+2*
     &  ak0t0)*M12+M12**2)-M12*(-26*a0t2**2+38*a0t2*M12+M12*(-4*aet1+
     &  40*aet2+20*ak0t0+3*M12)+a0t1*(36*a0t2+67*M12))*M22+2*(-30*a0t2*
     &  *2+64*a0t2*M12+6*(-3*aet1+10*aet2+5*ak0t0-3*M12)*M12+a0t1*(34*
     &  a0t2+125*M12))*M22**2-4*(81*a0t1+30*a0t2-17*aet1+30*aet2+15*
     &  ak0t0-35*M12)*M22**3-120*M22**4)/(2.*M12*(M12-4*M22)**3)
       coef(7)=(M12**2*(-2*a0t1*a0t2+5*a0t2*M12-2*aet2*M12)-M12*(-2*
     &  a0t2**2+2*(29*a0t2+aet1-10*aet2+ak0t0)*M12+M12**2+5*a0t1*(-4*
     &  a0t2+M12))*M22+2*(5*a0t1*(-6*a0t2+5*M12)+2*(a0t2**2+52*a0t2*
     &  M12+M12*(5*aet1-14*aet2+5*ak0t0+2*M12)))*M22**2-4*(33*a0t1+62*
     &  a0t2+15*aet1-2*aet2+15*ak0t0+M12)*M22**3-120*M22**4)/(2.*(M12-
     &  4*M22)**3*M22)                     
             endif
        else                     
        print*, "not encounter this case, FD321C", Sqrt(M12), Sqrt(M22), Sqrt(M32)    
        endif
     
        endif 
      end

*
***********************************************************************
*
c Input: M1**2, M2**2, M3**2, Q2.
c output: coef(7) coresponding to 
c     F^D_({4,M1}{1,M2}{0,0}{0,0}{1,M1}) coef(1),
c     F^D00001_({4,M1}{1,M2}{0,0}{0,0}{1,M1}) coef(2),  
c     F^D10000_({4,M1}{1,M2}{0,0}{0,0}{1,M1}) coef(3),  
c     F^D10001_({4,M1}{1,M2}{0,0}{0,0}{1,M1}) coef(4),
c     F^D01000_({4,M1}{1,M2}{0,0}{0,0}{1,M1}) coef(5),  5->7
c     F^D11000_({4,M1}{1,M2}{0,0}{0,0}{1,M1}) coef(6),  6->5
c     F^D20000_({4,M1}{1,M2}{0,0}{0,0}{1,M1}) coef(7), 
  
      subroutine FD411C(Mass12,Mass22,Mass32,a0t1,a0t2,a0t3,aet1,aet2,
     .   aet3,Q2,coef,id)
      implicit none
      integer id
      double precision Mass12,Mass32,Mass22
      double precision M12,M22,M32, Q2
      double precision M14,M24,M34,M16,M26,M36,M18,M28,M38,
     .   M1422, M1222,M1224,M1424,M1226,M1434,M1432,M1622,
     .   M2432, M1232,M2232,M1234,M2234
      double precision abr1,abr2,abr3,abr4, alambda, alambda2,
     .   a0t1,a0t2,a0t3,aet1,aet2,aet3
      double precision lambdaN, A0T, AEpT
      double precision K0T0N,ak0t0,coef(10)

      M12=Mass12; M22=Mass22;M32=Mass32
      M14=M12**2;  M24=M22**2 ; M34=M32**2
      M16=M12*M14; M26=M22*M24; M36=M32*M34
      M18=M14**2;  M28=M24**2;  M38=M34**2
      M1422=M14*M22; M1222=M12*M22;M1224=M12*M24
      M1424=M14*M24;M1226=M12*M26;M1434=M14*M34
      M1432=M14*M32; M1622=M16*M22;M2432=M24*M32
      M1232=M12*M32; M2232=M22*M32; M1234=M12*M34
      M2234=M22*M34
      alambda=LambdaN(M12,M22,M32)
      alambda2=alambda**2
      ak0t0= K0T0N(M12,M22,M32,aet1,aet2,aet3,Q2) 
      if (abs(alambda) .gt. 0D0) then
       coef(1)=-(a0t2*M12*(-2*M12**5+(M22-M32)**5+6*a0t3*M12**2*(-M12+
     &  M22+M32)**2+M12**4*(9*M22+M32)-2*M12**3*(8*M22**2+3*a0t1*M32+7*
     &  M22*M32-5*M32**2)+2*M12**2*(7*M22**3+4*M22**2*M32+6*a0t1*M32**
     &  2+9*M22*M32**2-8*M32**3)-2*M12*(M22-M32)*(3*M22**3-M22*(3*a0t1+
     &  2*M22)*M32-(3*a0t1+5*M22)*M32**2+4*M32**3))-a0t1*(-2*M12**6-
     &  (M22-M32)**6+10*M12**5*(M22+M32)+6*M12*(M22-M32)**4*(M22+M32)+
     &  M12**4*(6*a0t3*M22-21*M22**2-22*M22*M32-21*M32**2)+2*M12**2*
     &  (M22-M32)*(3*a0t3*M22*(M22+M32)-2*(M22-M32)*(4*M22**2+7*M22*
     &  M32+4*M32**2))+4*M12**3*(-3*a0t3*M22**2+(M22+M32)*(6*M22**2-
     &  M22*M32+6*M32**2)))+M12*(M12*(M12-M22-M32)*(M12**4+(M22-M32)**
     &  4-4*M12**3*(M22+M32)+M12**2*(6*M22**2-8*M22*M32+6*M32**2)-4*
     &  M12*(M22**3+M22*(3*(aet1+aet2+aet3+ak0t0)+2*M22)*M32+2*M22*M32*
     &  *2+M32**3))+a0t3*(-2*M12**5-(M22-M32)**5+2*M12*(M22-M32)**3*(4*
     &  M22+3*M32)+M12**4*(M22+9*M32)+2*M12**3*(5*M22**2-7*M22*M32-8*
     &  M32**2)+2*M12**2*(-8*M22**3+9*M22**2*M32+4*M22*M32**2+7*M32**3)
     &  )))/(6.*alambda**3*M12**3)
     

       coef(2)=(2*M12**2*M14*(-((M12-M22)**3*((M12-M22)**2*(2*M12-M22)+
     &  a0t3*(M12**2-5*M12*M22-2*M22**2)))+(M12-M22)*(M12**3*(5*a0t3+
     &  12*M12)-M12**2*(13*a0t3+21*M12)*M22+M12*(5*a0t3+12*(aet1+aet2+
     &  aet3+ak0t0)+11*M12)*M22**2+(-9*a0t3+29*M12)*M22**3-7*M22**4)*
     &  M32+2*(-5*M12**3*(a0t3+3*M12)+M12**2*(3*a0t3+11*M12)*M22+M12*
     &  (4*a0t3+6*(aet1+aet2+aet3+ak0t0)+17*M12)*M22**2+(-8*a0t3+9*M12)
     &  *M22**3-10*M22**4)*M32**2+2*(5*M12**2*(a0t3+4*M12)+M12*(5*a0t3+
     &  11*M12)*M22+(7*a0t3+16*M12)*M22**2+15*M22**3)*M32**3-(5*a0t3*
     &  M12+30*M12**2+6*a0t3*M22+33*M12*M22+25*M22**2)*M32**4+(a0t3+12*
     &  M12+11*M22)*M32**5-2*M32**6)+a0t2*M12**2*(alambda**3*M12-M12**
     &  5*M14+M12**4*M14*(8*M22+6*M32)-M12**3*M14*(12*a0t3*M22+23*M22**
     &  2+2*M22*M32+15*M32**2)+4*M12**2*M14*(6*a0t3*M22**2+8*M22**3-
     &  M22**2*M32+3*M22*(a0t1-2*M32)*M32+5*M32**3)+2*M14*(M22-M32)**2*
     &  (4*M22**3-5*M22**2*M32+3*M32**3-2*M22*M32*(3*a0t1+M32))-M12*
     &  (M22-M32)*((M22-M32)**5+12*a0t3*M14*M22*(M22+M32)+M14*(23*M22**
     &  3+3*M22**2*M32+13*M22*M32**2-15*M32**3)))+a0t1*(4*M12**7*M14-
     &  M14*M22*(-alambda**3+(M22-M32)**6)-M12**6*M14*(25*M22+22*M32)+
     &  2*M12**5*M14*(32*M22**2+31*M22*M32+25*M32**2)+M12**4*M14*(12*
     &  a0t3*M22**2-87*M22**3-26*M22**2*M32-27*M22*M32**2-60*M32**3)+
     &  M12**2*M14*(M22-M32)**2*(12*a0t3*M22**2-31*M22**3-12*M22**2*
     &  M32+9*M22*M32**2-14*M32**3)+2*M12**3*(12*a0t3*M14*M22**2*(-M22+
     &  M32)+(M22-M32)**4*(4*M22**2+M22*M32+M32**2)+2*M14*(17*M22**4-
     &  10*M22**3*M32+9*M22**2*M32**2-10*M22*M32**3+10*M32**4))))/(12.*
     &  alambda**3*M12**3*M14)
       coef(3)=(M14*(-((M12-M22)**2*(a0t2*(M12**3-4*M12**2*M22-2*M22**
     &  3+M12*M22*(6*a0t3+5*M22))+(M12-M22)*((4*M12-3*M22)*(M12-M22)**
     &  2+a0t3*(M12**2-5*M12*M22-2*M22**2))))+(M12-M22)*(M12**2*(-6*
     &  a0t2*a0t3+8*a0t2*M12+6*a0t3*M12+23*M12**2)-M12*(2*a0t2*(3*a0t3+
     &  M12)+M12*(4*a0t3+43*M12))*M22+M12*(-4*(a0t2+a0t3-3*(aet1+aet2+
     &  aet3+ak0t0))+11*M12)*M22**2+(10*a0t2-10*a0t3+51*M12)*M22**3-18*
     &  M22**4)*M32+(-(M12**2*(4*a0t2*(-3*a0t3+4*M12)+M12*(14*a0t3+55*
     &  M12)))+2*M12*(3*a0t2*a0t3+M12*(-a0t3+6*(aet1+aet2+aet3+ak0t0)+
     &  27*M12))*M22+4*M12*(6*(aet1+aet2+aet3+ak0t0)+17*M12)*M22**2+10*
     &  (2*a0t2-2*a0t3+5*M12)*M22**3-45*M22**4)*M32**2+2*(M12*(-3*a0t2*
     &  a0t3+5*a0t2*M12+8*a0t3*M12+35*M12**2)+M12*(-3*a0t2+7*a0t3-6*
     &  (aet1+aet2+aet3+ak0t0)+20*M12)*M22+5*(-2*a0t2+2*a0t3+5*M12)*
     &  M22**2+30*M22**3)*M32**3+((a0t2-9*a0t3-50*M12)*M12+(10*a0t2-10*
     &  a0t3-69*M12)*M22-45*M22**2)*M32**4+(-2*a0t2+2*a0t3+19*M12+18*
     &  M22)*M32**5-3*M32**6)+a0t1*(4*M12**5*M14-23*M12**4*M14*(M22+
     &  M32)+2*M12**2*M14*(M22+M32)*(3*a0t3*M22-33*M22**2+28*M22*M32+3*
     &  (a0t2-11*M32)*M32)+2*M12**3*M14*(27*M22**2+28*M22*M32+27*M32**
     &  2)+3*M14*(M22-M32)**3*(2*a0t3*M22-5*M22**2+M32*(-2*a0t2+5*M32))
     &  +2*M12*(M22-M32)*(-6*a0t3*M14*M22**2+(M22-M32)**5+2*M14*(11*
     &  M22**3-3*M22**2*M32+3*(a0t2+M22)*M32**2-11*M32**3))))/(6.*
     &  alambda**3*M12*M14)
       coef(4)=(2*a0t2*M14*(-alambda**3+(M12-M22)**2*(3*a0t1*(M12-M22)*
     &  *3+(M12-M22)**2*(M12**2-M12*M22+M22**2)-3*a0t3*M12*(M12**2-2*
     &  M12*M22+3*M22**2))-2*(M12-M22)*(3*M12**3*(2*a0t1-2*a0t3+M12)+(-
     &  3*a0t1+3*a0t3-7*M12)*M12**2*M22+15*(-a0t1+a0t3)*M12*M22**2+(6*
     &  a0t1+M12)*M22**3-3*M22**4)*M32+(3*M12**3*(6*a0t1-6*a0t3+5*M12)-
     &  6*M12**2*(-3*a0t1+2*(a0t3+M12))*M22-2*M12*(-21*a0t1+18*a0t3+
     &  M12)*M22**2+6*(-3*a0t1+2*M12)*M22**3+15*M22**4)*M32**2-2*(2*
     &  M12**2*(3*a0t1-3*a0t3+5*M12)+M12*(9*a0t1-9*a0t3+11*M12)*M22+(-
     &  6*a0t1+17*M12)*M22**2+10*M22**3)*M32**3+(-3*(a0t3-5*M12)*M12+3*
     &  a0t1*(M12-M22)+25*M12*M22+15*M22**2)*M32**4-6*(M12+M22)*M32**5+
     &  M32**6)+M14*(4*a0t3*M12**6+6*aet2*M12**6+6*aet3*M12**6+6*ak0t0*
     &  M12**6-M12**7+3*alambda**3*M22-26*a0t3*M12**5*M22+6*aet1*M12**
     &  5*M22-30*aet2*M12**5*M22-30*aet3*M12**5*M22-30*ak0t0*M12**5*
     &  M22+13*M12**6*M22+76*a0t3*M12**4*M22**2-30*aet1*M12**4*M22**2+
     &  60*aet2*M12**4*M22**2+60*aet3*M12**4*M22**2+60*ak0t0*M12**4*
     &  M22**2-47*M12**5*M22**2-112*a0t3*M12**3*M22**3+60*aet1*M12**3*
     &  M22**3-60*aet2*M12**3*M22**3-60*aet3*M12**3*M22**3-60*ak0t0*
     &  M12**3*M22**3+75*M12**4*M22**3+80*a0t3*M12**2*M22**4-60*aet1*
     &  M12**2*M22**4+30*aet2*M12**2*M22**4+30*aet3*M12**2*M22**4+30*
     &  ak0t0*M12**2*M22**4-55*M12**3*M22**4-22*a0t3*M12*M22**5+30*
     &  aet1*M12*M22**5-6*aet2*M12*M22**5-6*aet3*M12*M22**5-6*ak0t0*
     &  M12*M22**5+11*M12**2*M22**5-6*aet1*M22**6+7*M12*M22**6-3*M22**
     &  7+2*(M12-M22)*(-(M12**4*(10*a0t3-3*(aet1-5*(aet2+aet3+ak0t0)+3*
     &  M12)))+(26*a0t3+3*(-7*aet1+5*(aet2+aet3+ak0t0)-14*M12))*M12**3*
     &  M22+M12**2*(8*a0t3+15*(aet1+aet2+aet3+ak0t0)+29*M12)*M22**2-
     &  (36*a0t3-33*aet1+3*(aet2+aet3+ak0t0)-35*M12)*M12*M22**3+2*(-9*
     &  aet1+M12)*M22**4-9*M22**5)*M32+(5*(8*a0t3+3*(-2*aet1+4*(aet2+
     &  aet3+ak0t0)-5*M12))*M12**4+M12**3*(-60*a0t3+72*aet1+155*M12)*
     &  M22+2*M12**2*(-10*a0t3+18*(2*aet1+aet2+aet3+ak0t0)+55*M12)*M22*
     &  *2+2*M12*(-40*a0t3+12*(4*aet1+aet2+aet3+ak0t0)+57*M12)*M22**3-
     &  (90*aet1+19*M12)*M22**4-45*M22**5)*M32**2-4*(5*(2*a0t3-3*aet1+
     &  3*(aet2+aet3+ak0t0)-7*M12)*M12**3+(-2*a0t3-3*aet1+15*(aet2+
     &  aet3+ak0t0)-5*M12)*M12**2*M22+(-7*a0t3+2*(-3*aet1+6*(aet2+aet3+
     &  ak0t0)-5*M12))*M12*M22**2-3*(10*aet1+11*M12)*M22**3-15*M22**4)*
     &  M32**3+(5*(4*a0t3-12*aet1+6*(aet2+aet3+ak0t0)-27*M12)*M12**2+3*
     &  (2*a0t3-26*aet1+10*(aet2+aet3+ak0t0)-55*M12)*M12*M22-(90*aet1+
     &  167*M12)*M22**2-45*M22**3)*M32**4+2*(-2*a0t3*M12-3*(aet2+aet3+
     &  ak0t0-11*M12)*M12+41*M12*M22+9*M22**2+3*aet1*(5*M12+6*M22))*
     &  M32**5-(6*aet1+13*M12+3*M22)*M32**6)+2*a0t1*(11*M12**6*M14-M12*
     &  *5*M14*(59*M22+62*M32)-M14*(M22-M32)**4*(2*M22**2+17*M22*M32-7*
     &  M32**2)+M12**4*M14*(128*M22**2+151*M22*M32+145*M32**2)-M12**3*
     &  M14*(141*M22**3+58*M22**2*M32+57*M22*M32**2+180*M32**3)+M12**2*
     &  M14*(79*M22**4-98*M22**3*M32-24*M22**2*M32**2-146*M22*M32**3+
     &  125*M32**4)+3*a0t3*M14*(M12**5+(M22-M32)**4*(2*M22-M32)-M12**4*
     &  (4*M22+5*M32)-2*M12**2*(M22-M32)*(M22**2-2*M22*M32-5*M32**2)-
     &  M12*(M22-M32)**2*(3*M22**2+4*M22*M32-5*M32**2)+2*M12**3*(3*M22*
     &  *2+3*M22*M32+5*M32**2))+M12*(-(alambda**3*M22)+(M22-M32)**2*
     &  (M22*(M22-M32)**4+M14*(-17*M22**3+48*M22**2*M32+63*M22*M32**2-
     &  46*M32**3)))))/(12.*alambda**3*M12*M14)
       coef(5)=-(a0t3*M12**2*(M14*(M12-M22)**2*(M12**3+6*(a0t2-M12)*
     &  M12*M22+3*(-2*a0t1+M12)*M22**2+2*M22**3)-M12*(6*M12**3*M14+3*
     &  (4*a0t2-9*M12)*M12*M14*M22+2*(-6*a0t2+13*M12)*M14*M22**2-6*M14*
     &  M22**3+M22**5)*M32+(15*M12**3*M14-28*M12**2*M14*M22+6*M14*
     &  (a0t1-M22)*M22**2+M12*M22*(6*a0t2*M14+2*M14*M22+5*M22**3))*M32*
     &  *2-2*(10*M12**2*M14-M12*M14*M22+M14*M22**2+5*M12*M22**3)*M32**
     &  3+(12*M14*M22+5*M12*(3*M14+2*M22**2))*M32**4-(6*M14+5*M12*M22)*
     &  M32**5+M12*M32**6)+a0t1*(M14*(M22-M32)**6*(M22+M32)+M12**6*M14*
     &  (2*M22+M32)-2*M12**5*M14*(M22+M32)*(5*M22+3*M32)+M12**4*M14*
     &  (21*M22**3+M22*(-6*a0t2+37*M22)*M32+39*M22*M32**2+15*M32**3)+
     &  M12**2*M14*(M22-M32)*(16*M22**4+27*M22**3*M32+3*M22**2*(2*a0t2-
     &  3*M32)*M32+M22*(6*a0t2-19*M32)*M32**2-15*M32**4)-2*M12**3*(3*
     &  (M22-M32)**4*(M22+M32)**2+2*M14*(6*M22**4+10*M22**3*M32+M22*(-
     &  3*a0t2+8*M22)*M32**2+9*M22*M32**3+5*M32**4)))+M12**2*M22*(M14*
     &  (M12-M22-M32)*(M12**4+(M22-M32)**4-4*M12**3*(M22+M32)+M12**2*
     &  (6*M22**2-8*M22*M32+6*M32**2)-4*M12*(M22**3+M22*(3*(aet1+aet2+
     &  aet3+ak0t0)+2*M22)*M32+2*M22*M32**2+M32**3))+a0t2*(-2*M12**4*
     &  M14+M12**3*M14*(9*M22+M32)-2*M14*(M22-M32)**3*(3*M22+4*M32)-2*
     &  M12**2*M14*(8*M22**2+7*M22*M32-5*M32**2)+M12*((M22-M32)**5+2*
     &  M14*(7*M22**3+4*M22**2*M32+9*M22*M32**2-8*M32**3)))))/(6.*
     &  alambda**3*M12**3*M14)
       coef(6)=(a0t1*(2*M12**5*M14*(2*M22+M32)-M12**4*M14*(M22+M32)*
     &  (23*M22+12*M32)-3*M14*(M22-M32)**3*(5*M22**3+2*M22*(a0t2+2*M22)
     &  *M32-5*M22*M32**2-4*M32**3)+2*M12**3*M14*(27*M22**3+43*M22**2*
     &  M32+45*M22*M32**2+15*M32**3)-2*M12**2*M14*(M22+M32)*(33*M22**3-
     &  8*M22**2*M32+20*M32**3+M22*M32*(-3*a0t2+25*M32))+2*M12*(M22-
     &  M32)*((M22-M32)**5*(M22+M32)+M14*(22*M22**4+9*M22**3*M32+3*M22*
     &  (2*a0t2+3*M22)*M32**2-25*M22*M32**3-15*M32**4)))+M14*(-3*(M22-
     &  M32)**6*(M22+M32)-M12**6*(4*M22+3*M32)+M12**5*(M22+M32)*(23*
     &  M22+18*M32)-M12**4*(11*M22+9*M32)*(5*M22**2+6*M22*M32+5*M32**2)
     &  +2*M12**3*(M22+M32)*(35*M22**3+22*M22**2*M32+23*M22*M32**2+30*
     &  M32**3)+M12*(M22-M32)**2*(19*M22**4-13*M22**3*M32+M22**2*(-12*
     &  (aet1+aet2+aet3+ak0t0)-49*M32)*M32+M22*M32**3+18*M32**4)+M12**
     &  2*(-50*M22**5-5*M22**4*M32-14*M22*M32**4-45*M32**5+4*M22**3*
     &  M32*(3*(aet1+aet2+aet3+ak0t0)+26*M32)+2*M22**2*M32**2*(6*(aet1+
     &  aet2+aet3+ak0t0)+29*M32))+a0t2*M22*(-M12**5+2*(M22-M32)**5+M12*
     &  *4*(6*M22+8*M32)-2*M12**3*(7*M22**2+5*M22*M32+8*M32**2)+2*M12**
     &  2*(8*M22**3-M22**2*M32+5*M32**3)+M12*(-9*M22**4+14*M22**3*M32-
     &  6*M22*M32**3+M32**4)))+a0t3*M14*(2*M12**6-M12**5*(13*M22+12*
     &  M32)-2*(M22-M32)**3*(-3*a0t1*M22**2+(M22-M32)**2*M32)+M12**4*
     &  (38*M22**2+42*M22*M32+30*M32**2)+2*M12**2*(M22**3*(3*a0t1+6*
     &  a0t2+20*M22)+3*(a0t1-4*M22)*M22**2*M32+(6*a0t2-7*M22)*M22*M32**
     &  2-4*M22*M32**3+15*M32**4)-2*M12**3*(28*M22**3+17*M22**2*M32+19*
     &  M22*M32**2+20*M32**3+3*a0t2*M22*(M22+M32))-M12*(M22-M32)*(12*
     &  a0t1*M22**3+(M22-M32)*(11*M22**3-8*M22**2*M32-3*M22*M32**2+12*
     &  M32**3+6*a0t2*M22*(M22+M32)))))/(6.*alambda**3*M12*M14)
       coef(7)=(2*a0t3*M12**6+6*aet2*M12**6+6*aet3*M12**6+6*ak0t0*M12**
     &  6-M12**7-13*a0t3*M12**5*M22+6*aet1*M12**5*M22-30*aet2*M12**5*
     &  M22-30*aet3*M12**5*M22-30*ak0t0*M12**5*M22+17*M12**6*M22+38*
     &  a0t3*M12**4*M22**2-30*aet1*M12**4*M22**2+60*aet2*M12**4*M22**2+
     &  60*aet3*M12**4*M22**2+60*ak0t0*M12**4*M22**2-70*M12**5*M22**2-
     &  56*a0t3*M12**3*M22**3+60*aet1*M12**3*M22**3-60*aet2*M12**3*M22*
     &  *3-60*aet3*M12**3*M22**3-60*ak0t0*M12**3*M22**3+130*M12**4*M22*
     &  *3+40*a0t3*M12**2*M22**4-60*aet1*M12**2*M22**4+30*aet2*M12**2*
     &  M22**4+30*aet3*M12**2*M22**4+30*ak0t0*M12**2*M22**4-125*M12**3*
     &  M22**4-11*a0t3*M12*M22**5+30*aet1*M12*M22**5-6*aet2*M12*M22**5-
     &  6*aet3*M12*M22**5-6*ak0t0*M12*M22**5+61*M12**2*M22**5-6*aet1*
     &  M22**6-12*M12*M22**6+(M12-M22)*(-((9*a0t3-6*aet1+30*(aet2+aet3+
     &  ak0t0)-17*M12)*M12**4)+(29*a0t3-42*aet1+30*(aet2+aet3+ak0t0)-
     &  103*M12)*M12**3*M22+M12**2*(11*a0t3+30*(aet1+aet2+aet3+ak0t0)+
     &  95*M12)*M22**2-M12*(43*a0t3-9*(6*aet1-2*(aet2+aet3+ak0t0)+7*
     &  M12))*M22**3-12*(3*aet1+4*M12)*M22**4)*M32+2*(M12**4*(8*a0t3-5*
     &  (3*aet1-6*(aet2+aet3+ak0t0)+7*M12))+M12**3*(-16*a0t3+36*aet1+
     &  99*M12)*M22+M12**2*(-3*a0t3+18*(2*aet1+aet2+aet3+ak0t0)+37*M12)
     &  *M22**2+M12*(-31*a0t3+30*aet1-6*(aet2+aet3+ak0t0)+25*M12)*M22**
     &  3-3*(15*aet1+14*M12)*M22**4)*M32**2-2*((7*a0t3+5*(-6*aet1+6*
     &  (aet2+aet3+ak0t0)-13*M12))*M12**3+M12**2*(-7*a0t3+4*(-3*aet1+6*
     &  (aet2+aet3+ak0t0)+4*M12))*M22+(-19*a0t3-30*aet1+6*(aet2+aet3+
     &  ak0t0)-25*M12)*M12*M22**2-12*(5*aet1+4*M12)*M22**3)*M32**3+((6*
     &  (a0t3+5*(-2*aet1+aet2+aet3+ak0t0))-125*M12)*M12**2+(-7*a0t3+3*
     &  (-30*aet1+6*(aet2+aet3+ak0t0)-37*M12))*M12*M22-6*(15*aet1+14*
     &  M12)*M22**2)*M32**4+(-((a0t3-30*aet1+6*(aet2+aet3+ak0t0)-61*
     &  M12)*M12)+12*(3*aet1+4*M12)*M22)*M32**5-6*(aet1+2*M12)*M32**6+
     &  a0t1*((M12-M22)**2*(6*a0t2*(M12-M22)**3+(M12-M22)**2*(22*M12**
     &  2-34*M12*M22+11*M22**2)+6*a0t3*(M12**3-2*M12**2*M22+M12*M22**2+
     &  M22**3))-2*(M12-M22)*(M12**3*(12*a0t2+15*a0t3+61*M12)-3*M12**2*
     &  (2*a0t2+a0t3+32*M12)*M22-M12*(27*a0t2+21*a0t3+22*M12)*M22**2+3*
     &  (5*a0t2-5*a0t3+28*M12)*M22**3-33*M22**4)*M32+(3*M12**3*(12*
     &  a0t2+20*a0t3+93*M12)+2*(18*a0t2+21*a0t3-74*M12)*M12**2*M22+24*
     &  (3*(a0t2+a0t3)-M12)*M12*M22**2-12*(5*a0t2-5*a0t3+13*M12)*M22**
     &  3+165*M22**4)*M32**2-2*(3*M12**2*(3*a0t2+10*a0t3+56*M12)+2*M12*
     &  (3*a0t2+21*a0t3+53*M12)*M22+6*(-5*a0t2+5*a0t3+13*M12)*M22**2+
     &  110*M22**3)*M32**3+(224*M12**2+234*M12*M22+165*M22**2+30*a0t3*
     &  (M12+M22)-6*a0t2*(M12+5*M22))*M32**4-6*(-a0t2+a0t3+13*M12+11*
     &  M22)*M32**5+11*M32**6)+a0t2*M12*(2*M12**5-(M22-M32)**4*(M22+11*
     &  M32)-M12**4*(9*M22+13*M32)+2*M12**3*(8*M22**2+19*M22*M32+19*
     &  M32**2)+2*M12*(M22-M32)**2*(3*M22**2+13*M22*M32+20*M32**2)-2*
     &  M12**2*(7*M22**3+16*M22**2*M32+9*M22*M32**2+28*M32**3)+6*a0t3*
     &  (-M12**4-2*(M22-M32)**4+4*M12**3*(M22+M32)+6*M12*(M22-M32)**2*
     &  (M22+M32)-M12**2*(7*M22**2+6*M22*M32+7*M32**2))))/(6.*alambda**
     &  3*M12)

             else
             
        If(abs(M12-M22) .eq.0D0 ) then
          if (m32.eq.0D0) then
       coef(1)=(-4*a0t1+M12)/(12.*M12**3)
       coef(2)=-5/(12.*M12)+a0t1/(3.*M14)
       coef(3)=-11/(12.*M12)+(2*a0t1)/(3.*M14)
       coef(4)=(8*a0t1-3*aet1-7*M12)/(6.*M12)-a0t1**2/(4.*M14)
       coef(5)=(-4*a0t1+M12)/(12.*M14)
       coef(6)=-0.9166666666666666D0+(2*a0t1)/(3.*M12)
       coef(7)=(-23+(4*(8*a0t1-3*aet1))/M12-(6*a0t1**2)/M14)/12.                 
          elseif(abs(M12-M32) .eq.0D0 ) then
       coef(1)=(6*a0t1**2-6*a0t1*M12+M12*(12*aet1+4*ak0t0+9*M12))/(54.*M12**2)
       coef(2)=-(6*a0t1**2-6*a0t1*M12+M12*(12*aet1+4*ak0t0+27*M12))/(54.*M12**3)
       coef(3)=-(6*a0t1**2-6*a0t1*M12+M12*(12*aet1+4*ak0t0+27*M12))/(27.*M12**3)
       coef(4)=-(30*a0t1**2-138*a0t1*M12+M12*(60*aet1+2*ak0t0+63*M12))
     &  /(108.*M14)
       coef(5)=(6*a0t1**2-24*a0t1*M12+M12*(12*aet1+4*ak0t0+9*M12))/(54.*M12**3)
       coef(6)=-(12*a0t1**2-48*a0t1*M12+M12*(24*aet1+8*ak0t0+81*M12))/(54.*M14)
       coef(7)=-(30*a0t1**2-138*a0t1*M12+M12*(60*aet1+2*ak0t0+63*M12))
     &  /(54.*M14)         
          else
       coef(1)=(12*M12**3*(a0t1**2+a0t1*(a0t3+2*M12)+M12*(-a0t3+2*aet1+
     &  aet3+ak0t0+2*M12))-2*M12**2*(3*a0t1**2+52*a0t1*M12+M12*(-17*
     &  a0t3+2*M12))*M32+M12**2*(62*a0t1-11*a0t3+8*M12)*M32**2+(-13*
     &  a0t1+a0t3-M12)*M12*M32**3+a0t1*M32**4)/(6.*M12**3*(4*M12-M32)**
     &  3*M32)
       coef(2)=-(12*M12**3*(a0t1**2+a0t1*(a0t3+2*M12)+M12*(-a0t3+2*
     &  aet1+aet3+ak0t0+2*M12))+2*M12**2*(-3*a0t1**2-52*a0t1*M12+M12*
     &  (17*a0t3+62*M12))*M32+M12**2*(62*a0t1-11*(a0t3+8*M12))*M32**2+
     &  M12*(-13*a0t1+a0t3+23*M12)*M32**3+(a0t1-2*M12)*M32**4)/(6.*M14*
     &  (4*M12-M32)**3*M32)
       coef(3)=(-36*M12**3*(a0t1**2+a0t1*(a0t3+2*M12)+M12*(-a0t3+2*
     &  aet1+aet3+ak0t0+2*M12))+2*M12**2*(15*a0t1**2+(-25*a0t3+6*(2*
     &  aet1+aet3+ak0t0)-110*M12)*M12+2*a0t1*(3*a0t3+52*M12))*M32+M12*
     &  (-6*a0t1**2-130*a0t1*M12+M12*(19*a0t3+164*M12))*M32**2+(29*
     &  a0t1-2*a0t3-37*M12)*M12*M32**3+(-2*a0t1+3*M12)*M32**4)/(6.*M14*
     &  (4*M12-M32)**3*M32)
       coef(4)=(-120*M12**3*(a0t1**2+a0t1*(a0t3+2*M12)+M12*(-a0t3+2*
     &  aet1+aet3+ak0t0+2*M12))+4*M12**2*(9*a0t1**2+(a0t3-12*aet1+42*
     &  (aet3+ak0t0)-50*M12)*M12+14*a0t1*(3*a0t3+20*M12))*M32-2*M12*
     &  ((13*a0t3-84*aet1+30*(aet3+ak0t0)-184*M12)*M12+a0t1*(30*a0t3+
     &  362*M12))*M32**2+2*((2*a0t3-30*aet1+3*(aet3+ak0t0)-65*M12)*M12+
     &  a0t1*(3*a0t3+85*M12))*M32**3+(-14*a0t1+6*aet1+13*M12)*M32**4)
     &  /(12.*M12*(4*M12-M32)**3*M32)
       coef(5)=(12*M12**4*(a0t1**2+a0t1*(a0t3+2*M12)+M12*(-a0t3+2*aet1+
     &  aet3+ak0t0+2*M12))-2*M12**3*(3*a0t1**2+52*a0t1*M12+M12*(15*
     &  a0t3+2*M12))*M32+M12**3*(-2*a0t1+37*a0t3+8*M12)*M32**2-M12**2*
     &  (-35*a0t1+11*a0t3+M12)*M32**3+(-11*a0t1+a0t3)*M12*M32**4+a0t1*
     &  M32**5)/(6.*M12**3*(4*M12-M32)**3*M32)
       coef(6)=(-36*M12**4*(a0t1**2+a0t1*(a0t3+2*M12)+M12*(-a0t3+2*
     &  aet1+aet3+ak0t0+2*M12))+2*M12**3*(15*a0t1**2+(39*a0t3+6*(2*
     &  aet1+aet3+ak0t0)-110*M12)*M12+2*a0t1*(3*a0t3+52*M12))*M32-M12**
     &  2*(6*a0t1**2+2*a0t1*M12+7*M12*(11*a0t3+4*M12))*M32**2+M12**2*(-
     &  67*a0t1+22*a0t3+107*M12)*M32**3+(22*a0t1-2*a0t3-33*M12)*M12*
     &  M32**4+(-2*a0t1+3*M12)*M32**5)/(6.*M14*(4*M12-M32)**3*M32)
       coef(7)=(-84*M12**3*(a0t1**2+a0t1*(a0t3+2*M12)+M12*(-a0t3+2*
     &  aet1+aet3+ak0t0+2*M12))-2*M12**2*(15*a0t1**2+M12*(19*a0t3+72*
     &  aet1-60*(aet3+ak0t0)+122*M12)-4*a0t1*(15*a0t3+137*M12))*M32+
     &  M12*(36*a0t1**2-2*a0t1*(24*a0t3+353*M12)+M12*(a0t3+16*(12*aet1-
     &  3*(aet3+ak0t0)+20*M12)))*M32**2+(6*a0t1*(-a0t1+a0t3)+(155*a0t1+
     &  a0t3+6*(-10*aet1+aet3+ak0t0))*M12-109*M12**2)*M32**3+(-11*a0t1+
     &  6*(aet1+2*M12))*M32**4)/(6.*M12*(4*M12-M32)**3*M32)                    
          endif
        elseif(abs(M12-M32) .eq.0D0 ) then
             if(M22.eq.0D0) then
       coef(1)=(-4*a0t1+M12)/(12.*M12**3)
       coef(2)=-1/(2.*M12)+a0t1/(3.*M14)
       coef(3)=-11/(12.*M12)+(2*a0t1)/(3.*M14)
       coef(4)=(-9+(16*a0t1-6*aet1)/M12-(3*a0t1**2)/M14)/12.
       coef(5)=-a0t1/(3.*M14)
       coef(6)=-0.5+(2*a0t1)/(3.*M12)
       coef(7)=(-23+(4*(8*a0t1-3*aet1))/M12-(6*a0t1**2)/M14)/12.
            else
       coef(1)=(12*M12**3*(a0t1**2+a0t1*(a0t2+2*M12)+M12*(-a0t2+2*aet1+
     &  aet2+ak0t0+2*M12))-2*M12**2*(3*a0t1**2+52*a0t1*M12+M12*(-17*
     &  a0t2+2*M12))*M22+M12**2*(62*a0t1-11*a0t2+8*M12)*M22**2+(-13*
     &  a0t1+a0t2-M12)*M12*M22**3+a0t1*M22**4)/(6.*M12**3*(4*M12-M22)**
     &  3*M22)
       coef(2)=(-24*M12**3*(a0t1**2+a0t1*(a0t2+2*M12)+M12*(-a0t2+2*
     &  aet1+aet2+ak0t0+2*M12))+4*M12**2*(6*a0t1**2+(-4*a0t2+3*(2*aet1+
     &  aet2+ak0t0-8*M12))*M12+a0t1*(3*a0t2+26*M12))*M22+2*M12*(-3*
     &  a0t1**2-34*a0t1*M12+4*a0t2*M12+38*M12**2)*M22**2+(16*a0t1-a0t2-
     &  14*M12)*M12*M22**3+(-a0t1+M12)*M22**4)/(6.*M14*(4*M12-M22)**3*
     &  M22)
       coef(3)=(-36*M12**3*(a0t1**2+a0t1*(a0t2+2*M12)+M12*(-a0t2+2*
     &  aet1+aet2+ak0t0+2*M12))+2*M12**2*(15*a0t1**2+(-25*a0t2+6*(2*
     &  aet1+aet2+ak0t0)-110*M12)*M12+2*a0t1*(3*a0t2+52*M12))*M22+M12*
     &  (-6*a0t1**2-130*a0t1*M12+M12*(19*a0t2+164*M12))*M22**2+(29*
     &  a0t1-2*a0t2-37*M12)*M12*M22**3+(-2*a0t1+3*M12)*M22**4)/(6.*M14*
     &  (4*M12-M22)**3*M22)
       coef(4)=(-48*M12**3*(a0t1**2+a0t1*(a0t2+2*M12)+M12*(-a0t2+2*
     &  aet1+aet2+ak0t0+2*M12))-8*M12**2*(12*a0t1**2+(10*a0t2+30*aet1-
     &  9*(aet2+ak0t0-4*M12))*M12-a0t1*(9*a0t2+134*M12))*M22+4*M12*(18*
     &  a0t1**2+M12*(7*a0t2+54*aet1-9*(aet2+ak0t0)+68*M12)-a0t1*(9*
     &  a0t2+172*M12))*M22**2-2*(6*a0t1**2+M12*(a0t2+30*aet1-3*(aet2+
     &  ak0t0)+44*M12)-a0t1*(3*a0t2+70*M12))*M22**3+(-8*a0t1+6*aet1+11*
     &  M12)*M22**4)/(12.*M12*(4*M12-M22)**3*M22)
       coef(5)=(4*M12**3*(3*a0t1*(a0t1+a0t2)+(-26*a0t1+3*(-a0t2+2*aet1+
     &  aet2+ak0t0))*M12+6*M12**2)-2*M12**2*(3*a0t1**2+4*a0t1*M12+M12*
     &  (-17*a0t2+2*M12))*M22+M12**2*(38*a0t1-11*a0t2+8*M12)*M22**2+(-
     &  11*a0t1+a0t2-M12)*M12*M22**3+a0t1*M22**4)/(6.*M12**3*(4*M12-
     &  M22)**3)
       coef(6)=(-4*M12**3*(9*a0t1*(a0t1+a0t2)+(-46*a0t1+9*(-a0t2+2*
     &  aet1+aet2+ak0t0))*M12+66*M12**2)+2*M12**2*(15*a0t1**2+(-25*
     &  a0t2+6*(2*aet1+aet2+ak0t0)-38*M12)*M12+a0t1*(6*a0t2+8*M12))*
     &  M22+M12*(-6*a0t1**2-82*a0t1*M12+M12*(19*a0t2+128*M12))*M22**2+
     &  M12*(25*a0t1-2*(a0t2+17*M12))*M22**3+(-2*a0t1+3*M12)*M22**4)
     &  /(6.*M14*(4*M12-M22)**3)
       coef(7)=(-84*M12**3*(a0t1**2+a0t1*(a0t2+2*M12)+M12*(-a0t2+2*
     &  aet1+aet2+ak0t0+2*M12))-2*M12**2*(15*a0t1**2+M12*(19*a0t2+72*
     &  aet1-60*(aet2+ak0t0)+122*M12)-4*a0t1*(15*a0t2+137*M12))*M22+
     &  M12*(36*a0t1**2-2*a0t1*(24*a0t2+353*M12)+M12*(a0t2+16*(12*aet1-
     &  3*(aet2+ak0t0)+20*M12)))*M22**2+(6*a0t1*(-a0t1+a0t2)+(155*a0t1+
     &  a0t2+6*(-10*aet1+aet2+ak0t0))*M12-109*M12**2)*M22**3+(-11*a0t1+
     &  6*(aet1+2*M12))*M22**4)/(6.*M12*(4*M12-M22)**3*M22)
     
          endif 
        elseif(abs(M22-M32) .eq.0D0 ) then  
             if(M12.eq.0D0) then        
       coef(1)=a0t2/(30.*M22**3)-31/(900.*M22**2)
       coef(2)=(6*a0t2-11*M22)/(36.*M22**2)
       coef(3)=(6*a0t2-11*M22)/(18.*M22**2)
       coef(4)=(a0t2**2-6*a0t2*M22+2*M22*(aet2+3*M22))/(4.*M22**2)
       coef(5)=(30*a0t2-31*M22)/(900.*M22**2)
       coef(6)=-0.6111111111111112D0+a0t2/(3.*M22)
       coef(7)=3+(a0t2**2-6*a0t2*M22+2*aet2*M22)/(2.*M22**2)        
             else
       coef(1)=-(6*a0t2**2*(M12-2*M22)**2+2*a0t1*(M12**3-10*M12**2*M22+
     &  32*M12*M22**2-44*M22**3)+(M12-2*M22)*(M12**3-8*M12**2*M22+4*
     &  M12*M22**2-12*M22**2*(aet1+2*aet2+ak0t0+2*M22))-4*a0t2*(M12**3-
     &  5*M12**2*M22-6*M22**2*(a0t1+2*M22)+M12*M22*(3*a0t1+10*M22)))
     &  /(6.*M12**3*(M12-4*M22)**3)
       coef(2)=((2*a0t1-a0t2-2*M12)*M12**3+M12*(-6*a0t2**2+14*a0t2*M12+
     &  23*M12*(-a0t1+M12))*M22+2*(6*a0t2*(a0t1+a0t2)+(41*a0t1-20*a0t2)
     &  *M12-44*M12**2)*M22**2+4*(-19*a0t1+6*a0t2+3*(aet1+2*aet2+ak0t0)
     &  +31*M12)*M22**3+24*M22**4)/(6.*M14*(M12-4*M22)**3)
       coef(3)=((2*a0t1-a0t2-2*M12)*M12**3+M12*(-6*a0t2**2+14*a0t2*M12+
     &  23*M12*(-a0t1+M12))*M22+2*(6*a0t2*(a0t1+a0t2)+(41*a0t1-20*a0t2)
     &  *M12-44*M12**2)*M22**2+4*(-19*a0t1+6*a0t2+3*(aet1+2*aet2+ak0t0)
     &  +31*M12)*M22**3+24*M22**4)/(3.*M14*(M12-4*M22)**3)
       coef(4)=(M12**2*(6*(2*a0t1-a0t2)*a0t2+2*(11*a0t1+2*a0t2+6*aet2+
     &  3*ak0t0)*M12-M12**2)-2*M12*(6*(9*a0t1-4*a0t2)*a0t2+2*(61*a0t1+
     &  11*a0t2-3*aet1+30*aet2+15*ak0t0)*M12-17*M12**2)*M22+4*(6*(11*
     &  a0t1-5*a0t2)*a0t2+(218*a0t1+46*a0t2-27*aet1+90*aet2+45*ak0t0)*
     &  M12-65*M12**2)*M22**2-8*(121*a0t1+30*a0t2-33*aet1+30*aet2+15*
     &  ak0t0-82*M12)*M22**3-240*M22**4)/(12.*M12*(M12-4*M22)**3)
       coef(5)=-(6*a0t2**2*(M12-2*M22)**2*M22+a0t2*(M12-2*M22)*(M12**3-
     &  14*M12**2*M22+40*M12*M22**2-12*M22**2*(a0t1+2*M22))+M22*(a0t1*
     &  (3*M12**3-32*M12**2*M22+112*M12*M22**2-152*M22**3)+(M12-2*M22)*
     &  (M12**3-8*M12**2*M22+4*M12*M22**2-12*M22**2*(aet1+2*aet2+ak0t0+
     &  2*M22))))/(6.*M12**3*(M12-4*M22)**3)
       coef(6)=(2*a0t2*M12**4+(6*a0t1-26*a0t2-7*M12)*M12**3*M22+2*M12*
     &  (-6*a0t2**2+62*a0t2*M12+M12*(-35*a0t1+41*M12))*M22**2+4*(6*
     &  a0t2*(a0t1+a0t2)+13*(5*a0t1-4*a0t2)*M12-80*M12**2)*M22**3+8*(-
     &  35*a0t1+6*a0t2+3*(aet1+2*aet2+ak0t0)+55*M12)*M22**4+48*M22**5)
     &  /(6.*M14*(M12-4*M22)**3)
       coef(7)=(M12**2*(6*(2*a0t1-a0t2)*a0t2+2*(11*a0t1+2*a0t2+6*aet2+
     &  3*ak0t0)*M12-M12**2)-2*M12*(6*(9*a0t1-4*a0t2)*a0t2+2*(61*a0t1+
     &  11*a0t2-3*aet1+30*aet2+15*ak0t0)*M12-17*M12**2)*M22+4*(6*(11*
     &  a0t1-5*a0t2)*a0t2+(218*a0t1+46*a0t2-27*aet1+90*aet2+45*ak0t0)*
     &  M12-65*M12**2)*M22**2-8*(121*a0t1+30*a0t2-33*aet1+30*aet2+15*
     &  ak0t0-82*M12)*M22**3-240*M22**4)/(6.*M12*(M12-4*M22)**3)             
             endif
        else                     
        print*, "not encounter this case, FD411C", Sqrt(M12), Sqrt(M22), Sqrt(M32)    
        endif
        endif 
      end      


